Package: mspms
Type: Package
Title: Tools for the analysis of MSP-MS data
Version: 1.4.0
Authors@R: person("Charlie", "Bayne", email = "baynec2@gmail.com",
    role = c("aut", "cre"),comment=c(ORCID="0000-0003-1870-5298"))
Description: This package provides functions for the analysis of data generated 
    by the multiplex substrate profiling by mass spectrometry for proteases 
    (MSP-MS) method. Data exported from upstream proteomics software is accepted 
    as input and subsequently processed for analysis. 
    Tools for statistical analysis, visualization, and interpretation of 
    the data are provided. 
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.3.3
Depends: R (>= 4.4.0)
biocViews: Proteomics, MassSpectrometry, Preprocessing
LazyData: true
Imports: QFeatures, limma, SummarizedExperiment, magrittr, rlang,
        dplyr, purrr, stats, tidyr, stringr, ggplot2, ggseqlogo,
        heatmaply, readr, rstatix, tibble, ggpubr, imputeLCMD
Suggests: knitr, testthat (>= 3.0.0), downloadthis, DT, rmarkdown,
        BiocStyle
Config/testthat/edition: 3
URL: https://github.com/baynec2/mspms
BugReports: https://github.com/baynec2/mspms/issues
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/mspms
git_branch: RELEASE_3_23
git_last_commit: e8f7cf2
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:28:15 UTC; biocbuild
Author: Charlie Bayne [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-1870-5298>)
Maintainer: Charlie Bayne <baynec2@gmail.com>

<!-- README.md is generated from README.Rmd. Please edit that file -->

<img src="man/figures/logo.png" align="right" width="170"/>

# *[mspms](https://bioconductor.org/packages/3.22/mspms)*

<!-- badges: start -->

[![R-CMD-check](https://github.com/baynec2/mspms/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/baynec2/mspms/actions/workflows/R-CMD-check.yaml)
[![Codecov test
coverage](https://codecov.io/gh/baynec2/mspms/branch/main/graph/badge.svg)](https://app.codecov.io/gh/baynec2/mspms?branch=main)
[![Bioc release
status](http://www.bioconductor.org/shields/build/release/bioc/mspms.svg)](https://bioconductor.org/checkResults/release/bioc-LATEST/mspms)
[![Bioc devel
status](http://www.bioconductor.org/shields/build/devel/bioc/mspms.svg)](https://bioconductor.org/checkResults/devel/bioc-LATEST/mspms)
[![Bioc downloads
rank](https://bioconductor.org/shields/downloads/release/mspms.svg)](http://bioconductor.org/packages/stats/bioc/mspms/)
[![Bioc
support](https://bioconductor.org/shields/posts/mspms.svg)](https://support.bioconductor.org/tag/mspms)
[![Bioc
history](https://bioconductor.org/shields/years-in-bioc/mspms.svg)](https://bioconductor.org/packages/release/bioc/html/mspms.html#since)
[![Bioc last
commit](https://bioconductor.org/shields/lastcommit/devel/bioc/mspms.svg)](http://bioconductor.org/checkResults/devel/bioc-LATEST/mspms/)
[![Bioc
dependencies](https://bioconductor.org/shields/dependencies/release/mspms.svg)](https://bioconductor.org/packages/release/bioc/html/mspms.html#since)
<!-- badges: end -->

## Introduction

The goal of *[mspms](https://bioconductor.org/packages/3.22/mspms)* is
provide a R Package that can be used to easily and reproducibly analyze
data resulting from the [Multiplex Substrate Profiling by Mass
Spectrometry (MSP-MS)
method](https://pubmed.ncbi.nlm.nih.gov/36948708/).

Additionally, we provide a [graphical user interface powered by shiny
apps](https://github.com/baynec2/mspms-shiny) that allows for a user to
utilize the method without requiring any R coding knowledge.

Multiplex Substrate Profiling by Mass Spectrometry
[(MSP-MS)](https://pubmed.ncbi.nlm.nih.gov/36948708/) is a powerful
method used to determine the substrate specificity of proteases. This
method is of interest for groups interested in the study of proteases
and their role as regulators of biological pathways, whether applied to
the study of disease states, the development of diagnostic and
prognostic tests, generation of tool compounds, or rational design of
protease targeting therapeutics. Analysis of the MS based data produced
by MSP-MS is a multi-step process involving detection and quantification
of peptides, imputation, normalization, cleavage sequence
identification, statistics, and data visualizations. This process can be
challenging, especially for scientists with limited programming
experience. To overcome these issues, we developed the mspms R package
to facilitate the analysis of MSP-MS data utilizing good software/data
analysis practices.

mspms differs from existing proteomics packages that are available in
the Bioconductor project in that it is specifically designed to analyze
MSP-MS data. This involves unique preprocessing steps and data
visualizations tailored to this specific assay.

In order to do so, mspms uses several excellent packages from the
Bioconductor project to provide a framework to easily and reproducibly
analyze MSP-MS data. These include:

- *[QFeatures](https://bioconductor.org/packages/3.22/QFeatures)*:
  management and processing of peptide quantitative features and sample
  metadata.

- *[limma](https://bioconductor.org/packages/3.22/limma)*: Powerful
  linear models and empirical Bayesian methods for omics data.

- *[MsCoreUtils](https://bioconductor.org/packages/3.22/MsCoreUtils)*:
  log2 transformation, imputation (QRILC), and normalization
  (center.median).

Some excellent non-Bioconductor packages are also utilized.

- *ggplot2*: data visualizations

- *heatmaply*: interactive heatmaps

- *rstatix*: conduct statistics

- *ggseqlogo*: iceLogo motif visualization.

- *downloadthis*: gives users the ability to download data from standard
  .html report generated by mspms::generate_report().

Lastly, *mspms* takes advantage of iceLogos ([Colaert, N. et al. Nature
Methods 6,786-787 (2009)](http://www.ncbi.nlm.nih.gov/pubmed/19876014))
to visualize over represented amino acid motifs relative to a background
set by implementing components of the Java software in R.

## Installation

You can install the development version from github.

``` r
devtools::install_github("baynec2/mspms")
```

## Quickstart

To generate a general report using your own data, run the following
code. It requires data that has been prepared for mspms data analysis by
a converter function. For more information see subsequent sections.

``` r
mspms::generate_report(
  prepared_data = mspms::peaks_prepared_data,
  outdir = "../Desktop/mspms_report"
)
```

The above command will generate a .html file containing a generic mspms
analysis.

There is much more that can be done using the mspms package- see the
following sections for more information.

## Overview

Functions in this package are logically divided into 4 broad types of
functions.

1.  Pre-processing data. These functions are focused on getting all of
    the data necessary for a mspms analysis together and in a consistent
    format.

2.  Data processing. These functions allow the user to process the
    proteomics data (imputation, normalization, etc).

3.  Statistics. These methods allow the user to perform basic statistics
    on the normalized/processed data.

4.  Data visualization. These functions allow the user to visualize the
    data.

**Note that only a subset of functions are exported to the user.**
Helper functions can be found in the
[preprocessing_helper_functions.R](https://github.com/baynec2/mspms/blob/main/R/preprocessing_helper_functions.R),
[processing_helper_functions.R](https://github.com/baynec2/mspms/blob/main/R/processing_helper_functions.R),[icelogo_helper_functions.R](https://github.com/baynec2/mspms/blob/main/R/iceLogo_helper_fuctions.R),
[statistics_helper_functions.R](https://github.com/baynec2/mspms/blob/main/R/statistics_helper_functions.R),
and
[iceLogo_helper_functions.R](https://github.com/baynec2/mspms/blob/main/R/iceLogo_helper_fuctions.R)
files.

These functions were not intended to be directly used by the user and
are not exported in an effort to make the package API cleaner and more
intuitive.

## Pre-processing data

Pre-processing data here refers to standardizing the data exported from
different software solutions for analyzing mass spectrometry-based
proteomics and adding useful information specific to the MSP-MS assay.

Specifically, the data from the file exported from the upstream software
is parsed to contain the **peptide** (detected peptide sequence,
cleavages are represented as “\_”), **library_id** (name of the peptide
in the peptide library each detected peptide maps to), and intensities
for each sample.

Information about each peptide relative to the peptide it was derived
from is then added. This includes the **cleavage_seq** (the motif the
peptide a user specified n residues up and down from the cleavage
event), **cleavage_pos** (position of the peptide library the cleavage
product was cleaved at ), **peptide_type** (whether the detected peptide
is a cleavage product of the peptide library, or a full length member of
the peptide library).

All of the information is then loaded as a QFeatures object along with
colData (metadata about each sample) where it is stored as a
SummarizedExperiment object named “peptides”.

### A note on colData

As briefly described above, the colData contains metadata describing the
samples you are trying to analyze.

**It is very important that this contains at least the following
columns: quantCols”,“group”,“condition”,and “time”.**

The quantCols field contains the name of each sample. These names must
match whatever the samples are named in the files exported from the
upstream proteomics software.

The group field contains text specifying what group each sample belongs
to. All replicate samples should have the same group name

The condition field contains the experimental conditions that vary in
your MSP-MS experiment (this depends on the experimental question, could
be type of protease, the type of inhibitor, etc)

The time field contains the duration of incubation of your protease of
interest with the peptide library for each sample.

An example of a valid colData file is shown below.

``` r
colData <- readr::read_csv(system.file("extdata/colData.csv",
  package = "mspms"
))
#> Rows: 12 Columns: 4
#> ── Column specification ────────────────────────────────────────────────────────
#> Delimiter: ","
#> chr (3): quantCols, group, condition
#> dbl (1): time
#> 
#> ℹ Use `spec()` to retrieve the full column specification for this data.
#> ℹ Specify the column types or set `show_col_types = FALSE` to quiet this message.

head(colData)
#> # A tibble: 6 × 4
#>   quantCols   group     condition  time
#>   <chr>       <chr>     <chr>     <dbl>
#> 1 CatA_0000_1 CatA_0000 CatA          0
#> 2 CatA_0000_2 CatA_0000 CatA          0
#> 3 CatA_0000_3 CatA_0000 CatA          0
#> 4 CatA_0000_4 CatA_0000 CatA          0
#> 5 CatA_0030_1 CatA_0030 CatA         30
#> 6 CatA_0030_2 CatA_0030 CatA         30
```

### PEAKS

Analysis using a .csv exported from [PEAKS
software](https://www.bioinfor.com/peaks-studio/) is supported.

an exported .csv file can be generated from PEAKS as follows:

1.  Create a New Project in PEAKS.  
2.  Select data to add to PEAKS project.  
3.  Add data, rename samples, set correct parameters. • Highlight all
    the added data.  
    • Select Create new sample for each file.  
    • Select appropriate instrument and fragmentation method.  
    • Set Enzyme to “None”.  
    • Rename samples according to enzymes, time points, and
    replicates.  
    • Can also ensure appropriate data is selected for these.  
    • Select “Data Refinement” to continue.  
4.  Data Refinement.  
    • On the top right, select MSP-MS as the predefined parameters.  
    • Parameters shown are what should be used for MSP-MS data
    analysis.  
    • Select “Identification” to continue.  
5.  Peptide Identification.  
    • On the top right, select MSP-MS as the predefined parameters.  
    • Parameters shown are what should be used for MSP-MS data
    analysis.  
    • Identification -\> Select Database -\> TPD_237.  
    • Identification -\> no PTMs.  
    • Can remove the PTMs by highlighting them and selecting Remove  
6.  Label Free Quantification.  
    • Make sure Label Free is selected.  
    • Group samples -\> add quadruplicates of samples to new group.

``` r
library(dplyr)
#> 
#> Attaching package: 'dplyr'
#> The following objects are masked from 'package:stats':
#> 
#>     filter, lag
#> The following objects are masked from 'package:base':
#> 
#>     intersect, setdiff, setequal, union
library(mspms)
#> 
#> Attaching package: 'mspms'
#> The following object is masked _by_ '.GlobalEnv':
#> 
#>     colData

# File path of peaks lfq file
lfq_filepath <- system.file("extdata/peaks_protein-peptides-lfq.csv",
  package = "mspms"
)

colData_filepath <- system.file("extdata/colData.csv", package = "mspms")

# Prepare the data
peaks_prepared_data <- mspms::prepare_peaks(lfq_filepath,
  colData_filepath,
  quality_threshold = 0.3,
  n_residues = 4
)
#> Rows: 2444 Columns: 32
#> ── Column specification ────────────────────────────────────────────────────────
#> Delimiter: ","
#> chr  (6): Protein Accession, Peptide, Used, Candidate, Sample Profile (Ratio...
#> dbl (25): Protein Group, Protein ID, Quality, Significance, Avg. ppm, Avg. A...
#> lgl  (1): PTM
#> 
#> ℹ Use `spec()` to retrieve the full column specification for this data.
#> ℹ Specify the column types or set `show_col_types = FALSE` to quiet this message.
#> Rows: 12 Columns: 4
#> ── Column specification ────────────────────────────────────────────────────────
#> Delimiter: ","
#> chr (3): quantCols, group, condition
#> dbl (1): time
#> 
#> ℹ Use `spec()` to retrieve the full column specification for this data.
#> ℹ Specify the column types or set `show_col_types = FALSE` to quiet this message.
#> Checking arguments.
#> 
#> Loading data as a 'SummarizedExperiment' object.
#> 
#> Formatting sample annotations (colData).
#> 
#> Formatting data as a 'QFeatures' object.
#> 
#> Setting assay rownames.

peaks_prepared_data
#> An instance of class QFeatures (type: bulk) with 1 set:
#> 
#>  [1] peptides: SummarizedExperiment with 1421 rows and 12 columns
```

### Fragpipe

Data exported from [Fragpipe](https://github.com/Nesvilab/FragPipe) as a
.tsv file is supported.

To generate this file, run a [LFQ Fragpipe
workflow](https://fragpipe.nesvilab.org/docs/tutorial_lfq.html) using
your desired parameters (we recommend using match between runs).

You will find a file named “combined_peptide.tsv” in the output folder
from Fragpipe.

This can be loaded into mspms as follows:

``` r
combined_peptide_filepath <- system.file("extdata/fragpipe_combined_peptide.tsv",
  package = "mspms"
)

colData_filepath <- system.file("extdata/colData.csv", package = "mspms")


fragpipe_prepared_data <- prepare_fragpipe(
  combined_peptide_filepath,
  colData_filepath
)
#> Rows: 1847 Columns: 63
#> ── Column specification ────────────────────────────────────────────────────────
#> Delimiter: "\t"
#> chr (19): Peptide Sequence, Prev AA, Next AA, Protein, Protein ID, Entry Nam...
#> dbl (40): Start, End, Peptide Length, CatA_0000_1 Spectral Count, CatA_0000_...
#> num  (1): Charges
#> lgl  (3): Gene, Mapped Genes, Mapped Proteins
#> 
#> ℹ Use `spec()` to retrieve the full column specification for this data.
#> ℹ Specify the column types or set `show_col_types = FALSE` to quiet this message.
#> Rows: 12 Columns: 4
#> ── Column specification ────────────────────────────────────────────────────────
#> Delimiter: ","
#> chr (3): quantCols, group, condition
#> dbl (1): time
#> 
#> ℹ Use `spec()` to retrieve the full column specification for this data.
#> ℹ Specify the column types or set `show_col_types = FALSE` to quiet this message.
#> Checking arguments.
#> 
#> Loading data as a 'SummarizedExperiment' object.
#> 
#> Formatting sample annotations (colData).
#> 
#> Formatting data as a 'QFeatures' object.
#> 
#> Setting assay rownames.

fragpipe_prepared_data
#> An instance of class QFeatures (type: bulk) with 1 set:
#> 
#>  [1] peptides: SummarizedExperiment with 1694 rows and 12 columns
```

### Proteome Discoverer

Analysis of a PeptideGroups.txt file exported from [proteome
discoverer](https://www.thermofisher.com/us/en/home/industrial/mass-spectrometry/liquid-chromatography-mass-spectrometry-lc-ms/lc-ms-software/multi-omics-data-analysis/proteome-discoverer-software.html)
is supported.

To generate this .txt file: 1. Ensure that non-normalized/ non-scaled
abundances are included in your PeptideGroup table.  
2. File \> export \> To Text (tab delimited) \> Items to be exported -
check the Peptide Groups box \> Export.

Note that the fileIDs of each sample in proteome discoverer (By default
F1 - Fn) must match the quantCols in colData.

``` r
peptide_groups_filepath <- system.file(
  "extdata/proteome_discoverer_PeptideGroups.txt",
  package = "mspms"
)

colData_filepath <- system.file("extdata/proteome_discover_colData.csv",
  package = "mspms"
)

prepared_pd_data <- prepare_pd(peptide_groups_filepath, colData_filepath)
#> Rows: 1207 Columns: 68
#> ── Column specification ────────────────────────────────────────────────────────
#> Delimiter: "\t"
#> chr (17): Confidence, Annotated Sequence, Master Protein Accessions, Positio...
#> dbl (48): Peptide Groups Peptide Group ID, Qvality PEP, Qvality q-value, # P...
#> lgl  (3): Checked, Modifications, Modifications in Master Proteins
#> 
#> ℹ Use `spec()` to retrieve the full column specification for this data.
#> ℹ Specify the column types or set `show_col_types = FALSE` to quiet this message.
#> Rows: 12 Columns: 4
#> ── Column specification ────────────────────────────────────────────────────────
#> Delimiter: ","
#> chr (3): quantCols, group, condition
#> dbl (1): time
#> 
#> ℹ Use `spec()` to retrieve the full column specification for this data.
#> ℹ Specify the column types or set `show_col_types = FALSE` to quiet this message.
#> Checking arguments.
#> 
#> Loading data as a 'SummarizedExperiment' object.
#> 
#> Formatting sample annotations (colData).
#> 
#> Formatting data as a 'QFeatures' object.
#> 
#> Setting assay rownames.

prepared_pd_data
#> An instance of class QFeatures (type: bulk) with 1 set:
#> 
#>  [1] peptides: SummarizedExperiment with 1161 rows and 12 columns
```

### Sage

Analysis of a lfq.tsv file exported from
[sage](https://github.com/lazear/sage) is supported. We found this
software a little harder to use than other solutions (No-GUI), however
it is completly open-source, free, and by far the fastest!

``` r
sage_lfq_filepath <- system.file(
  "extdata/sage_lfq.tsv",
  package = "mspms"
)

colData_filepath <- system.file("extdata/colData.csv",
  package = "mspms"
)

prepare_sage(sage_lfq_filepath, colData_filepath)
#> Rows: 1555 Columns: 18
#> ── Column specification ────────────────────────────────────────────────────────
#> Delimiter: "\t"
#> chr  (2): peptide, proteins
#> dbl (16): charge, q_value, score, spectral_angle, CatA_0000_1.mzML, CatA_000...
#> 
#> ℹ Use `spec()` to retrieve the full column specification for this data.
#> ℹ Specify the column types or set `show_col_types = FALSE` to quiet this message.
#> Rows: 12 Columns: 4
#> ── Column specification ────────────────────────────────────────────────────────
#> Delimiter: ","
#> chr (3): quantCols, group, condition
#> dbl (1): time
#> 
#> ℹ Use `spec()` to retrieve the full column specification for this data.
#> ℹ Specify the column types or set `show_col_types = FALSE` to quiet this message.
#> Checking arguments.
#> 
#> Loading data as a 'SummarizedExperiment' object.
#> 
#> Formatting sample annotations (colData).
#> 
#> Formatting data as a 'QFeatures' object.
#> 
#> Setting assay rownames.
#> An instance of class QFeatures (type: bulk) with 1 set:
#> 
#>  [1] peptides: SummarizedExperiment with 969 rows and 12 columns
```

### DIA-NN

We are currently investigating how well the method works with DIA data.
To allow for this we have created a parser to make DIA-NN output
compatible with mspms.

Note that this could be used with DIA-NN alone or with Fragpipe
(MSFragger-DIA) uses DIA-NN for quantification. Here we are using the
file output from Fragpipe.

Use caution when using this approach, we haven’t thoroughly investigated
how well DIA data works with mspms using ground truth data yet.

``` r
precursor_filepath <- system.file(
  "extdata/diann_report.pr_matrix.tsv",
  package = "mspms"
)
colData_filepath <- system.file(
  "extdata/diann_colData.csv",
  package = "mspms"
)

prepared_diann_data <- prepare_diann(precursor_filepath, colData_filepath)
#> Rows: 3657 Columns: 28
#> ── Column specification ────────────────────────────────────────────────────────
#> Delimiter: "\t"
#> chr  (6): Protein.Group, Protein.Ids, Stripped.Sequence, Modified.Sequence, ...
#> dbl (18): Proteotypic, Precursor.Charge, D:\Charlie\conce_mspms\CS_MSPMS_Spe...
#> lgl  (4): Protein.Names, Genes, First.Protein.Description, All Mapped Genes
#> 
#> ℹ Use `spec()` to retrieve the full column specification for this data.
#> ℹ Specify the column types or set `show_col_types = FALSE` to quiet this message.
#> Rows: 16 Columns: 4
#> ── Column specification ────────────────────────────────────────────────────────
#> Delimiter: ","
#> chr (3): quantCols, group, condition
#> dbl (1): time
#> 
#> ℹ Use `spec()` to retrieve the full column specification for this data.
#> ℹ Specify the column types or set `show_col_types = FALSE` to quiet this message.
#> Checking arguments.
#> 
#> Loading data as a 'SummarizedExperiment' object.
#> 
#> Formatting sample annotations (colData).
#> 
#> Formatting data as a 'QFeatures' object.
#> 
#> Setting assay rownames.

prepared_diann_data
#> An instance of class QFeatures (type: bulk) with 1 set:
#> 
#>  [1] peptides: SummarizedExperiment with 2682 rows and 16 columns
```

## Data Processing

Data processing includes imputation and normalization of the proteomics
data. This is all done in a QFeatures object using MSCoreUtils methods.
Data from each step is stored as a SummarizedExperiment within the
QFeatures object with the indicated name.

1.  Data is first log2 transformed (“peptides_log”).  
2.  Data is normalized using the center.median method
    (“peptides_log_norm”).  
3.  Missing values are then imputed using the QRILC method
    (“peptides_log_impute_norm”).
4.  Data is then reverse log2 transformed (“peptides_norm”).

``` r
set.seed(2)
processed_qf <- process_qf(peaks_prepared_data)
#> Loading required namespace: imputeLCMD
#> Imputing along margin 2 (samples/columns).
#> Your row data contain missing values. Please read the relevant
#> section(s) in the aggregateFeatures manual page regarding the effects
#> of missing values on data aggregation.
#> Aggregated: 1/1
processed_qf
#> An instance of class QFeatures (type: bulk) with 5 sets:
#> 
#>  [1] peptides: SummarizedExperiment with 1421 rows and 12 columns 
#>  [2] peptides_log: SummarizedExperiment with 1421 rows and 12 columns 
#>  [3] peptides_log_norm: SummarizedExperiment with 1421 rows and 12 columns 
#>  [4] peptides_log_impute_norm: SummarizedExperiment with 1421 rows and 12 columns 
#>  [5] peptides_norm: SummarizedExperiment with 1421 rows and 12 columns
```

## Statistics

MSP-MS analysis has traditionally used T-tests to what peptides are
significantly different relative to T0. The authors of the assay suggest
using a T-test derived FDR adjusted p value threshold \<= 0.05 and log2
fold change threshold \>= 3.

We recommend that the user now uses a Limma based approach that uses a
linear modeling and empirical Bayesian approach. This is a approach well
suited to proteomics data that is powerful, flexible, and fast.

This limma based approach (with stats calculated relative to time 0 for
each condition) can be utilized as follows:

``` r
limma_stats <- mspms::limma_stats(processed_qf = processed_qf)
#> Joining with `by = join_by(quantCols)`
```

Alternatively, we provide a user-friendly implementation of the
traditional t-test approach as follows:

``` r
log2fc_t_test_data <- mspms::log2fc_t_test(processed_qf = processed_qf)
#> Joining with `by = join_by(quantCols)`
#> Joining with `by = join_by(quantCols)`
```

## Data Visualizations

We provide a number of data visualizations as part of the mspms package.

### QC Checks

A critical initial step in MSP-MS data analysis is a rigorous quality
control assessment. Given the reliance on a specific peptide library,
calculating the percentage of library peptides detected in each sample
provides a straightforward yet powerful indicator of data integrity.
Anomalously low detection rates signal potential instrument or
experimental problems.

We can see the percentage of the peptide library that were undetected
among each group of replicates as follows (for full length peptides a
threshold of ~\< 10 is considered good while for cleavage products a
threshold ~\< 5 is good):

``` r
plot_qc_check(processed_qf,
  full_length_threshold = 10,
  cleavage_product_threshold = 5
)
#> Joining with `by = join_by(quantCols)`
```

![](README_files/figure-gfm/unnamed-chunk-13-1.png)<!-- -->

We can also see in what percentage of samples each peptide in the
peptide library were undetected in.

``` r
plot_nd_peptides(processed_qf)
#> Joining with `by = join_by(quantCols)`
```

![](README_files/figure-gfm/unnamed-chunk-14-1.png)<!-- -->

### Tidying our data

We can then convert our QFeatures object into a “long” tibble using the
mspms_tidy function.

This makes the data easy to manipulate prior to ggplot2 or plotly based
plotting functions.

``` r
mspms_tidy_data <- mspms_tidy(processed_qf)
#> Joining with `by = join_by(quantCols)`
```

### Heatmap

We can inspect our data using an interactive heatmap as follows:

``` r
plot_heatmap(mspms_tidy_data)
```

note that the interactive plot is not returned in this vignette due to
size constraints.

### PCA

We can also inspect our data using a PCA as follows.

``` r
plot_pca(mspms_tidy_data, value_colname = "peptides_norm")
```

![](README_files/figure-gfm/unnamed-chunk-17-1.png)<!-- -->

### Volcano plots

We can generate volcano plots showing the significant peptides from each
condition as follows:

``` r
plot_volcano(log2fc_t_test_data)
```

![](README_files/figure-gfm/unnamed-chunk-18-1.png)<!-- -->

### Cleavage Position Plots

We can also create plots showing the number of times we observe a
cleavage at each position of the peptide_library among a set of peptides
of interest.

We can do this as follows:

``` r
sig_cleavage_data <- log2fc_t_test_data %>%
  dplyr::filter(p.adj <= 0.05, log2fc > 3)

p1 <- mspms::plot_cleavages_per_pos(sig_cleavage_data)

p1
```

![](README_files/figure-gfm/unnamed-chunk-19-1.png)<!-- -->

### iceLogo

[Icelogos](https://www.nature.com/articles/nmeth1109-786) are a method
for visualizing conserved patterns in protein sequences through
probability theory.

As part of the mspms R package, we have implemented the logic to
generate
[iceLogos](https://genesis.ugent.be/uvpublicdata/icelogo/iceLogo.pdf) in
R.

To use this, we first have to define a vector of cleavage sequences that
we are interested in. We will do this for the significant CatA cleavages
below.

``` r
catA_sig_cleavages <- log2fc_t_test_data %>%
  dplyr::filter(p.adj <= 0.05, log2fc > 3) %>%
  dplyr::filter(condition == "CatA") %>%
  dplyr::pull(cleavage_seq) %>%
  unique()
```

We also need to know all of the possible cleavages we could see among
our peptide library. We can generate that as below:

``` r
all_possible_8mers_from_228_library <- calculate_all_cleavages(
  mspms::peptide_library$library_real_sequence,
  n_AA_after_cleavage = 4
)
```

We can then generate an iceLogo relative to the background of all
possible cleavages in our peptide library like so:

``` r
plot_icelogo(catA_sig_cleavages,
  background_universe = all_possible_8mers_from_228_library
)
#> Warning: `aes_string()` was deprecated in ggplot2 3.0.0.
#> ℹ Please use tidy evaluation idioms with `aes()`.
#> ℹ See also `vignette("ggplot2-in-packages")` for more information.
#> ℹ The deprecated feature was likely used in the ggseqlogo package.
#>   Please report the issue at <https://github.com/omarwagih/ggseqlogo/issues>.
#> This warning is displayed once every 8 hours.
#> Call `lifecycle::last_lifecycle_warnings()` to see where this warning was
#> generated.
#> Scale for x is already present.
#> Adding another scale for x, which will replace the existing scale.
```

![](README_files/figure-gfm/unnamed-chunk-22-1.png)<!-- -->

We also provide a function that conveniently plots all icelogos from all
conditions from the experiment all together.

``` r
sig_cleavage_data <- log2fc_t_test_data %>%
  dplyr::filter(p.adj <= 0.05, log2fc > 3)

plot_all_icelogos(sig_cleavage_data)
#> Scale for x is already present.
#> Adding another scale for x, which will replace the existing scale.
```

![](README_files/figure-gfm/unnamed-chunk-23-1.png)<!-- -->

### Plotting a Time Course

We can also plot the intensities of peptides of interest over time.

First we need to define which peptides we are interested in. Here we
will use the t-test results, and look at the peptide with the max
log2fc.

``` r
max_log2fc_pep <- log2fc_t_test_data %>%
  dplyr::filter(p.adj <= 0.05, log2fc > 3) %>%
  dplyr::filter(log2fc == max(log2fc)) %>%
  pull(peptide)
```

We can then filter our tidy mspms data to only include this peptide and
plot

``` r
p1 <- mspms_tidy_data %>%
  dplyr::filter(peptide == max_log2fc_pep) %>%
  plot_time_course()

p1
```

![](README_files/figure-gfm/unnamed-chunk-25-1.png)<!-- -->

``` r
sessionInfo()
#> R version 4.5.2 (2025-10-31)
#> Platform: aarch64-apple-darwin20
#> Running under: macOS Sequoia 15.3.1
#> 
#> Matrix products: default
#> BLAS:   /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libBLAS.dylib 
#> LAPACK: /Library/Frameworks/R.framework/Versions/4.5-arm64/Resources/lib/libRlapack.dylib;  LAPACK version 3.12.1
#> 
#> locale:
#> [1] en_US.UTF-8/en_US.UTF-8/en_US.UTF-8/C/en_US.UTF-8/en_US.UTF-8
#> 
#> time zone: America/Los_Angeles
#> tzcode source: internal
#> 
#> attached base packages:
#> [1] stats     graphics  grDevices utils     datasets  methods   base     
#> 
#> other attached packages:
#> [1] mspms_1.1.1 dplyr_1.1.4
#> 
#> loaded via a namespace (and not attached):
#>   [1] tidyselect_1.2.1            farver_2.1.2               
#>   [3] S7_0.2.0                    fastmap_1.2.0              
#>   [5] lazyeval_0.2.2              digest_0.6.37              
#>   [7] lifecycle_1.0.4             cluster_2.1.8.1            
#>   [9] ProtGenerics_1.42.0         statmod_1.5.1              
#>  [11] magrittr_2.0.4              compiler_4.5.2             
#>  [13] rlang_1.1.6                 tools_4.5.2                
#>  [15] igraph_2.2.1                utf8_1.2.6                 
#>  [17] yaml_2.3.10                 ggsignif_0.6.4             
#>  [19] knitr_1.50                  labeling_0.4.3             
#>  [21] S4Arrays_1.10.0             bit_4.6.0                  
#>  [23] DelayedArray_0.36.0         plyr_1.8.9                 
#>  [25] RColorBrewer_1.1-3          abind_1.4-8                
#>  [27] norm_1.0-11.1               withr_3.0.2                
#>  [29] purrr_1.2.0                 BiocGenerics_0.56.0        
#>  [31] grid_4.5.2                  stats4_4.5.2               
#>  [33] ggpubr_0.6.2                ggplot2_4.0.0              
#>  [35] scales_1.4.0                MASS_7.3-65                
#>  [37] MultiAssayExperiment_1.36.0 SummarizedExperiment_1.40.0
#>  [39] cli_3.6.5                   mvtnorm_1.3-3              
#>  [41] tmvtnorm_1.7                rmarkdown_2.30             
#>  [43] crayon_1.5.3                generics_0.1.4             
#>  [45] rstudioapi_0.17.1           reshape2_1.4.4             
#>  [47] tzdb_0.5.0                  BiocBaseUtils_1.12.0       
#>  [49] stringr_1.6.0               ggseqlogo_0.2              
#>  [51] parallel_4.5.2              impute_1.84.0              
#>  [53] AnnotationFilter_1.34.0     BiocManager_1.30.26        
#>  [55] XVector_0.50.0              matrixStats_1.5.0          
#>  [57] vctrs_0.6.5                 Matrix_1.7-4               
#>  [59] sandwich_3.1-1              carData_3.0-5              
#>  [61] car_3.1-3                   IRanges_2.44.0             
#>  [63] hms_1.1.4                   S4Vectors_0.48.0           
#>  [65] rstatix_0.7.3               bit64_4.6.0-1              
#>  [67] imputeLCMD_2.1              Formula_1.2-5              
#>  [69] clue_0.3-66                 limma_3.66.0               
#>  [71] tidyr_1.3.1                 glue_1.8.0                 
#>  [73] QFeatures_1.20.0            cowplot_1.2.0              
#>  [75] stringi_1.8.7               gmm_1.9-1                  
#>  [77] gtable_0.3.6                GenomicRanges_1.62.0       
#>  [79] tibble_3.3.0                pillar_1.11.1              
#>  [81] pcaMethods_2.2.0            htmltools_0.5.8.1          
#>  [83] Seqinfo_1.0.0               R6_2.6.1                   
#>  [85] vroom_1.6.6                 evaluate_1.0.5             
#>  [87] lattice_0.22-7              Biobase_2.70.0             
#>  [89] readr_2.1.5                 backports_1.5.0            
#>  [91] broom_1.0.10                BiocStyle_2.38.0           
#>  [93] Rcpp_1.1.0                  gridExtra_2.3              
#>  [95] SparseArray_1.10.1          xfun_0.54                  
#>  [97] MsCoreUtils_1.21.0          MatrixGenerics_1.22.0      
#>  [99] zoo_1.8-14                  pkgconfig_2.0.3
```

#' prepare_diann
#'
#' prepare data from the pr_matrix.tsv diann output. This can be either from
#' DIA-NN or from Fragpipe (as it uses DIA-NN for quantification internally for
#' MSFragger-DIA workflows)
#'
#' @param precursor_filepath filepath to report.pr_matrix.tsv file exported
#' from DIA-NN.
#' @param colData_filepath file path to .csv file containing colData.
#' Must have columns named "quantCols","group","condition",and "time".
#' @param peptide_library peptide library used with experiment. Contains
#' columns "library_id", "library_match_sequence", and "library_real_sequence".
#' @param n_residues the number of amino acid residues before and after the
#' cleavage site to generate a cleavage seq for.
#'
#' @returns a QFeatures object.
#' @export
#'
#' @examples
#' precursor_filepath <- system.file(
#'   "extdata/diann_report.pr_matrix.tsv",
#'   package = "mspms"
#' )
#' colData_filepath <- system.file("extdata/diann_colData.csv", package = "mspms")
#' prepare_diann(precursor_filepath, colData_filepath)
prepare_diann <- function(precursor_filepath,
                          colData_filepath,
                          peptide_library = mspms::peptide_library,
                          n_residues = 4) {
  prepared_data <- prepare_file(
    filepath = precursor_filepath,
    colData_filepath = colData_filepath,
    peptide_library = peptide_library,
    n_residues = n_residues,
    read_fun = readr::read_tsv,
    validate_fun = check_file_is_valid_diann,
    transform_fun = transform_diann
  )

  return(prepared_data)
}

test_that("prepare_diann works", {
  expect_no_error({
    precursor_filepath <- system.file("extdata/diann_report.pr_matrix.tsv",
      package = "mspms"
    )
    colData_filepath <- system.file("extdata/diann_colData.csv", package = "mspms")
    prepare_diann(precursor_filepath, colData_filepath)
  })
})

#' plot_nd_peptides
#'
#' plot the percentage of samples each peptide from library was undetected in
#' (if the percentage is > 0).
#'
#' @param processed_qf a QFeatures object containing a SummarizedExperiment
#' named "peptides"
#' @param peptide_library_ids a vector of all peptide library ids in the
#' experiment.
#'
#' @return a ggplot2 object
#' @export
#'
#' @examples
#' plot_nd_peptides(mspms::processed_qf)
plot_nd_peptides <- function(processed_qf,
                             peptide_library_ids =
                               mspms::peptide_library$library_id) {
  nd_peptides <- calc_per_samples_library_nd(
    processed_qf,
    peptide_library_ids
  ) %>%
    dplyr::filter(.data$per_samples_undetected > 0)
  # Plotting
  p1 <- nd_peptides %>%
    ggplot2::ggplot(ggplot2::aes(
      x = stats::reorder(
        .data$library_id,
        .data$per_samples_undetected
      ),
      y = .data$per_samples_undetected
    )) +
    ggplot2::geom_point() +
    ggplot2::coord_flip() +
    ggplot2::facet_wrap(~ .data$peptide_type, scales = "free_y") +
    ggplot2::xlab("Library ID")
  return(p1)
}

#' prepare_fragpipe
#'
#' Prepare a label free quantification file exported from Fragpipe
#' for subsequent mspms analysis.
#'
#' @param combined_peptide_filepath file path the combined_peptide.tsv file
#' generated by FragPipe.
#' @param colData_filepath file path to .csv file containing colData.
#' Must have columns named "quantCols","group","condition",and "time".
#' @param peptide_library peptide library used with experiment. Contains
#' columns "library_id", "library_match_sequence", and "library_real_sequence".
#' @param n_residues the number of amino acid residues before and after the
#' cleavage site to generate a cleavage seq for.
#'
#' @return a QFeatures object containing a summarizedExperiment named "peptides"
#' @export
#'
#' @examples
#' fragpipe_combined_peptide <- system.file("extdata/fragpipe_combined_peptide.tsv", package = "mspms")
#' colData_filepath <- system.file("extdata/colData.csv", package = "mspms")
#' # Prepare the data
#' fragpipe_prepared_data <- mspms::prepare_fragpipe(fragpipe_combined_peptide, colData_filepath)
prepare_fragpipe <- function(combined_peptide_filepath,
                             colData_filepath,
                             peptide_library = mspms::peptide_library,
                             n_residues = 4) {
  prepared_data <- prepare_file(
    filepath = combined_peptide_filepath,
    colData_filepath = colData_filepath,
    peptide_library = peptide_library,
    n_residues = n_residues,
    read_fun = readr::read_tsv,
    validate_fun = check_file_is_valid_fragpipe,
    transform_fun = transform_fragpipe
  )

  return(prepared_data)
}

test_that("prepare_fragpipe() results in a QFeatures object", {
  prepared_data <- prepare_fragpipe(
    combined_peptide_filepath <- system.file(
      "extdata/fragpipe_combined_peptide.tsv",
      package = "mspms"
    ),
    colData_filepath <- system.file("extdata/colData.csv", package = "mspms")
  )

  expect_s4_class(prepared_data, "QFeatures")
})

test_that("prepare_fragpipe() produces error when
          peaks data is accidently loaded", {
  expect_error(prepare_fragpipe(
    combined_peptide_filepath <- system.file(
      "extdata/peaks_protein-peptides-lfq.csv",
      package = "mspms"
    ),
    colData_filepath <- system.file("extdata/colData.csv", package = "mspms")
  ))
})

#' plot_icelogo
#'
#' This function plots the cleavage motifs that were enriched relative to
#' background as implemented in the iceLogo method.
#' https://iomics.ugent.be/icelogoserver/resources/manual.pdf
#'
#' @param cleavage_seqs  these are the cleavage sequences of interest
#' @param background_universe  this is a list of cleavage sequences
#' to use as the background in building the iceLogo.
#' @param pval  this is the pvalue threshold (<=) to consider significant when
#' determining the significance of the sig_cleavages relative to the background
#' at each position of the iceLogo.
#' @param type this is the type of visualization you would like to perform,
#' accepted values are  either "percent_difference" or "fold_change".
#' @return a ggplot2 object
#' @export
#'
#' @examples
#' # Determining significant cleavages for catA
#' catA_sig_cleavages <- mspms::log2fc_t_test_data %>%
#'   dplyr::filter(p.adj <= 0.05, log2fc > 3) %>%
#'   dplyr::filter(condition == "CatA") %>%
#'   dplyr::pull(cleavage_seq) %>%
#'   unique()
#'
#' # Plotting icelogo
#' plot_icelogo(catA_sig_cleavages,
#'   background_universe = all_possible_8mers_from_228_library
#' )
plot_icelogo <- function(cleavage_seqs,
                         background_universe =
                           mspms::all_possible_8mers_from_228_library,
                         pval = 0.05,
                         type = "percent_difference") {
  # calculate n
  n <- length(cleavage_seqs)
  # processing data to plot
  icelogo_data <- prepare_icelogo_data(
    cleavage_seqs,
    background_universe,
    pval,
    type
  )
  nchar_cleav <- ncol(icelogo_data)
  # Creating color scheme for mspms data
  col_scheme <- icelogo_col_scheme()
  # Plotting the motif
  p1 <- ggseqlogo::ggseqlogo(icelogo_data,
    font = "helvetica_light",
    method = "custom",
    seq_type = "AA",
    col_scheme = col_scheme
  ) +
    ggplot2::scale_x_continuous(
      labels = paste0("P", c(
        (nchar_cleav / 2):1,
        paste0(
          seq_len(nchar_cleav / 2), "'"
        )
      )),
      breaks = seq_len(nchar_cleav)
    ) +
    ggplot2::labs(subtitle = paste0("n = ", n)) +
    if (type == "percent_difference") {
      ggplot2::ylab("percent difference")
    } else if (type == "fold_change") {
      ggplot2::ylab("fold change")
    } else {
      stop("type must be either percent_difference or fold_change")
    }
  return(p1)
}

test_that("plot_icelogo() does not generate an error with expected data", {
  cleavage_seqs <- mspms::log2fc_t_test_data %>%
    dplyr::filter(
      p.adj <= 0.05, log2fc > 3,
      condition == "CatA"
    ) %>%
    dplyr::pull(cleavage_seq)

  expect_no_error(plot_icelogo(cleavage_seqs))
})

#' process_qf
#'
#' @param prepared_qf this is a QFeatures object containing a
#' SummarizedExperiment named "peptides"
#'
#' @return a QFeatures object containing a
#' SummarizedExperiments named "peptides","peptides_log","peptides_log_norm",
#' "peptides_log_impute_norm",and "peptides_norm"
#' @export
#' @examples
#' processed_qf <- process_qf(mspms::peaks_prepared_data)
process_qf <- function(prepared_qf) {
  # Log2transform the data, add as assay
  prepared_qf_norm <- QFeatures::addAssay(prepared_qf,
    QFeatures::logTransform(
      prepared_qf[["peptides"]]
    ),
    name = "peptides_log"
  )
  # Normalize the data, add as assay
  prepared_qf_norm <- QFeatures::normalize(prepared_qf_norm,
    i = "peptides_log",
    name = "peptides_log_norm",
    method = "center.median"
  )
  # Impute the data, add as assay
  QF_mod <- QFeatures::impute(prepared_qf_norm,
    method = "QRILC",
    i = "peptides_log_norm",
    name = "peptides_log_impute_norm", MARGIN = 2
  )
  # reverse log2 transform the data
  QF_mod <- QFeatures::aggregateFeatures(QF_mod,
    i = "peptides_log_impute_norm",
    "peptide", name = "peptides_norm",
    fun = rlog2
  )
  return(QF_mod)
}

test_that("plot_all_icelogos() produces ggarrange s3 class", {
  sig <- mspms::log2fc_t_test_data %>%
    dplyr::filter(p.adj <= 0.05, log2fc > 3)
  t <- plot_all_icelogos(sig)
  expect_s3_class(t, "ggarrange")
})

test_that("plot_all_icelogos() works with nresidues = 4", {
  sig <- mspms::log2fc_t_test_data %>%
    dplyr::filter(p.adj <= 0.05, log2fc > 3)
  expect_no_error(plot_all_icelogos(sig))
})


test_that("plot_all_icelogos() works with nresidues = 8", {
  all_16mers <- calculate_all_cleavages(
    mspms::peptide_library$library_real_sequence,
    n_AA_after_cleavage = 8
  )

  peaks_prepared_data <- mspms::prepare_peaks(
    system.file("extdata/peaks_protein-peptides-lfq.csv",
      package = "mspms"
    ),
    system.file("extdata/colData.csv", package = "mspms"),
    n_residues = 8
  ) %>%
    process_qf() %>%
    log2fc_t_test()

  sig <- peaks_prepared_data %>%
    dplyr::filter(p.adj <= 0.05, log2fc > 3)

  expect_no_error(plot_all_icelogos(sig, background_universe = all_16mers))
})

test_that("process_qf() produces the expected assays", {
  processed_qf <- process_qf(mspms::peaks_prepared_data)
  expected_assays <- c(
    "peptides", "peptides_log", "peptides_log_norm",
    "peptides_log_impute_norm", "peptides_norm"
  )
  sum <- sum(names(processed_qf) %!in% expected_assays)
  expect_equal(sum, 0)
})

#' prepare_sage
#' Prepare a label free quantification file exported from Sage
#' for subsequent mspms analysis.
#' @param sage_lfq_filepath filepath to lfq.tsv file output from
# ` Sage.
#' @param colData_filepath file path to .csv file containing colData.
#' Must have columns named "quantCols","group","condition",and "time".
#' @param peptide_library peptide library used with experiment. Contains
#' columns "library_id", "library_match_sequence", and "library_real_sequence".
#' @param n_residues the number of amino acid residues before and after the
#' cleavage site to generate a cleavage seq for.
#' @return a QFeatures object containing a summarizedExperiment named "peptides"
#' @export
#' @examples
#' sage_lfq_filepath <- system.file(
#'   "extdata/sage_lfq.tsv",
#'   package = "mspms"
#' )
#' colData_filepath <- system.file("extdata/colData.csv", package = "mspms")
#'
#' prepare_sage(sage_lfq_filepath, colData_filepath)
prepare_sage <- function(sage_lfq_filepath,
                         colData_filepath,
                         peptide_library = mspms::peptide_library,
                         n_residues = 4) {
  prepared_data <- prepare_file(
    filepath = sage_lfq_filepath,
    colData_filepath = colData_filepath,
    peptide_library = peptide_library,
    n_residues = n_residues,
    read_fun = readr::read_tsv,
    validate_fun = check_file_is_valid_sage,
    transform_fun = transform_sage
  )

  return(prepared_data)
}

test_that("prepare_sage works", {
  sage_lfq_filepath <- system.file(
    "extdata/sage_lfq.tsv",
    package = "mspms"
  )
  colData_filepath <- system.file("extdata/colData.csv",
    package = "mspms"
  )

  expect_no_error(prepare_sage(sage_lfq_filepath, colData_filepath))
})

#' Prepare PEAKS label-free quantification data for MSP-MS analysis
#'
#' This function reads, validates, transforms, and converts a PEAKS
#' LFQ file into a `QFeatures` object compatible with the `mspms` workflow.
#'
#' @param lfq_filepath Path to the PEAKS `.csv` file containing peptide-level LFQ data.
#' @param colData_filepath Path to a `.csv` file containing sample metadata (`colData`).
#'   Must include the columns `"quantCols"`, `"group"`, `"condition"`, and `"time"`.
#' @param quality_threshold Minimum quality score required for a peptide to be retained.
#'   Peptides below this threshold are filtered out (default `0.3`).
#' @param peptide_library A peptide library used in the experiment, typically
#'   `mspms::peptide_library`. Must include `"library_id"`, `"library_match_sequence"`,
#'   and `"library_real_sequence"`.
#' @param n_residues Number of amino acid residues to include on each side of the
#'   cleavage site when generating cleavage sequences (default `4`).
#'
#' @return A `QFeatures` object containing a `SummarizedExperiment` named `"peptides"`.
#' @export
#'
#' @examples
#' lfq_filepath <- system.file(
#'   "extdata/peaks_protein-peptides-lfq.csv",
#'   package = "mspms"
#' )
#' colData_filepath <- system.file(
#'   "extdata/colData.csv",
#'   package = "mspms"
#' )
#' peaks_qf <- mspms::prepare_peaks(lfq_filepath, colData_filepath)
prepare_peaks <- function(lfq_filepath,
                          colData_filepath,
                          quality_threshold = 0.3,
                          peptide_library = mspms::peptide_library,
                          n_residues = 4) {
  # Prepare PEAKS data using the generic prepare_file workflow
  prepared_data <- prepare_file(
    filepath = lfq_filepath,
    colData_filepath = colData_filepath,
    peptide_library = peptide_library,
    n_residues = n_residues,
    read_fun = readr::read_csv,
    validate_fun = check_file_is_valid_peaks,
    transform_fun = function(df, peptide_library) {
      transform_peaks(df, peptide_library, quality_threshold)
    }
  )

  return(prepared_data)
}

test_that("prepare_peaks() works as expected.", {
  expect_no_error({
    mspms::prepare_peaks(
      system.file("extdata/peaks_protein-peptides-lfq.csv",
        package = "mspms"
      ),
      system.file("extdata/colData.csv", package = "mspms")
    )
  })
})

#' plot_pca
#'
#' Easily create a PCA plot from a QFeatures object containing mspms data.
#' Ellipses are drawn around the points at a 95% confidence interval.
#' Shape and colors are user specified.
#'
#' @param mspms_tidy_data tidy mspms data (prepared from QFeatures object
#'  by mspms_tidy)
#' @param value_colname the name of the column containing values.
#' @param color the name of the variable you would like to color by.
#' @param shape the name of the variable that you would like to determine
#' shape by.
#' @return a ggplot2 object
#' @export
#'
#' @examples
#' plot_pca(mspms::mspms_tidy_data)
plot_pca <- function(mspms_tidy_data,
                     value_colname = "peptides_norm",
                     color = "time",
                     shape = "condition") {
  color <- dplyr::sym(color)
  shape <- dplyr::sym(shape)
  all <- prepare_for_PCA(mspms_tidy_data)
  plot <- all[[1]] %>%
    ggplot2::ggplot(ggplot2::aes(.data$PC1, .data$PC2,
      color = !!color,
      linetype = !!shape, shape = !!shape
    )) +
    ggplot2::geom_point() +
    ggplot2::stat_ellipse(level = 0.95) +
    ggplot2::xlab(paste0("PCA-1 ", round(all[[2]][1] * 100, 2), "%")) +
    ggplot2::ylab(paste0("PCA-2 ", round(all[[2]][2] * 100, 2), "%"))

  return(plot)
}

#' limma_stats
#'
#' Calculates statistics for each condition relative to time 0 using limma for
#' differential analysis. Results are then formatted to be consistent with
#' results produced by other statistic approaches used in the mspms package
#' (log2fc_t_test).
#'
#' @param processed_qf mspms data in a QFeatures object.
#'
#' @returns a tibble containing statistics
#' @export
#'
#' @examples
#' mspms_limma_results <- limma_stats(mspms::processed_qf)
limma_stats <- function(processed_qf) {
  # Preparing the data for limma analysis
  norm_data <- SummarizedExperiment::assay(
    processed_qf,
    "peptides_log_impute_norm"
  )
  colData <- SummarizedExperiment::colData(processed_qf)
  # Ensure time and condition columns are factors
  colData$time <- factor(colData$time, levels = unique(colData$time))
  colData$condition <- factor(colData$condition)
  # Create the design matrix with a valid naming format using periods
  design_mat <- calc_limma_design_matrix(colData, norm_data)
  # Fit the linear model
  fit <- limma::lmFit(norm_data, design_mat)
  # Define contrasts for each condition's time points relative to T0
  contrast_matrix <- calc_limma_contrasts(colData, design_mat)
  # Fit contrasts and apply empirical Bayes
  fit2 <- limma::contrasts.fit(fit, contrast_matrix)
  fit3 <- limma::eBayes(fit2)
  # Retrieve results for each contrast
  results <- lapply(colnames(contrast_matrix), function(contrast_name) {
    coef_index <- which(colnames(fit3$coefficients) == contrast_name)
    if (length(coef_index) > 0) {
      result <- limma::topTable(fit3, coef = coef_index, number = Inf)
      result$contrast <- contrast_name
      return(result)
    } else {
      warning(paste(
        "Contrast", contrast_name,
        "not found in fit coefficients. Skipping."
      ))
      return(NULL)
    }
  })

  # Combine results into a single tibble
  results_combined <- do.call(rbind, results) %>%
    tibble::rownames_to_column("peptide") %>%
    # duplicate peptides got a number in process, removing here
    dplyr::mutate(peptide = gsub("\\d*", "", peptide)) %>%
    dplyr::mutate(
      # Split the contrast at " - " to separate the two parts
      group1 = sapply(
        strsplit(as.character(contrast), " - "),
        function(x) x[1]
      ),
      # Extract the condition and time for the first part (before " - ")
      condition = sapply(strsplit(group1, "\\."), function(x) x[2]),
      time = sapply(strsplit(group1, "\\."), function(x) as.numeric(x[4])),
      # Now do the same for the second part (after " - ")
      group2 = sapply(strsplit(as.character(contrast), " - "), function(x) x[2])
    ) %>%
    rstatix::add_significance("adj.P.Val", "p.adj.signif")
  # Add cleavage data back to table
  results_combined <- add_peptide_data(results_combined, processed_qf)
  # Adding control mean to results
  t0 <- mspms::mspms_tidy(processed_qf, "peptides_log_impute_norm") %>%
    dplyr::filter(time == 0) %>%
    dplyr::group_by(.data$peptide, .data$condition) %>%
    dplyr::summarise(control_mean = mean(.data$peptides_log_impute_norm))

  # Convert results to a consistent format.
  results_formatted <- results_combined %>%
    dplyr::inner_join(t0, by = c("peptide", "condition")) %>%
    dplyr::select("condition", "peptide", "library_id", "peptide_type", "control_mean",
      "time",
      "sample_mean" = "AveExpr", "comparison" = "contrast",
      "log2fc" = "logFC", "cleavage_seq", "cleavage_pos", "group1",
      "group2", "p" = "P.Value", "p.adj" = "adj.P.Val", "p.adj.signif"
    )
  return(results_formatted)
}

#' calc_per_samples_library_nd
#' Calculate the percentage of samples each library_id peptide was not detected
#' in.
#' @param processed_qf a QFeatures object with a SummarizedExperiment named
#' "peptides". Intended to be prepared by one of the pre-processing
#' prepare_x_data functions of the mspms R package.
#' @param peptide_library_ids a character vector containing the names of the
#' library_ids
#' @return a tibble containing percentage of samples each library id was
#' detected in,  both as full length, and as cleavage products.
#' @keywords internal
calc_per_samples_library_nd <- function(processed_qf,
                                        peptide_library_ids =
                                          mspms::peptide_library$library_id) {
  mspms_data <- mspms_tidy(processed_qf, "peptides")
  n_samples <- length(unique(mspms_data$quantCols))
  wide <- mspms_data %>%
    dplyr::select(
      "peptide", "library_id", "peptides", "peptide_type", "quantCols"
    )
  full_length <- wide %>%
    dplyr::filter(.data$peptide_type == "full_length") %>%
    tidyr::pivot_wider(names_from = "quantCols", values_from = "peptides")
  nd_full <- peptide_library_ids[peptide_library_ids %!in%
    unique(full_length$library_id)]
  nd_full <- tibble::tibble(
    library_id = nd_full, n_samples = n_samples,
    n_missing = n_samples
  )
  n_missing_full_length <- tibble::tibble(
    library_id = full_length$library_id, n_samples = n_samples,
    n_missing = rowSums(is.na(full_length))
  )
  full <- dplyr::bind_rows(n_missing_full_length, nd_full) %>%
    dplyr::mutate(peptide_type = "full_length", .after = "library_id")
  cleavage_product <- wide %>%
    dplyr::filter(.data$peptide_type == "cleavage_product") %>%
    dplyr::select(-"peptide") %>%
    tidyr::pivot_wider(
      names_from = "quantCols", values_from = "peptides",
      values_fn = ~ sum(!is.na(.))
    )
  cleavage_product[cleavage_product == 0] <- NA
  cp_row_sums <- tibble::tibble(
    library_id = cleavage_product$library_id, n_samples = n_samples,
    n_missing = rowSums(is.na(cleavage_product))
  )
  nd_cleavage <- peptide_library_ids[peptide_library_ids %!in% unique(
    cleavage_product$library_id
  )]
  nd_cleavage <- tibble::tibble(
    library_id = nd_cleavage,
    n_samples = n_samples, n_missing = n_samples
  )
  cp_final <- dplyr::bind_rows(cp_row_sums, nd_cleavage) %>%
    dplyr::mutate(peptide_type = "cleavage_product", .after = "library_id")
  out <- dplyr::bind_rows(full, cp_final) %>%
    dplyr::mutate(per_samples_undetected = .data$n_missing /
      .data$n_samples * 100)
  return(out)
}
#' prepare_qc_check
#' Run simple quality control checks on the data. This checks to see how many
#' peptides belonging to the library were identified in the data in
#' each sample. Computes full length, and cleavage products independantly.
#' @param processed_qf a QFeatures object with a SummarizedExperiment named
#' "peptides". Intended to be prepared by one of the pre-processing
#' prepare_x_data functions of the mspms R package.
#' @param peptide_library_ids a character vector containing the names of the
#' library_ids
#' @return a tibble containing percentage of library_ids detected per sample,
#' both as full length, and as cleavage products.
#'
#' @keywords internal

prepare_qc_check_data <- function(processed_qf,
                                  peptide_library_ids =
                                    mspms::peptide_library$library_id) {
  # Filtering to only include detected peptides
  long <- processed_qf %>%
    mspms_tidy(se_name = "peptides") %>%
    dplyr::filter(!is.na(.data$peptides))
  # Counting # of peptides in peptide library
  library_num <- length(peptide_library_ids)
  # checking to see what percentage of the library is detected in each sample.
  check <- long %>%
    dplyr::group_by(
      .data$quantCols,
      .data$peptide_type,
      .data$condition,
      .data$time,
      .data$group
    ) %>%
    dplyr::summarise(
      n_detected = dplyr::n_distinct(.data$library_id),
      n_total = library_num,
      per_library_id_detected = round(.data$n_detected / .data$n_total
        * 100, 2),
      per_library_id_undetected = 100 -
        .data$per_library_id_detected
    )
  return(check)
}
#' icelogo_col_scheme
#' Defining a color scheme for our iceLogos
#'
#' @return a ggseqlogo color scheme function
#' @keywords internal
#'
icelogo_col_scheme <- function() {
  col_scheme <- ggseqlogo::make_col_scheme(
    chars = c(
      "G", "S", "T", "Y", "C", "N", "Q", "K", "R", "H", "D", "E", "P",
      "A", "W", "F", "L", "I", "M", "V", "n", "X"
    ),
    group = c(
      rep("Polar", 5), rep("Neutral", 2), rep("Basic", 3),
      rep("Acidic", 2), rep("Hydrophobic", 9), "Past Terminus"
    ),
    col = c(
      rep("#058644", 5), rep("#720091", 2), rep("#0046C5", 3),
      rep("#C5003E", 2),
      rep("#2E2E2E", 9), "#808080"
    ),
    name = "chemistry"
  )
  return(col_scheme)
}
#' count_cleavages_per_pos
#'
#' Count the number of cleavages per position
#'
#' @param data a tibble containing columns named peptide, cleavage_pos, condition,
#' and time. Other column names can be included.
#' @param peptide_library a peptide library tibble.
#' @return a tibble with all positions filled.
#' @keywords internal
count_cleavages_per_pos <- function(data,
                                    peptide_library = mspms::peptide_library) {
  peptide_length <- unique(nchar(peptide_library$library_match_sequence))
  positions <- seq_len(peptide_length - 1)

  # Count existing cleavages
  count <- data %>%
    dplyr::group_by(.data$condition, .data$time, .data$cleavage_pos) %>%
    dplyr::summarise(n = dplyr::n(), .groups = "drop")

  # Prepare list to collect results
  results_list <- vector("list", length = length(unique(data$condition)) * length(unique(data$time)))
  idx <- 1

  for (i in unique(data$condition)) {
    f <- count %>% dplyr::filter(.data$condition == i)
    for (t in unique(f$time)) {
      count_f <- f %>% dplyr::filter(.data$time == t)
      missing <- positions[!positions %in% count_f$cleavage_pos]
      missing_t <- tibble::tibble(
        condition = i,
        time = t,
        cleavage_pos = missing,
        n = rep(0, length(missing))
      )
      out <- dplyr::bind_rows(count_f, missing_t)
      results_list[[idx]] <- out
      idx <- idx + 1
    }
  }

  final <- dplyr::bind_rows(results_list)
  final$time <- as.character(final$time)
  return(final)
}

#' prepare_for_PCA()
#'
#' prepare QFeatures object for PCA analysis
#'
#' @param mspms_tidy_data tidy mspms data (prepared from QFeatures object
#'  by mspms_tidy())
#' @param value_colname the name of the column containing values.
#'
#' @return a tibble
#' @keywords internal
prepare_for_PCA <- function(mspms_tidy_data, value_colname = "peptides_norm") {
  value_colname <- dplyr::sym(value_colname)
  # dealing with no visible binding for global variable ‘.’ NOTE
  . <- NULL
  PCA_data <- mspms_tidy_data %>%
    dplyr::select(
      "quantCols", "peptide", "group", "condition",
      "time", !!value_colname
    ) %>%
    tidyr::pivot_wider(
      names_from = "peptide", values_from = !!value_colname,
      values_fn = NULL
    ) %>%
    # if a peptide has an na remove it
    dplyr::select_if(~ !any(is.na(.)))
  dat <- PCA_data %>%
    dplyr::select(5:length(.))
  # prcomp
  prcomp <- prcomp(dat, center = TRUE, scale = TRUE)
  # Getting PCA values
  PCA_df <- stats::predict(prcomp, dat) %>%
    tibble::as_tibble()
  # Extracting the metadata.
  md <- PCA_data %>%
    dplyr::select(seq_len(4))
  Prop_of_var <- data.frame(summary(prcomp)$importance)[2, ]
  all <- dplyr::bind_cols(md, PCA_df) %>%
    dplyr::mutate(time = as.factor(.data$time))
  list <- list(all, Prop_of_var)
  return(list)
}

### calc_per_samples_library_nd() ###
test_that("all library ids are in output of calc_per_samples_library_nd()", {
  nd_peptides <- mspms:::calc_per_samples_library_nd(
    mspms::peaks_prepared_data,
    peptide_library_ids = mspms::peptide_library$library_id
  )
  li <- unique(nd_peptides$library_id)
  total <- mspms::peptide_library$library_id
  sum <- sum(total %!in% li)
  expect_equal(sum, 0)
})

### prepare_qc_check() ###
test_that("prepare_qc_check() generates percentages 100 and below", {
  out <- mspms:::prepare_qc_check_data(mspms::processed_qf)
  per_library_id_detected <- max(out$per_library_id_detected)
  expect_lt(per_library_id_detected, 100)
})


test_that("prepare_qc_check() does not generate a percentage below 100.", {
  out <- mspms:::prepare_qc_check_data(mspms::processed_qf)
  per_library_id_detected <- min(out$per_library_id_detected)
  expect_gt(per_library_id_detected, 0)
})

### icelogo_col_scheme() ###
test_that("icelogo_col_scheme() does not error", {
  expect_no_error(mspms:::icelogo_col_scheme())
})

### count_cleavages_per_pos() ###

test_that("count_cleavages_per_pos() generates expected results", {
  test <- tibble::tibble(
    peptide = c("p1", "p2", "p3", "p4"),
    time = c(1, 1, 1, 1),
    condition = c("c1", "c1", "c1", "c1"),
    cleavage_pos = c(1, 1, 1, 1)
  )


  cc <- mspms:::count_cleavages_per_pos(test) %>%
    dplyr::filter(time == 1, condition == "c1", cleavage_pos == 1) %>%
    dplyr::pull(n)


  expect_equal(cc, 4)
})


test_that("count_cleavages_per_pos() generates expected length", {
  seq <- paste0(rep("A", 20),
    collapse = ""
  )

  peptide_library <- tibble::tibble(
    library_id = c("test1"),
    library_match_sequence = seq,
    library_real_sequence = seq
  )

  test <- tibble::tibble(
    peptide = c("p1", "p2", "p3", "p4"),
    time = c(1, 1, 1, 1),
    condition = c("c1", "c1", "c1", "c1"),
    cleavage_pos = c(1, 1, 1, 1)
  )

  cc <- mspms:::count_cleavages_per_pos(test, peptide_library)

  expect_equal(nchar(seq) - 1, max(cc$cleavage_pos))
})

#' generate_report
#'
#' wrapper function to generate an automatic .html report of a basic mspms
#' analysis.
#'
#' @param prepared_data a QFeatures object containing a SummarizedExperiment
#' named "peptides".
#' @param peptide_library peptide library used with experiment. Contains
#' columns "library_id", "library_match_sequence", and "library_real_sequence".
#' @param n_residues the number of amino acid residues before and after the
#' cleavage site to generate a cleavage seq for.
#' @param outdir the output directory you would like to render the
#' report to.
#' @param output_file the file name to export.
#'
#' @return a knited .html report of the mspms analysis.
#' @export
#' @examplesIf isTRUE(FALSE)
#' generate_report(mspms::peaks_prepared_data)
generate_report <- function(prepared_data,
                            peptide_library = mspms::peptide_library,
                            n_residues = 4,
                            outdir = getwd(),
                            output_file = paste0(
                              Sys.Date(),
                              "_mspms_report.html"
                            )) {
  rmarkdown::render(
    system.file("rmarkdown/templates/mspms_report/skeleton/skeleton.RMD",
      package = "mspms"
    ),
    params = list(
      prepared_data = prepared_data,
      peptide_library = peptide_library,
      n_residues = n_residues
    ),
    clean = TRUE,
    output_dir = outdir,
    output_file = output_file
  )
}

#' plot_volcano
#'
#' create a volcano plot to generate log2fc and adjusted p values for
#' experimental conditions
#'
#' @param log2fc_t_test_data a tibble containing the log2fc
#' and adjusted p values
#' @param log2fc_threshold  the log2fc threshold that you want displayed on plot
#' @param padj_threshold  the padj threshold that you want displayed on plot
#' @param facets how facets should be displayed. Accepted values are grid and
#' wrap
#' @param ncol ncol to include if facets = "wrap"
#'
#' @return a ggplot2 object
#' @export
#'
#' @examples
#' p1 <- mspms::plot_volcano(mspms::log2fc_t_test_data, log2fc_threshold = 3)
#' p1
plot_volcano <- function(log2fc_t_test_data,
                         log2fc_threshold = 3,
                         padj_threshold = 0.05,
                         facets = "grid",
                         ncol = 1) {
  ncol <- length(unique(log2fc_t_test_data$time))
  p1 <- log2fc_t_test_data %>%
    dplyr::mutate(`log_10_p.adj` = -log10(.data$p.adj)) %>%
    ggplot2::ggplot(ggplot2::aes(
      x = .data$log2fc,
      y = .data$log_10_p.adj
    )) +
    ggplot2::geom_point(size = 0.5) +
    ggplot2::geom_hline(
      yintercept = -log10(padj_threshold),
      linetype = "dashed", color = "red"
    ) +
    ggplot2::geom_vline(
      xintercept = log2fc_threshold,
      linetype = "dashed", color = "red"
    ) +
    ggplot2::geom_vline(
      xintercept = -log2fc_threshold,
      linetype = "dashed", color = "red"
    ) +
    ggplot2::labs(x = "Log2 (Time TX/T0)", y = "-log10(p.adj value)")
  if (facets == "grid") {
    p2 <- p1 + ggplot2::facet_grid(
      rows = dplyr::vars(.data$condition),
      cols = dplyr::vars(.data$time)
    )
  } else if (facets == "wrap") {
    p2 <- p1 + ggplot2::facet_wrap(~ .data$condition + .data$time,
      ncol = ncol
    )
  } else {
    stop("facets must be equal to either grid or wrap")
  }
  return(p2)
}

#' calculate_all_cleavages
#' calculate all possible cleavages for a defined peptide library containing
#' peptides of the same length.
#' @param peptide_library_seqs The sequences of each peptide in the peptide
#' library. They should all be the same length.
#' @param n_AA_after_cleavage  The number of AA after (and before) the cleavage
#' site to consider.
#' @return a vector of all the possible cleavages for the peptide library
#' sequences
#' @export
#' @examples
#' calculate_all_cleavages(mspms::peptide_library$library_real_sequence,
#'   n_AA_after_cleavage = 4
#' )
calculate_all_cleavages <- function(peptide_library_seqs,
                                    n_AA_after_cleavage = 4) {
  # calculate the length of the peptides in library.
  length <- unique(nchar(peptide_library_seqs))
  # The current code assumes all the sequences are the same length
  if (length(length) > 1) {
    stop("Peptide library sequences are not of the same length")
  }
  # first cut at every single position
  peptide_sequences <- c()
  # for each position go through and cut into two pieces
  for (i in seq_len(length - 1)) {
    ## Doing this for the first fragment, left side of cleavage
    first_fragment <- substr(peptide_library_seqs, 1, i)
    n_char <- unique(nchar(first_fragment))
    if (n_AA_after_cleavage - n_char > 0) {
      n_x <- paste0(rep("X", n_AA_after_cleavage - n_char), collapse = "")
    } else {
      n_x <- ""
    }
    first_fragment_x <- paste0(n_x, first_fragment)
    first_fragment_x <- substr(first_fragment_x,
      stop = unique(nchar(first_fragment_x)),
      start = unique(nchar(first_fragment_x)) -
        n_AA_after_cleavage + 1
    )
    ## Doing this for the second fragment, right side of cleavage
    second_fragment <- substr(
      peptide_library_seqs, i + 1,
      i + n_AA_after_cleavage
    )
    n_char <- unique(nchar(second_fragment))
    # calculating the overhangs
    if (n_AA_after_cleavage - n_char > 0) {
      n_x <- paste0(rep("X", n_AA_after_cleavage - n_char), collapse = "")
    } else {
      n_x <- ""
    }
    # appending the overhangs
    second_fragment_x <- paste0(second_fragment, n_x)
    # combining the two fragments
    combined <- paste0(first_fragment_x, second_fragment_x)
    # appending the combined fragments to the vector
    peptide_sequences <- c(peptide_sequences, combined)
  }
  return(peptide_sequences)
}

test_that("calculate all cleavages works", {
  expect_no_error(
    mspms::calculate_all_cleavages(
      mspms::peptide_library$library_real_sequence
    )
  )
})

test_that("calculate all cleavages generates cleavage motifs of the same
          length", {
  background_universe <- mspms::calculate_all_cleavages(
    mspms::peptide_library$library_real_sequence
  )
  nchar <- unique(sapply(background_universe, nchar))
  expect_equal(
    length(nchar),
    1
  )
})

#' prepare_pd
#' Prepare a label free quantification file exported from Proteome Discoverer
#' for subsequent mspms analysis.
#' @param peptide_groups_filepath filepath to PeptideGroups.txt file exported
#' from proteome discoverer.
#' @param colData_filepath file path to .csv file containing colData.
#' Must have columns named "quantCols","group","condition",and "time".
#' @param peptide_library peptide library used with experiment. Contains
#' columns "library_id", "library_match_sequence", and "library_real_sequence".
#' @param n_residues the number of amino acid residues before and after the
#' cleavage site to generate a cleavage seq for.
#' @return a QFeatures object containing a summarizedExperiment named "peptides"
#' @export
#' @examples
#' peptide_groups_filepath <- system.file(
#'   "extdata/proteome_discoverer_PeptideGroups.txt",
#'   package = "mspms"
#' )
#' colData_filepath <- system.file("extdata/colData.csv", package = "mspms")
prepare_pd <- function(peptide_groups_filepath,
                       colData_filepath,
                       peptide_library = mspms::peptide_library,
                       n_residues = 4) {
  prepared_data <- prepare_file(
    filepath = peptide_groups_filepath,
    colData_filepath = colData_filepath,
    peptide_library = peptide_library,
    n_residues = n_residues,
    read_fun = readr::read_delim,
    validate_fun = check_file_is_valid_pd,
    transform_fun = transform_pd
  )

  return(prepared_data)
}

test_that("prepare_pd() ", {
  peptide_groups_filepath <- system.file("extdata/proteome_discoverer_PeptideGroups.txt",
    package = "mspms"
  )
  colData_filepath <- system.file("extdata/proteome_discover_colData.csv",
    package = "mspms"
  )
  expect_s4_class(
    mspms::prepare_pd(
      peptide_groups_filepath,
      colData_filepath
    ),
    "QFeatures"
  )
})

# Adding Global Variables for use with NSE
if (getRversion() >= "2.15.1") {
  utils::globalVariables(c(
    "peptide",
    "contrast",
    "group1",
    "group2",
    "group3",
    "time",
    "peptide_length",
    "quantCols",
    "Protein.Group",
    "Stripped.Sequnce",
    "library_match_sequence",
    "cleavage_pos",
    "prev_aa_i",
    "next_aa_i",
    "library_id",
    "library_real_sequence",
    "Prev AA",
    "Peptide Sequence",
    "Next AA",
    "Protein",
    "q_value",
    "Stripped.Sequence",
    "proteins",
    "terminus",
    "terminus_cleavage_pos",
    ":="
  ))
}

# Dummy reference to avoid R CMD check note
.onLoad <- function(libname, pkgname) {
  if (FALSE) {
    imputeLCMD::impute.MAR()
  }
}


# Negate
`%!in%` <- Negate(`%in%`)

#' Generic preparation function for MSP-MS input files
#'
#' @param filepath path to the input file
#' @param colData_filepath path to colData CSV
#' @param peptide_library peptide library used in experiment
#' @param n_residues number of residues to include around cleavage site
#' @param read_fun function to read the file (e.g., read_tsv, read_csv, read_delim)
#' @param validate_fun function to validate the file (check_file_is_valid_*)
#' @param transform_fun function to transform file into standard peptide format
#'
#' @return a QFeatures object
#' @keywords internal
prepare_file <- function(filepath,
                         colData_filepath,
                         peptide_library = mspms::peptide_library,
                         n_residues = 4,
                         read_fun,
                         validate_fun,
                         transform_fun) {
  # Step 1: Read file
  raw_data <- read_fun(filepath)

  # Step 2: Validate
  validate_fun(raw_data)

  # Step 3: Transform into standard peptide format
  peptides <- transform_fun(raw_data, peptide_library)

  # Step 4: Load colData
  colData <- load_colData(colData_filepath)

  # Step 5: Convert to QFeatures
  qf <- prepared_to_qf(peptides, colData, peptide_library, n_residues)

  return(qf)
}


#' Transform PEAKS LFQ file into standard peptide format
#'
#' @param df PEAKS LFQ data read in with read_csv
#' @param peptide_library peptide library used in the experiment
#' @param quality_threshold minimum peptide quality to keep (default 0.3)
#'
#' @return a tibble with columns: peptide, library_id, sample intensities
#' @keywords internal
transform_peaks <- function(df, peptide_library, quality_threshold = 0.3) {
  # Filter out low quality peptides
  df <- df %>% dplyr::filter(.data$Quality > quality_threshold)

  # Report how many were removed
  n_removed <- sum(df$Quality <= quality_threshold, na.rm = TRUE)
  if (n_removed > 0) {
    percentage <- round(n_removed / nrow(df) * 100)
    message(
      n_removed, " peptides removed (quality < ", quality_threshold,
      ") = ", percentage, "% of total"
    )
  }

  # Identify relevant columns: from Avg. Area to Sample Profile (Ratio)
  start <- which(names(df) == "Avg. Area") + 1
  end <- which(names(df) == "Sample Profile (Ratio)") - 1

  # Create the standard peptide column
  df <- df %>%
    dplyr::mutate(Peptide = gsub("\\.", "_", .data$Peptide)) %>%
    dplyr::select(
      peptide = "Peptide",
      library_id = "Protein Accession",
      dplyr::any_of(start:end)
    )

  # Join with peptide library to ensure consistent metadata
  df <- dplyr::inner_join(peptide_library, df, by = "library_id")

  # Remove unnecessary library columns before returning
  df <- df %>%
    dplyr::select(peptide, library_id, dplyr::everything()) %>%
    dplyr::select(-library_match_sequence, -library_real_sequence)

  return(df)
}

#' Transform Proteome Discoverer PeptideGroups.txt into standard peptide format
#'
#' @param df Proteome Discoverer PeptideGroups.txt read with read_delim
#' @param peptide_library peptide library used in the experiment
#'
#' @return a tibble with columns: peptide, library_id, sample intensities
#' @keywords internal
transform_pd <- function(df, peptide_library) {
  # Rename to standard columns
  df <- df %>%
    dplyr::rename(
      peptide = "Annotated Sequence",
      library_id = "Master Protein Accessions"
    )

  # Convert peptide notation from PD to standard format
  df <- df %>%
    dplyr::mutate(
      peptide = gsub("\\[-\\]", "", .data$peptide),
      peptide = gsub("^\\.", "", .data$peptide),
      peptide = gsub("\\.$", "", .data$peptide),
      peptide = gsub("\\].", "_", .data$peptide),
      peptide = gsub("\\.\\[", "_", .data$peptide),
      peptide = gsub("\\]", "", .data$peptide),
      peptide = gsub("\\[", "", .data$peptide)
    )

  # Remove abundance normalization/scaling/count columns
  df <- df %>%
    dplyr::select(
      -dplyr::contains("Normalized"),
      -dplyr::contains("Scaled"),
      -dplyr::contains("Count")
    )

  # Keep only peptide, library_id, and abundance columns
  df <- df %>%
    dplyr::select("peptide", "library_id", dplyr::contains("Abundance")) %>%
    dplyr::rename_with(~ gsub("Abundance: ", "", .)) %>%
    dplyr::rename_with(~ gsub(": Sample", "", .))

  # Join with peptide library to ensure consistent library_id mapping
  df <- dplyr::inner_join(peptide_library, df, by = "library_id")

  # Remove extra library columns
  df <- df %>%
    dplyr::select(peptide, library_id, dplyr::everything()) %>%
    dplyr::select(-library_match_sequence, -library_real_sequence)

  return(df)
}


#' Transform DIA-NN report (pr_matrix.tsv) into standard peptide format
#'
#' @param df DIA-NN pr_matrix.tsv read with read_tsv
#' @param peptide_library peptide library used in the experiment
#'
#' @return a tibble with columns: peptide, library_id, sample intensities
#' @keywords internal
transform_diann <- function(df, peptide_library) {
  # start and and end indicies of quantification columns
  start <- which(names(df) == "Precursor.Id") + 1
  end <- length(names(df)) - 2
  nsamples <- end - start

  # Convert to peptides by summarizing precursor intensities (sum) per peptide
  peptides <- df %>%
    dplyr::group_by(
      library_id = `Protein.Group`,
      peptide = `Stripped.Sequence`
    ) %>%
    dplyr::summarise(
      dplyr::across(dplyr::all_of(names(df)[start:end]), \(x) sum(x, na.rm = TRUE)),
      .groups = "drop"
    )

  peptides <- dplyr::inner_join(peptide_library, peptides, by = "library_id") %>%
    dplyr::mutate(
      cleavage_pos = stringr::str_locate(library_match_sequence, peptide),
      prev_aa_i = cleavage_pos[, "start"] - 1,
      next_aa_i = cleavage_pos[, "end"] + 1,
      prev_aa = dplyr::if_else(prev_aa_i > 0, stringr::str_sub(library_match_sequence, prev_aa_i, prev_aa_i), ""),
      next_aa = dplyr::if_else(next_aa_i <= stringr::str_length(library_match_sequence), stringr::str_sub(library_match_sequence, next_aa_i, next_aa_i), "")
    ) %>%
    dplyr::mutate(peptide = dplyr::case_when(
      prev_aa != "" ~ paste0(prev_aa, "_", peptide),
      next_aa != "" ~ paste0(peptide, "_", next_aa),
      TRUE ~ peptide
    ))
  peptides <- peptides %>%
    dplyr::select(1:(length(names(peptides)) - 5)) %>%
    dplyr::select(peptide, library_id, dplyr::everything()) %>%
    dplyr::select(-library_match_sequence, -library_real_sequence)

  return(peptides)
}


#' Transform FragPipe combined_peptide.tsv into standard peptide format
#'
#' @param df FragPipe combined_peptide.tsv read with read_tsv
#' @param peptide_library peptide library used in the experiment
#'
#' @return a tibble with columns: peptide, library_id, sample intensities
#' @keywords internal
transform_fragpipe <- function(df, peptide_library) {
  # Replace NA Prev/Next AA with empty string
  df <- df %>%
    dplyr::mutate(
      `Prev AA` = dplyr::if_else(.data$`Prev AA` == "-", "", .data$`Prev AA`),
      `Next AA` = dplyr::if_else(.data$`Next AA` == "-", "", .data$`Next AA`)
    ) %>%
    # Build peptide with _ cleavage indicators
    dplyr::mutate(
      peptide = paste0(`Prev AA`, "_", `Peptide Sequence`, "_", `Next AA`),
      peptide = gsub("^_", "", peptide),
      peptide = gsub("_$", "", peptide)
    )

  # Select peptide, library_id, and abundance columns
  df <- df %>%
    dplyr::select(
      peptide,
      library_id = Protein,
      dplyr::contains("MaxLFQ Intensity")
    ) %>%
    dplyr::rename_with(~ gsub(" MaxLFQ Intensity", "", .))

  # Convert 0 to NA
  df[df == 0] <- NA

  # Join with peptide library to ensure consistency
  df <- dplyr::inner_join(peptide_library, df, by = "library_id") %>%
    dplyr::select(peptide, library_id, dplyr::everything()) %>%
    dplyr::select(-library_match_sequence, -library_real_sequence)

  return(df)
}


#' Transform Sage lfq.tsv into standard peptide format
#'
#' @param df sage lfq.tsv read with read_tsv
#' @param peptide_library peptide library used in the experiment
#'
#' @return a tibble with columns: peptide, library_id, sample intensities
#' @keywords internal
transform_sage <- function(df, peptide_library) {
  # start and and end indicies of quantification columns
  start <- which(names(df) == "spectral_angle") + 1
  end <- length(names(df))

  # Convert to peptides by summarizing precursor intensities (sum) per peptide
  peptides <- df %>%
    # Only including peptides confidently detected FDR < 0.01
    dplyr::filter(q_value <= 0.01) %>%
    dplyr::group_by(
      library_id = `proteins`,
      peptide
    ) %>%
    dplyr::summarise(
      dplyr::across(
        dplyr::all_of(names(df)[start:end]),
        \(x) sum(x, na.rm = TRUE)
      ),
      .groups = "drop"
    )

  peptides <- dplyr::inner_join(peptide_library, peptides, by = "library_id") %>%
    dplyr::mutate(
      cleavage_pos = stringr::str_locate(library_match_sequence, peptide),
      prev_aa_i = cleavage_pos[, "start"] - 1,
      next_aa_i = cleavage_pos[, "end"] + 1,
      prev_aa = dplyr::if_else(prev_aa_i > 0, stringr::str_sub(library_match_sequence, prev_aa_i, prev_aa_i), ""),
      next_aa = dplyr::if_else(next_aa_i <= stringr::str_length(library_match_sequence), stringr::str_sub(library_match_sequence, next_aa_i, next_aa_i), "")
    ) %>%
    dplyr::mutate(peptide = dplyr::case_when(
      prev_aa != "" ~ paste0(prev_aa, "_", peptide),
      next_aa != "" ~ paste0(peptide, "_", next_aa),
      TRUE ~ peptide
    ))
  peptides <- peptides %>%
    dplyr::select(1:(length(names(peptides)) - 5)) %>%
    dplyr::select(peptide, library_id, dplyr::everything()) %>%
    dplyr::select(-library_match_sequence, -library_real_sequence)

  # Converting 0 to NA
  peptides[peptides == 0] <- NA

  # Removing .mzmL extension from filenames
  new_names <- gsub("\\.mzML", "", names(peptides))
  names(peptides) <- new_names
  return(peptides)
}


#' check_file_is_valid
#'
#' Validate that an input data frame contains all expected columns.
#'
#' @param data A data frame read into R.
#' @param expected_names A character vector of expected column names.
#' @param tool_name A short string identifying the originating software
#' (e.g., "PEAKS", "PD",etc).
#' @return Raises an error (`stop`) with an informative message if required
#' columns are missing; otherwise returns `invisible(NULL)`.
#' @keywords internal

check_file_is_valid <- function(data, expected_names, tool_name) {
  missing_names <- expected_names[expected_names %!in% names(data)]
  if (length(missing_names) > 0) {
    stop(
      paste0(
        "This doesn't look like the expected ", tool_name, " file. ",
        "The following columns are missing: ",
        paste(missing_names, collapse = ", ")
      )
    )
  }
  invisible(NULL)
}

#' check_file_is_valid_peaks
#' Check to make sure the input data looks like the expected PEAKS file.
#' @param peaks_data protein-peptides-lfq.csv file generated by PEAKS read
#' into R.
#' @return a stop command with a informative message if file looks unexpected.
#' otherwise, nothing.
#' @keywords internal
check_file_is_valid_peaks <- function(peaks_data) {
  # These are the names of the columns expected to be in every PEAKS file
  expected_names <- c(
    "Protein Group", "Protein ID", "Protein Accession", "Peptide",
    "Used", "Candidate", "Quality", "Significance", "Avg. ppm", "Avg. Area",
    "Sample Profile (Ratio)", "Group Profile (Ratio)", "Max Ratio", "#Vector",
    "Start", "End", "PTM"
  )
  check_file_is_valid(peaks_data, expected_names, "PEAKS")
}


#' check_file_is_valid_fragpipe
#' Check to make sure the input data looks like the expected FragPipe file.
#' @param fragpipe_data combined_peptide.tsv file generated by FragPipe read
#' into R.
#'
#' @return a stop command with a informative message if file looks unexpected.
#' otherwise, nothing.
check_file_is_valid_fragpipe <- function(fragpipe_data) {
  # These are the names of the columns expected to be in every fragpipe file
  expected_names <- c(
    "Peptide Sequence", "Prev AA", "Next AA", "Start", "End", "Peptide Length",
    "Charges", "Protein", "Protein ID", "Entry Name", "Gene",
    "Protein Description", "Mapped Genes", "Mapped Proteins"
  )

  check_file_is_valid(fragpipe_data, expected_names, "Fragpipe")
}

#' check_file_is_valid_pd
#' Check to make sure the input data looks like the expected ProteomeDiscoverer
#' file.
#' @param pd_data PeptideGroups.txt file generated by ProteomeDiscover and read
#' into R.
#'
#' @return a stop command with a informative message if file looks unexpected.
#' otherwise, nothing.
check_file_is_valid_pd <- function(pd_data) {
  # These are the names of the columns expected to be in every PEAKS file
  expected_names <- c(
    "Peptide Groups Peptide Group ID", "Checked", "Confidence",
    "Annotated Sequence", "Modifications", "Qvality PEP",
    "Qvality q-value", "# Protein Groups", "# Proteins",
    "# PSMs", "Master Protein Accessions",
    "Positions in Master Proteins",
    "Modifications in Master Proteins",
    "# Missed Cleavages"
  )
  check_file_is_valid(pd_data, expected_names, "Proteome Discoverer")
}
#' check_file_is_valid_diann
#' Check to make sure the input data looks like the expected DIA-NN output
#' file.
#' @param diann_data pg_matrix.tsv file generated by DIA-NN and read
#' into R.
#'
#' @return a stop command with a informative message if file looks unexpected.
#' otherwise, nothing.
check_file_is_valid_diann <- function(diann_data) {
  expected_names <- c(
    "Protein.Group", "Protein.Ids", "Protein.Names", "Genes",
    "First.Protein.Description", "Proteotypic",
    "Stripped.Sequence", "Modified.Sequence",
    "Precursor.Charge", "Precursor.Id", "All Mapped Proteins",
    "All Mapped Genes"
  )

  check_file_is_valid(diann_data, expected_names, "DIA-NN")
}


#' check_file_is_valid_sage
#' Check to make sure the input data looks like the expected PEAKS file.
#' @param sage_data read in lfq.tsv file output prodcued by Sage
#' into R.
#' @return a stop command with a informative message if file looks unexpected.
#' otherwise, nothing.
#' @keywords internal
check_file_is_valid_sage <- function(sage_data) {
  # These are the names of the columns expected to be in every PEAKS file
  expected_names <- c(
    "peptide", "charge", "proteins", "q_value", "score", "spectral_angle"
  )
  check_file_is_valid(sage_data, expected_names, "sage")
}

#' Generalized cleavage function with dynamic column names
#'
#' Finds cleavage sequences for either N-terminal or C-terminal cleavages
#' relative to a peptide library sequence.
#'
#' @param peptide_sequence Peptide sequence, single-letter code. "_" denotes cleavage site.
#' @param library_match_sequence Sequence matched by proteomics software (may differ from real sequence).
#' @param library_real_sequence True peptide sequence.
#' @param n_residues Number of residues to include on each side of the cleavage site.
#' @param terminus "nterm" or "cterm", specifying which terminus to analyze.
#'
#' @return tibble with peptide, cleavage sequence, and cleavage position. Column names are
#' dynamically named based on the terminus.
#' @keywords internal
cleavage <- function(peptide_sequence,
                     library_match_sequence,
                     library_real_sequence,
                     n_residues = 4,
                     terminus = c("nterm", "cterm")) {
  terminus <- match.arg(terminus)
  has_cleavage <- grepl("_", peptide_sequence)

  # Return NA if no cleavage detected
  if (!has_cleavage) {
    return(tibble::tibble(
      peptide = peptide_sequence,
      !!terminus := NA_character_,
      !!paste0(terminus, "_cleavage_pos") := NA_integer_
    ))
  }

  # Pad library sequences with Xs
  n_x <- paste0(rep("X", n_residues), collapse = "")
  x_mod_match <- paste0(n_x, library_match_sequence, n_x)
  x_mod_real <- paste0(n_x, library_real_sequence, n_x)

  if (terminus == "cterm" && grepl("_.$", peptide_sequence)) {
    temp <- gsub("_", "", substr(peptide_sequence, 1, nchar(peptide_sequence) - 1))
    left_ref_start <- regexpr(temp, x_mod_match)[[1]]
    cleavage_pos <- left_ref_start + nchar(temp) - 1
  } else if (terminus == "nterm" && regexpr("_", peptide_sequence)[[1]] == 2) {
    temp <- gsub("_", "", substr(peptide_sequence, 3, nchar(peptide_sequence)))
    cleavage_pos <- regexpr(temp, x_mod_match)[[1]] - 1
  } else {
    return(tibble::tibble(
      peptide = peptide_sequence,
      !!terminus := NA_character_,
      !!paste0(terminus, "_cleavage_pos") := NA_integer_
    ))
  }

  # Extract left and right sequences around cleavage
  left_seq <- substr(x_mod_real, cleavage_pos - n_residues + 1, cleavage_pos)
  right_seq <- substr(x_mod_real, cleavage_pos + 1, cleavage_pos + n_residues)

  tibble::tibble(
    peptide = peptide_sequence,
    !!terminus := paste0(left_seq, right_seq),
    !!paste0(terminus, "_cleavage_pos") := regexpr(temp, library_match_sequence)[[1]] +
      ifelse(terminus == "cterm", nchar(temp) - 1, -1)
  )
}

#' N-terminal cleavage sequence extraction
#'
#' Wrapper for `cleavage()` that extracts the N-terminal cleavage sequence
#' and cleavage position from a peptide relative to its library sequence.
#'
#' @inheritParams cleavage
#' @return A tibble with columns:
#'   - `peptide`: the input peptide sequence
#'   - `nterm`: the N-terminal cleavage sequence (n residues on each side)
#'   - `nterm_cleavage_pos`: the position of the N-terminal cleavage in the library sequence
#' @keywords internal
nterm_cleavage <- function(...) cleavage(..., terminus = "nterm")

#' C-terminal cleavage sequence extraction
#'
#' Wrapper for `cleavage()` that extracts the C-terminal cleavage sequence
#' and cleavage position from a peptide relative to its library sequence.
#'
#' @inheritParams cleavage
#' @return A tibble with columns:
#'   - `peptide`: the input peptide sequence
#'   - `cterm`: the C-terminal cleavage sequence (n residues on each side)
#'   - `cterm_cleavage_pos`: the position of the C-terminal cleavage in the library sequence
#' @keywords internal
cterm_cleavage <- function(...) cleavage(..., terminus = "cterm")
#' add_cleavages
#'
#' Adds cleavage information to a tibble by wraping the n_term_cleavage
#' and c_term_cleavage functions into a consolidated function.
#'
#' @param joined_with_library  a tibble containing columns named "peptide",
#' "library_match_sequence", and "library_real_sequence".
#' @param n_residues the number of residues to the left and right of the
#'  cleavage site to include in the output.
#' @return a tibble with cleavage information added.
#' @keywords internal
add_cleavages <- function(joined_with_library, n_residues = 4) {
  # Iterating through and applying nterm_clevage
  nterm <- purrr::pmap_df(
    list(
      joined_with_library$peptide,
      joined_with_library$library_match_sequence,
      joined_with_library$library_real_sequence,
      n_residues
    ),
    nterm_cleavage
  )
  # Iterating though and applying cterm_cleavage
  cterm <- purrr::pmap_df(
    list(
      joined_with_library$peptide,
      joined_with_library$library_match_sequence,
      joined_with_library$library_real_sequence,
      n_residues
    ),
    cterm_cleavage
  )
  # Combining nterm and cterm
  cleavages <- dplyr::bind_cols(nterm, cterm[, 2:3])
  joined_with_library <- dplyr::select(joined_with_library, -"peptide")
  # Building final data frame.
  output <- dplyr::bind_cols(cleavages, joined_with_library)
  return(output)
}

#' consolidate_cleavages
#'
#' Consolidate the n term and c term cleavage data. The nterm and cterm
#' cleavage information  are consolidated into a single column and rows
#  that have both nterm and cterm cleavage information are removed.
#'
#' @param cleavage_added_data a tibble where cleavage information has
#' been added by add_cleavages()
#'
#' @return a tibble with the cleavage information combined into a single column
#'  and rows with no cleavage information or double information removed.
#' @keywords internal
consolidate_cleavages <- function(cleavage_added_data) {
  out <- cleavage_added_data %>%
    # consolidating cleavage sequence
    dplyr::mutate(cleavage_seq = dplyr::case_when(
      !is.na(.data$nterm) & is.na(.data$cterm) ~ .data$nterm,
      !is.na(.data$cterm) & is.na(.data$nterm) ~ .data$cterm,
      TRUE ~ NA_character_
    ), .after = "cterm_cleavage_pos") %>%
    # Removing peptides with double cleavages
    dplyr::filter(!(!is.na(.data$cterm) & !is.na(.data$nterm))) %>%
    dplyr::mutate(cleavage_pos = dplyr::case_when(
      is.na(.data$cterm_cleavage_pos) ~ .data$nterm_cleavage_pos,
      TRUE ~ .data$cterm_cleavage_pos
    ), .after = "cleavage_seq") %>%
    # Adding character specifying what are cleaved vs not
    dplyr::mutate(
      peptide_type = dplyr::case_when(
        is.na(.data$cleavage_pos) ~ "full_length",
        TRUE ~ "cleavage_product"
      ),
      .after = "cleavage_pos"
    ) %>%
    dplyr::select(
      -"nterm", -"cterm", -"nterm_cleavage_pos",
      -"cterm_cleavage_pos"
    )
  return(out)
}
#' convert prepared data to a QFeatures object
#'
#' @param prepared_data data prepared within one of the prepare functions
#' @param colData  sample metadata
#' @param peptide_library the peptide library used.
#' @param n_residues the number of residues reported in the cleavage site
#'
#' @return a QFeatures object
#' @keywords internal
prepared_to_qf <- function(prepared_data,
                           colData,
                           peptide_library = mspms::peptide_library,
                           n_residues = 4) {
  # adding peptide length to prepared_data
  prepared_data <- prepared_data %>%
    dplyr::mutate(
      peptide_length = gsub("^._", "", peptide),
      peptide_length = nchar(gsub("_.$", "", peptide_length)),
      .after = peptide
    )
  # check peptide library for correct names.
  check_peptide_library(peptide_library)
  # Making sure that prepared_data and peptide library are consistent
  peptide_library_ids <- peptide_library$library_id
  peptide_library_ids_data <- unique(prepared_data$library_id)
  missing <- peptide_library_ids_data[peptide_library_ids_data %!in%
    peptide_library_ids]
  missing_mes <- paste0(missing, collapse = ",")
  if (length(missing > 1)) {
    stop("There are peptide library ids in your data that are not in your
         peptide library. Specificially ", missing_mes, "are missing from your
         peptide library.")
  }
  # combining peptide sequences
  combined <- dplyr::inner_join(peptide_library, prepared_data,
    by = "library_id"
  ) %>%
    add_cleavages(n_residues = n_residues) %>%
    consolidate_cleavages()
  name_in_prepared_data <- names(prepared_data)[3:length(prepared_data)]
  n_coldata_nin_prepared_data <- sum(colData$quantCols %!in%
    name_in_prepared_data)
  missing_name <- paste0(
    name_in_prepared_data[
      colData$quantCols %!in% name_in_prepared_data
    ],
    collapse = " "
  )
  if (n_coldata_nin_prepared_data > 0) {
    stop(
      "the quantCol names in your colData do not match those in your",
      " proteomics data. Specifically the column(s) ", missing_name,
      " are present in your proteomics data but not in your",
      " colData"
    )
  }
  # Need columns in the combined data frame to be in the same order as colData
  # Extract the ordered sample names (columns 9 onward in combined)
  order_in_combined <- names(combined)[9:ncol(combined)]

  # arrange colData to be in the same order
  colData <- colData |>
    dplyr::arrange(factor(quantCols, levels = order_in_combined))

  QF <- QFeatures::readQFeatures(combined,
    quantCols = 9:length(combined),
    fnames = "peptide",
    colData = colData,
    name = "peptides"
  )
  return(QF)
}

#' load_colData
#'
#' load a .csv file containing sample colData. Check for errors
#'
#' @param colData_filepath filepath to .csv file containing colData.
#'
#' @return a tibble
#' @keywords internal

load_colData <- function(colData_filepath) {
  colData <- readr::read_csv(colData_filepath)
  # Expected names
  `%!in%` <- Negate(`%in%`)
  expected_names <- c("quantCols", "group", "condition", "time")
  colData_names <- names(colData)
  unexpected_names <- expected_names %!in% colData_names
  n_unexpected_names <- sum(unexpected_names)
  if (n_unexpected_names > 0) {
    missing_names <- expected_names[unexpected_names]
    stop(
      paste0(c("colData must have columns named \"quantCols\",\"group\",
    \"condition\", and \"time\" ", "you are missing ", paste(missing_names,
        collapse = ", "
      ))),
      collapse = ""
    )
  }
  # Check if the column types match
  expected_types <- c("character", "character", "character", "numeric")
  colData_types <- sapply(colData, class)
  unexpected_types <- (colData_types != expected_types[1:4])
  n_unexpected_types <- sum(unexpected_types)

  if (n_unexpected_types > 0) {
    missing_types <- names(colData)[unexpected_types]
    stop(paste0(
      "colData columns must be as follows: quantCols = character,
    group = character, condition = character, time = numeric.",
      "You have the wrong type for the following column(s): ",
      paste(missing_types, collapse = ", ")
    ))
  }
  # Check to make sure none of the columns have spaces in them
  n_spaces <- sum(sapply(colData, function(x) {
    grepl(".* .*", x)
  }))
  if (n_spaces > 0) {
    stop("Your colData has spaces in it (ie condition = Cathepsin A). Please
    change it to not contain any spaces to be compatible with limma (ie
    condition  = cathepsin_A)")
  }
  return(colData)
}

#' check_peptide_library
#'
#' @param peptide_library
#'
#' @return an informative error if the column names of the peptide library are
#' unexpected. Otherwise nothing.
#' @keywords internal

check_peptide_library <- function(peptide_library) {
  pl_names <- names(peptide_library)
  if (!identical(pl_names, c(
    "library_id",
    "library_match_sequence",
    "library_real_sequence"
  ))) {
    stop("the first three columns of the peptide library .csv are not as
         expected. They must be library_id, library_match_sequence, and
         library_real_sequence")
  }
}


#' check_peptide_library
#'
#' @param peptide_library
#'
#' @return an informative error if the column names of the peptide library are
#' unexpected. Otherwise nothing.
#' @keywords internal

# Testing for case where there is no cleavage site
testthat::test_that("works with no cleavage site", {
  testthat::expect_equal(
    mspms:::nterm_cleavage(
      "ABCDEFGHIJKLMN", "ABCDEFGHIJKLMN",
      "ABCDEFGHIJKLMN", 4
    ),
    tibble::tibble(
      peptide = "ABCDEFGHIJKLMN",
      nterm = NA_character_,
      nterm_cleavage_pos = NA_integer_
    )
  )
})


# Testing for case where there is no cleavage site
testthat::test_that("works with one clevage site", {
  testthat::expect_equal(
    mspms:::nterm_cleavage(
      "A_BCDEFGHIJKLM_N", "ABCDEFGHIJKLMN",
      "ABCDEFGHIJKLMN", 4
    ),
    tibble::tibble(
      peptide = "A_BCDEFGHIJKLM_N",
      nterm = "XXXABCDE",
      nterm_cleavage_pos = 1
    )
  )
})


# Testing for case where there are two cleavage sites
testthat::test_that("works with two clevage site", {
  testthat::expect_equal(
    mspms:::nterm_cleavage(
      "A_BCDEFGHIJKLM_N", "ABCDEFGHIJKLMN",
      "ABCDEFGHIJKLMN", 4
    ),
    tibble::tibble(
      peptide = "A_BCDEFGHIJKLM_N",
      nterm = "XXXABCDE",
      nterm_cleavage_pos = 1
    )
  )
})


# Testing for case where we look for 6 AAs past the cleavage site
testthat::test_that("works with 6 AA past", {
  testthat::expect_equal(
    mspms:::nterm_cleavage(
      "A_BCDEFGHIJKLM_N", "ABCDEFGHIJKLMN",
      "ABCDEFGHIJKLMN", 6
    ),
    tibble::tibble(
      peptide = "A_BCDEFGHIJKLM_N",
      nterm = "XXXXXABCDEFG",
      nterm_cleavage_pos = 1
    )
  )
})


# Testing for extreme case
testthat::test_that("works with 10 AA past", {
  testthat::expect_equal(
    mspms:::nterm_cleavage(
      "A_BCDEFGHIJKLM_N", "ABCDEFGHIJKLMN",
      "ABCDEFGHIJKLMN", 10
    ),
    tibble::tibble(
      peptide = "A_BCDEFGHIJKLM_N",
      nterm = "XXXXXXXXXABCDEFGHIJK",
      nterm_cleavage_pos = 1
    )
  )
})

# Testing for case where there is no cleavage site
testthat::test_that("works with no cleavage site", {
  testthat::expect_equal(
    mspms:::cterm_cleavage("ABCDEFGHIJKLMN"),
    tibble::tibble(
      peptide = "ABCDEFGHIJKLMN",
      cterm = NA_character_,
      cterm_cleavage_pos = NA_integer_
    )
  )
})


# Testing for case where there is no cleavage site
testthat::test_that("works with one clevage site", {
  testthat::expect_equal(
    mspms:::cterm_cleavage(
      "ABCDEFGHIJKLM_N", "ABCDEFGHIJKLMN",
      "ABCDEFGHIJKLMN", 4
    ),
    tibble::tibble(
      peptide = "ABCDEFGHIJKLM_N",
      cterm = "JKLMNXXX",
      cterm_cleavage_pos = 13
    )
  )
})


# Testing for case where there are two cleavage sites
testthat::test_that("works with two clevage site", {
  peptide_sequence <- "A_BCDEFGHIJKLM_N"
  library_match_sequence <- "ABCDEFGHIJKLMN"
  library_real_sequence <- "ABCDEFGHIJKLMN"
  n_residues <- 4
  testthat::expect_equal(
    mspms:::cterm_cleavage(
      "A_BCDEFGHIJKLM_N", "ABCDEFGHIJKLMN",
      "ABCDEFGHIJKLMN", 4
    ),
    tibble::tibble(
      peptide = "A_BCDEFGHIJKLM_N",
      cterm = "JKLMNXXX",
      cterm_cleavage_pos = 13
    )
  )
})


# Testing for case where we look for 6 AAs past the cleavage site
testthat::test_that("works with 6 AA past", {
  testthat::expect_equal(
    mspms:::cterm_cleavage(
      "A_BCDEFGHIJKLM_N", "ABCDEFGHIJKLMN",
      "ABCDEFGHIJKLMN", 6
    ),
    tibble::tibble(
      peptide = "A_BCDEFGHIJKLM_N",
      cterm = "HIJKLMNXXXXX",
      cterm_cleavage_pos = 13
    )
  )
})


# Testing for extreme case
testthat::test_that("works with 10 AA past", {
  testthat::expect_equal(
    mspms:::cterm_cleavage(
      "A_BCDEFGHIJKLM_N", "ABCDEFGHIJKLMN",
      "ABCDEFGHIJKLMN", 10
    ),
    tibble::tibble(
      peptide = "A_BCDEFGHIJKLM_N",
      cterm = "DEFGHIJKLMNXXXXXXXXX",
      cterm_cleavage_pos = 13
    )
  )
})

### check_file_is_valid_peaks()###
test_that("check_file_is_valid_peaks() works when PTM is provided.", {
  peaks_ptm <- readr::read_csv(system.file(
    "extdata/peaks_protein-peptides-lfq.csv",
    package = "mspms"
  )) %>%
    dplyr::mutate(PTM = "PTM")
  expect_no_error(mspms:::check_file_is_valid_peaks(peaks_ptm))
})

### check_file_is_valid_fragpipe()###
test_that("check_file_is_valid_fragpipe() errors when peaks file is
          provided.", {
  peaks_ptm <- readr::read_csv("tests/testdata/
                               check_file_is_valid_peaks_ptm.csv")
  expect_error(mspms:::check_file_is_valid_fragpipe(peaks_ptm))
})

### Testing cleavage function ###

test_that("cleavage() works as expected with n_residue = 1", {
  peptide_sequence <- "G_HIDHL"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 1,
    terminus = "nterm"
  )

  expect_equal(out$nterm, "GH")
  expect_equal(out$nterm_cleavage_pos, 9)
})


### Testing nterm cleavages ###

test_that("nterm_cleavages() works as expected with n_residue = 1", {
  peptide_sequence <- "G_HIDHL"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::nterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 1
  )

  expect_equal(out$nterm, "GH")
  expect_equal(out$nterm_cleavage_pos, 9)
})

test_that("nterm_cleavage() works as expected with n_residue = 2", {
  peptide_sequence <- "G_HIDHL"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::nterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 2
  )

  expect_equal(out$nterm, "FGHI")
  expect_equal(out$nterm_cleavage_pos, 9)
})

test_that("nterm_cleavage() works as expected with n_residue = 3", {
  peptide_sequence <- "G_HIDHL"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::nterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 3
  )

  expect_equal(out$nterm, "EFGHID")
  expect_equal(out$nterm_cleavage_pos, 9)
})


test_that("nterm_cleavage() works as expected with n_residue = 4", {
  peptide_sequence <- "G_HIDHL"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::nterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 4
  )

  expect_equal(out$nterm, "YEFGHIDH")
  expect_equal(out$nterm_cleavage_pos, 9)
})

test_that("nterm_cleavages() works as expected with n_residue = 5", {
  peptide_sequence <- "G_HIDHL"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::nterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 5
  )

  expect_equal(out$nterm, "VYEFGHIDHL")
  expect_equal(out$nterm_cleavage_pos, 9)
})

test_that("nterm_cleavages() works as expected with n_residue = 6", {
  peptide_sequence <- "G_HIDHL"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::nterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 6
  )

  expect_equal(out$nterm, "TVYEFGHIDHLX")
  expect_equal(out$nterm_cleavage_pos, 9)
})

test_that("nterm_cleavages() works as expected with n_residue = 7", {
  peptide_sequence <- "G_HIDHL"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::nterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 7
  )

  expect_equal(out$nterm, "ATVYEFGHIDHLXX")
  expect_equal(out$nterm_cleavage_pos, 9)
})

test_that("nterm_cleavages() works as expected with n_residue = 8", {
  peptide_sequence <- "G_HIDHL"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::nterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 8
  )

  expect_equal(out$nterm, "VATVYEFGHIDHLXXX")
  expect_equal(out$nterm_cleavage_pos, 9)
})

test_that("nterm_cleavages() works as expected with n_residue = 9", {
  peptide_sequence <- "G_HIDHL"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::nterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 9
  )

  expect_equal(out$nterm, "LVATVYEFGHIDHLXXXX")
  expect_equal(out$nterm_cleavage_pos, 9)
})

test_that("nterm_cleavages() works as expected with n_residue = 10", {
  peptide_sequence <- "G_HIDHL"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::nterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 10
  )

  expect_equal(out$nterm, "XLVATVYEFGHIDHLXXXXX")
  expect_equal(out$nterm_cleavage_pos, 9)
})

test_that("nterm_cleavages() works as expected with n_residue = 11", {
  peptide_sequence <- "G_HIDHL"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::nterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 11
  )

  expect_equal(out$nterm, "XXLVATVYEFGHIDHLXXXXXX")
  expect_equal(out$nterm_cleavage_pos, 9)
})

test_that("nterm_cleavages() works as expected with n_residue = 12", {
  peptide_sequence <- "G_HIDHL"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::nterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 12
  )

  expect_equal(out$nterm, "XXXLVATVYEFGHIDHLXXXXXXX")
  expect_equal(out$nterm_cleavage_pos, 9)
})

test_that("nterm_cleavages() works as expected with n_residue = 13", {
  peptide_sequence <- "G_HIDHL"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::nterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 13
  )

  expect_equal(out$nterm, "XXXXLVATVYEFGHIDHLXXXXXXXX")
  expect_equal(out$nterm_cleavage_pos, 9)
})

test_that("nterm_cleavages() works as expected with n_residue = 14", {
  peptide_sequence <- "G_HIDHL"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::nterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 14
  )

  expect_equal(out$nterm, "XXXXXLVATVYEFGHIDHLXXXXXXXXX")
  expect_equal(out$nterm_cleavage_pos, 9)
})


test_that("nterm_cleavages() finds correct position", {
  peptide_sequence <- "T_VYEFGH"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::nterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 4
  )

  expect_equal(out$nterm, "LVATVYEF")
  expect_equal(out$nterm_cleavage_pos, 4)
})


### Testing Cterm ###

test_that("cterm_cleavages() works as expected with n_residue = 1", {
  peptide_sequence <- "GHIDH_L"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::cterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 1
  )

  expect_equal(out$cterm, "HL")
  expect_equal(out$cterm_cleavage_pos, 13)
})

test_that("cterm_cleavages() works as expected with n_residue = 2", {
  peptide_sequence <- "GHIDH_L"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::cterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 2
  )

  expect_equal(out$cterm, "DHLX")
  expect_equal(out$cterm_cleavage_pos, 13)
})

test_that("cterm_cleavages() works as expected with n_residue = 3", {
  peptide_sequence <- "GHIDH_L"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::cterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 3
  )

  expect_equal(out$cterm, "IDHLXX")
  expect_equal(out$cterm_cleavage_pos, 13)
})

test_that("cterm_cleavages() works as expected with n_residue = 4", {
  peptide_sequence <- "GHIDH_L"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::cterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 4
  )

  expect_equal(out$cterm, "HIDHLXXX")
  expect_equal(out$cterm_cleavage_pos, 13)
})

test_that("cterm_cleavages() works as expected with n_residue = 5", {
  peptide_sequence <- "GHIDH_L"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::cterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 5
  )

  expect_equal(out$cterm, "GHIDHLXXXX")
  expect_equal(out$cterm_cleavage_pos, 13)
})

test_that("cterm_cleavages() works as expected with n_residue = 6", {
  peptide_sequence <- "GHIDH_L"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::cterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 6
  )

  expect_equal(out$cterm, "FGHIDHLXXXXX")
  expect_equal(out$cterm_cleavage_pos, 13)
})

test_that("cterm_cleavages() works as expected with n_residue = 7", {
  peptide_sequence <- "GHIDH_L"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::cterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 7
  )

  expect_equal(out$cterm, "EFGHIDHLXXXXXX")
  expect_equal(out$cterm_cleavage_pos, 13)
})

test_that("cterm_cleavages() works as expected with n_residue = 8", {
  peptide_sequence <- "GHIDH_L"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::cterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 8
  )

  expect_equal(out$cterm, "YEFGHIDHLXXXXXXX")
  expect_equal(out$cterm_cleavage_pos, 13)
})

test_that("cterm_cleavages() works as expected with n_residue = 9", {
  peptide_sequence <- "LVATVYEFGHIDH_L"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::cterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 9
  )

  expect_equal(out$cterm, "VYEFGHIDHLXXXXXXXX")
  expect_equal(out$cterm_cleavage_pos, 13)
})


test_that("cterm_cleavages() works as expected with n_residue = 10", {
  peptide_sequence <- "LVATVYEFGHIDH_L"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::cterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 10
  )

  expect_equal(out$cterm, "TVYEFGHIDHLXXXXXXXXX")
  expect_equal(out$cterm_cleavage_pos, 13)
})

test_that("cterm_cleavages() works as expected with n_residue = 11", {
  peptide_sequence <- "LVATVYEFGHIDH_L"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::cterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 11
  )

  expect_equal(out$cterm, "ATVYEFGHIDHLXXXXXXXXXX")
  expect_equal(out$cterm_cleavage_pos, 13)
})

test_that("cterm_cleavages() works as expected with n_residue = 12", {
  peptide_sequence <- "LVATVYEFGHIDH_L"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::cterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 12
  )

  expect_equal(out$cterm, "VATVYEFGHIDHLXXXXXXXXXXX")
  expect_equal(out$cterm_cleavage_pos, 13)
})

test_that("cterm_cleavages() works as expected with n_residue = 13", {
  peptide_sequence <- "LVATVYEFGHIDH_L"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::cterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 13
  )

  expect_equal(out$cterm, "LVATVYEFGHIDHLXXXXXXXXXXXX")
  expect_equal(out$cterm_cleavage_pos, 13)
})

test_that("cterm_cleavages() works as expected with n_residue = 14", {
  peptide_sequence <- "LVATVYEFGHIDH_L"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"


  out <- mspms:::cterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 14
  )

  expect_equal(out$cterm, "XLVATVYEFGHIDHLXXXXXXXXXXXXX")
  expect_equal(out$cterm_cleavage_pos, 13)
})

test_that("cterm_cleavages() finds correct position", {
  peptide_sequence <- "VATV_Y"
  library_match_sequence <- "LVATVYEFGHIDHL"
  library_real_sequence <- "LVATVYEFGHIDHL"

  out <- mspms:::cterm_cleavage(peptide_sequence,
    library_match_sequence,
    library_real_sequence,
    n_residues = 4
  )

  expect_equal(out$cterm, "VATVYEFG")
  expect_equal(out$cterm_cleavage_pos, 5)
})


### consolidate_cleavages()###

test_that("consolidate_cleavages() removes double cleaved peptides", {
  test <- tibble::tibble(
    peptide = "P_AAAAAAAAAAAAA",
    nterm = "P_AAAAAAAA_P",
    nterm_cleavage_pos = 5,
    cterm = "P_AAAAAAA_P",
    cterm_cleavage_pos = 5
  )
  nrow <- nrow(mspms:::consolidate_cleavages(test))
  expect_equal(nrow, 0)
})

### prepared_to_qf ###
test_that("prepared_to_qf() generates an error when supplied a QFeatures
          object", {
  expect_error(mspms:::prepared_to_qf(mspms::peaks_prepared_data,
    colData = mspms::colData
  ))
})


test_that("prepared_to_qf() fails with unexpected colData", {
  prepared_data <- mspms::processed_qf %>%
    mspms_tidy("peptides") %>%
    dplyr::select(peptide, library_id, quantCols, peptides) %>%
    tidyr::pivot_wider(names_from = "quantCols", values_from = "peptides")

  wrong_col_data <- mspms::colData %>%
    dplyr::mutate(quantCols = 1:length(quantCols))

  expect_error(mspms:::prepared_to_qf(prepared_data, wrong_col_data))
})

test_that("prepared_to_qf() works with expected colData", {
  prepared_data <- mspms::processed_qf %>%
    mspms_tidy("peptides") %>%
    dplyr::select(peptide, library_id, quantCols, peptides) %>%
    tidyr::pivot_wider(names_from = "quantCols", values_from = "peptides")

  expect_no_error(mspms:::prepared_to_qf(prepared_data, mspms::colData))
})

### load_colData() ###
test_that("load_colData() generates expected expected error when colData is
          off", {
  expect_error(
    mspms:::load_colData(
      "tests/testdata/missing_time.csv",
      "colData must have columns named \"quantCols\",\"group\",
                       \"condition\", and \"time\" you are missing time"
    )
  )
})

#' plot_heatmap
#'
#' This produces a heatmaply interactive heatmap of the QFeatures object with
#' color bars representing the condition and time for each sample in each row.
#'
#' Each column has a colored bar representing whether the peptide is a
#' cleavage product or a full length member of the peptide library.
#'
#' @param mspms_tidy_data tidy mspms data (prepared from QFeatures object
#' by mspms_tidy())
#' @param value_colname the name of the column containing values.
#' @param scale how would you like the data scaled? default is none,
#'  but can also be "row", "column", or "none"
#' @param plot_method what plot method would you like to use, can use
#' plotly or ggplot2.
#' @param show_dendrogram Logical vector of length two, controlling whether
#' the row and/or column dendrograms are displayed. If a logical scalar is
#' provided, it is repeated to become a logical vector of length two.

#' @return a heatmaply interactive heatmap
#' @export
#'
#' @examples
#' plot_heatmap(mspms::mspms_tidy_data)
plot_heatmap <- function(mspms_tidy_data,
                         value_colname = "peptides_norm",
                         scale = "column",
                         plot_method = "plotly",
                         show_dendrogram = c(TRUE, TRUE)) {
  value_colname <- dplyr::sym(value_colname)
  heatmap_data <- mspms_tidy_data %>%
    dplyr::select(
      "quantCols", "condition", "time",
      "peptide", !!value_colname
    ) %>%
    tidyr::pivot_wider(
      names_from = "peptide",
      values_from = "peptides_norm",
      values_fn = NULL,
    ) %>%
    tibble::column_to_rownames("quantCols")
  values <- heatmap_data %>%
    dplyr::select(-"condition", -"time") %>%
    as.matrix()
  colors <- heatmap_data %>%
    dplyr::select("condition", "time")
  peptide_order <- colnames(values)
  mat <- mspms_tidy_data %>%
    dplyr::select("quantCols", "peptide", "cleavage_seq") %>%
    tidyr::pivot_wider(
      names_from = "peptide",
      values_from = "cleavage_seq"
    ) %>%
    tibble::column_to_rownames("quantCols") %>%
    dplyr::select(dplyr::all_of(peptide_order)) %>%
    as.matrix()
  # Creating column labels for whether a peptide is cleaved or not
  col_logic <- grepl(".*_.*", colnames(values))
  col_p_colors <- c("cleavage_product", "full_length")
  col_colors <- data.frame(peptide_type = ifelse(col_logic,
    col_p_colors[1],
    col_p_colors[2]
  ))
  heatmaply::heatmaply(values,
    scale = scale,
    showticklabels = c(FALSE, TRUE),
    custom_hovertext = mat,
    row_side_colors = colors,
    col_side_colors = col_colors,
    plot_method = plot_method,
    show_dendrogram = show_dendrogram
  )
}

test_that("plot_heatmap() produces no error with expected data", {
  expect_no_error(plot_heatmap(mspms::mspms_tidy_data))
})

test_that("plot_heatmap() produces error with bad argument", {
  expect_error(plot_heatmap(mspms::mspms_tidy_data, scale = "wrong_arg"))
})

#' all_possible_8mers_from_228_library
#' All possible 8mers from the standard (as of 26April2024)
#' 228 MSP-MS peptide library
#' (This is equivalent to the result of
#' mspms::calculate_all_cleavages(mspms::peptide_library$real_cleavage_seq,n=4))
#' vector of the 14 AA peptides used in the library.
#' @format ## `all_possible_8mers_from_228_library`
#' A vector with 2964 entries
#' @source <standard peptide library used with MSP-MS method
#' in the O’Donoghue lab as of 26April2024>
"all_possible_8mers_from_228_library"

#' peptide_library
#'
#' This is the 228 peptide library used by the O’Donoghue lab as of 26April2024.
#' @format ## `peptide_library`
#' A  data frame with 228 rows and 3 columns:
#' \describe{
#'   \item{library_reference_id}{reference id of the detected peptide as
#'   put in upstream software}
#'   \item{library_match_sequence}{the sequence match to the peptide library,
#'    methionine is replaced with norleucine,which should function the same as
#'     methionine for proteases but has the same mass as L}
#'   \item{library_real_sequence}{Ls corresponding to norleucine are replaced
#'    back with n (for norleucine )}
#'   ...
#' }
#' @source <O’Donoghue lab as of 26April2024 >
"peptide_library"
#' peaks_prepared_data
#' A QFeatures object prepared from PEAKS data of cathepsin data/.
#' @format ## `peaks_prepared_data`
#' An instance of class QFeatures containing 1 assays:
#' [1] peptides: SummarizedExperiment with 2071 rows and 42 columns
#' \describe{
#'   \item{peptides}{Peptide Sequence Detected}
#'   ...
#' }
#' @source <mspms processed data originally from PEAKS files found in
#'  "tests/testdata/protein-peptides-id.csv" and
#'  "tests/testdata/protein-peptides-lfq.csv">
"peaks_prepared_data"

#' processed_qf
#' A QFeatures object prepared from PEAKS data of Cathepsin data that has been
#' processed (imputation/normalization)
#' @format ## `peaks_prepared_data`
#' An instance of class QFeatures containing 5 assays:
#' [1] peptides: SummarizedExperiment with 2071 rows and 42 columns
#' [2] peptides_log: SummarizedExperiment with 2071 rows and 42 columns
#' [3] peptides_log_norm: SummarizedExperiment with 2071 rows and 42 columns
#' [4] peptides_log_impute_norm: SummarizedExperiment with 2071 rows and 42
#' columns
#' [5] peptides_norm: SummarizedExperiment with 2071 rows and 42 columns
#' \describe{
#'   \item{peptides}{Peptide Sequence Detected}
#'   ...
#' }
#' @source <mspms processed data originally from PEAKS files found in
#'  "tests/testdata/protein-peptides-id.csv" and
#'  "tests/testdata/protein-peptides-lfq.csv">
"processed_qf"


#' log2fc_t_test_data
#' A tibble containing the results of t-tests and log2fc compared to time 0
#' 14,497 × 19
#' @format ## `peaks_prepared_data`
#' A tibble: 14,497 × 19
#' @source <mspms processed data originally from PEAKS files found in
#'  "tests/testdata/protein-peptides-id.csv" and
#'  "tests/testdata/protein-peptides-lfq.csv">
"log2fc_t_test_data"

#' colData
#' A tibble containing the colData associated with an experiment to proc
#' @format ## `colData`
#' A tibble: 42 × 4
#' @source colData corresponding to cathepsin A-D MSP-MS experiment
"colData"

#' mspms_tidy_data
#' A tibble containing tidy data derived from QFeatures object
#' @format ## `mspms_tidy_data`
#' A tibble:
#' @source processed_qf
"mspms_tidy_data"

#' plot_all_icelogos
#'
#' Easily plot a iceLogo corresponding to peptides of interest across each
#' condition of an experiment.
#' @param sig_cleavage_data a tibble of data of interest containing a column
#' labeled peptide, cleavage_seq, and condition
#' @param pval this is the pvalue threshold (<=) to consider significant when
#' determining the significance of the sig_cleavages relative to the background
#' at each position of the iceLogo.
#' @param type this is the type of iceLogo you would like to generate,
#'  can be either "percent_difference" or "fold_change".
#' @param background_universe this is a list cleavages you would like to compare
#' to as background of the iceLogo
#'
#' @return a ggplot object that shows the motif of the cleavage sequences
#' @export
#' @examples
#' # Determining cleavages of interest
#' sig_cleavage_data <- mspms::log2fc_t_test_data %>%
#'   dplyr::filter(p.adj <= 0.05, log2fc > 3)
#' # Plotting a iceLogo for each condition.
#' plot_all_icelogos(sig_cleavage_data)
plot_all_icelogos <- function(sig_cleavage_data,
                              type = "percent_difference",
                              pval = 0.05,
                              background_universe =
                                mspms::all_possible_8mers_from_228_library) {
  # initiating plot list
  plot_list <- list()
  # Plotting Icelogos
  for (i in unique(sig_cleavage_data$condition)) {
    # filtering data
    f <- dplyr::filter(sig_cleavage_data, .data$condition == i) %>%
      dplyr::select("peptide", "cleavage_seq") %>%
      # appending peptide to cleavage_seqs
      dplyr::pull(.data$cleavage_seq) %>%
      unique()
    # generating ice logo
    out <- mspms::plot_icelogo(f,
      type = type, pval = pval,
      background_universe = background_universe
    ) +
      ggplot2::ggtitle(i)
    plot_list[[i]] <- out
  }
  p1 <- do.call(ggpubr::ggarrange, c(plot_list,
    nrow = length(unique(sig_cleavage_data$condition)),
    common.legend = TRUE, legend = "bottom"
  ))
  return(p1)
}

#' mspms_tidy
#' Convert a SummarizedExperiment object within a QFeatures object
#' into a tidy tibble.
#'
#' @param processed_qf a QFeature object containing rowData and colData.
#' @param se_name  the name of the SummarizedExperiment you would like to
#' extract
#'
#' @return a tibble containing all the rowData, colData, and assay data for the
#' specified SummarizedExperiment.
#'
#' @export
#' @examples
#' mspms_data <- mspms_tidy(mspms::processed_qf)
mspms_tidy <- function(processed_qf, se_name = "peptides_norm") {
  . <- NULL
  # Extracting assay data
  assay_data <- SummarizedExperiment::assay(processed_qf[[se_name]]) %>%
    as.data.frame() %>%
    tibble::rownames_to_column("peptide") %>%
    tidyr::pivot_longer(2:length(.),
      names_to = "quantCols",
      values_to = se_name
    )
  # Extracting colData
  colData <- SummarizedExperiment::colData(processed_qf) %>%
    SummarizedExperiment::as.data.frame() %>%
    tibble::remove_rownames()
  # Extracting row data
  rowData <- SummarizedExperiment::rowData(processed_qf[[se_name]]) %>%
    SummarizedExperiment::as.data.frame() %>%
    tibble::remove_rownames()
  long <- dplyr::inner_join(colData, assay_data)
  tidy <- dplyr::inner_join(rowData, long, by = "peptide") %>%
    tibble::as_tibble()
  return(tidy)
}

test_that("mspms_tidy() returns a tibble with the expected colnames", {
  expected_colData_names <- c("quantCols", "time", "condition", "group")
  expected_rowData_names <- c(
    "peptide",
    "peptide_type",
    "library_match_sequence",
    "library_real_sequence",
    "library_id",
    "cleavage_seq",
    "cleavage_pos"
  )
  expected_value_name <- "peptides_norm"
  expected_names <- c(
    expected_colData_names, expected_rowData_names,
    expected_value_name
  )
  tidy <- mspms_tidy(mspms::processed_qf)
  colnames <- colnames(tidy)
  n_missing <- sum(expected_names %!in% colnames)
  expect_equal(n_missing, 0)
})

#' plot_time_course
#'
#' Easily plot a time course of all peptides in a QFeatures object by
#' peptide.
#'
#'
#' @param mspms_tidy_data tidy mspms data (prepared from QFeatures object
#' by mspms_tidy())
#' @param value_colname the name of the column containing values.
#' @param summarize_by_mean whether to summarise by mean (TRUE- show error bars
#' +- 1 standard deviation) or not (FALSE)
#'
#' @return a ggplot2 object
#' @export
#'
#' @examples
#' # Determining peptide of interest
#' max_log2fc_pep <- mspms::log2fc_t_test_data %>%
#'   dplyr::filter(p.adj <= 0.05, log2fc > 3) %>%
#'   dplyr::filter(log2fc == max(log2fc)) %>%
#'   dplyr::pull(peptide)
#'
#' # Defining QFeatures filter
#' filtered <- mspms::mspms_tidy_data %>%
#'   dplyr::filter(peptide == max_log2fc_pep) %>%
#'   plot_time_course()
plot_time_course <- function(mspms_tidy_data,
                             value_colname = "peptides_norm",
                             summarize_by_mean = FALSE) {
  value_colname <- dplyr::sym(value_colname)
  if (isTRUE(summarize_by_mean)) {
    p1 <- mspms_tidy_data %>%
      dplyr::group_by(
        .data$peptide, .data$condition, .data$time,
        .data$cleavage_seq
      ) %>%
      dplyr::summarize(
        mean = mean(!!value_colname, na.rm = TRUE),
        sd = stats::sd(!!value_colname, na.rm = TRUE)
      ) %>%
      ggplot2::ggplot(ggplot2::aes(
        x = .data$time,
        y = .data$mean,
        color = .data$condition
      )) +
      ggplot2::geom_point() +
      ggplot2::geom_line() +
      ggplot2::geom_errorbar(ggplot2::aes(
        ymax = .data$mean + .data$sd,
        ymin = .data$mean - .data$sd
      ), width = 15) +
      ggplot2::facet_wrap(~ peptide + cleavage_seq, scales = "free_y")
  } else {
    p1 <- mspms_tidy_data %>%
      ggplot2::ggplot(ggplot2::aes(
        x = .data$time,
        y = !!value_colname,
        color = .data$condition
      )) +
      ggplot2::geom_point() +
      ggplot2::stat_summary(ggplot2::aes(group = .data$condition),
        fun = mean,
        geom = "line"
      ) +
      ggplot2::facet_wrap(~ peptide + cleavage_seq, scales = "free_y")
  }
  return(p1)
}

#' plot_cleavages_per_pos
#'
#' plot the number of cleavages at each
#'
#' @param sig_cleavage_data a tibble of data of interest containing a column
#' labeled peptide, cleavage_seq, condition, and cleavage_pos.
#' @param ncol the number of columns to plot.
#' @return a ggplot2 object
#' @export
#'
#' @examples
#' # Defining the significant peptides
#' sig_cleavage_data <- log2fc_t_test_data %>%
#'   dplyr::filter(p.adj <= 0.05, log2fc > 3)
#' # Plotting
#' p1 <- mspms::plot_cleavages_per_pos(sig_cleavage_data)
#' p1
plot_cleavages_per_pos <- function(sig_cleavage_data,
                                   ncol = NULL) {
  count_cleavages_per_pos <- count_cleavages_per_pos(sig_cleavage_data)
  p1 <- count_cleavages_per_pos %>%
    ggplot2::ggplot(ggplot2::aes(
      x = .data$cleavage_pos,
      y = .data$n,
      color = .data$time
    )) +
    ggplot2::facet_wrap(~ .data$condition, scales = "free_y", ncol = ncol) +
    ggplot2::geom_point() +
    ggplot2::geom_line()
  return(p1)
}

test_that("plot_cleavages_per_pos() works when given expected data", {
  sig <- log2fc_t_test_data %>%
    dplyr::filter(p.adj <= 0.05, log2fc > 3)

  p1 <- plot_cleavages_per_pos(sig)
  expect_no_error(p1)
})

test_that("plot_cleavages_per_pos() gives error with unexpected data", {
  sig <- log2fc_t_test_data %>%
    dplyr::filter(p.adj <= 0.05, log2fc > 3) %>%
    dplyr::select(-cleavage_pos)

  expect_error(plot_cleavages_per_pos(sig))
})

#' log2fc_t_test
#'
#' Calculates the log2 fold change and t-test statistics given a user specified
#' reference variable and value.
#'
#' @param processed_qf mspms data in a QFeatures object.
#' @param reference_variable the colData variable to use as reference
#' @param reference_value the value of the colData variable to use as reference
#'
#' @return a tibble containing log2fc and t test statistics
#' @export
#'
#' @examples
#' log2fc_and_t_test <- log2fc_t_test(mspms::processed_qf)
log2fc_t_test <- function(processed_qf,
                          reference_variable = "time",
                          reference_value = 0) {
  # Calculating the log2fc
  log2fc <- mspms_log2fc(
    processed_qf,
    reference_variable,
    reference_value
  )

  # Calculating the stats
  stat <- mspms_t_tests(processed_qf,
    reference_variable,
    reference_value = as.character(reference_value)
  )

  # Combining them together
  log2fc_stats <- dplyr::inner_join(log2fc, stat, by = c(
    "peptide",
    "comparison"
  )) %>%
    tibble::as_tibble() %>%
    dplyr::rename("condition" = "condition.x") %>%
    dplyr::select(-"condition.y")

  return(log2fc_stats)
}

test_that("log2fc_t_test() works using time as reference ", {
  expect_no_error(log2fc_t_test(mspms::processed_qf,
    "time",
    reference_value = 0
  ))
})
#
# test_that("log2fc_t_test() thows an error when a value is not in data ", {
#     expect_error(log2fc_t_test(mspms::processed_qf,
#         "condition",
#         reference_value = "not present in data"
#     ))
# })

#' remaining_cd_names
#'
#' determine what the remaining colData names are when removing the reference
#' variable.
#'
#' @param processed_qf a QFeatures object
#' @param reference_variable name of reference variable
#'
#' @return a vector of the remaining names in the colData
#' @keywords internal
remaining_cd_names <- function(processed_qf, reference_variable) {
  cd_names <- SummarizedExperiment::colData(processed_qf) %>%
    as.data.frame() %>%
    names()

  ex_col_names <- c(reference_variable, "group", "quantCols")
  remaining_names <- cd_names[cd_names %!in% ex_col_names]

  if (length(remaining_names) != 1) {
    stop("expected there to be one remaining name in colData")
  }
  return(remaining_names)
}

#' mspms_log2fc
#'
#' calculates the log2fc for each time point within each condition relative to
#' a specified value for a specified reference variable.
#' @param processed_qf a QFeatures object with a SummarizedExperiment named
#' "peptides_norm".
#' @param reference_variable the variable to used as a reference (denominator
#' of log2 fold change).
#' @param reference_value  the value of the reference variable to use as
#' the reference
#' @return a tibble with the t test statistics for each peptide within each
#' group with the supplied value at the supplied variable as reference.
#' @keywords internal
mspms_log2fc <- function(processed_qf,
                         reference_variable = "time",
                         reference_value = 0) {
  # converting reference_variable to symbol
  sym <- dplyr::sym(reference_variable)
  # creating enquosure to determine what column to filter by
  filter_reference_by <- dplyr::enquo(sym)
  # Determining the remaining variables
  remaining_variables <- remaining_cd_names(processed_qf, reference_variable)
  remaining_variable_syms <- dplyr::sym(remaining_variables)
  group_by_cols <- dplyr::enquo(remaining_variable_syms)
  # Converting the data in the qf to tibble
  mspms_data <- mspms_tidy(processed_qf)
  # Extracting just the control data
  control_data <- mspms_data %>%
    dplyr::filter(!!filter_reference_by == reference_value) %>%
    dplyr::group_by(!!group_by_cols, .data$peptide) %>%
    dplyr::summarise(control_mean = mean(.data$peptides_norm,
      na.rm = TRUE
    ))
  # Extracting just the reference data
  reference_data <- mspms_data %>%
    dplyr::group_by(
      .data$peptide, !!filter_reference_by,
      !!group_by_cols
    ) %>%
    dplyr::summarise(
      sample_mean = mean(.data$peptides_norm, na.rm = TRUE),
      sample_sd = stats::sd(.data$peptides_norm, na.rm = TRUE)
    )
  # Calculating the log2fc
  log2fc <- dplyr::inner_join(control_data, reference_data, by = c(
    "peptide",
    remaining_variables
  )) %>%
    dplyr::mutate(
      comparison = paste0(
        !!remaining_variable_syms, ".", !!filter_reference_by, "/",
        !!remaining_variable_syms, ".", reference_value
      ),
      log2fc = log2(.data$sample_mean / .data$control_mean),
      difference = .data$sample_mean - .data$control_mean
    ) %>%
    tibble::as_tibble()
  return(log2fc)
}

#' mspms_t_tests
#'
#' performs t-tests for each peptide within each group for the user specified.
#' FDR adjustment is performed.
#'
#' @param processed_qf a QFeatures object with a SummarizedExperiment named
#' "peptides_norm".
#' @param reference_variable the variable to used as a reference.
#' @param reference_value  the value of the reference variable to use as
#' the reference
#' @return a tibble with the t test statistics for each peptide within each
#' group with the supplied value at the supplied variable as reference.
#' @keywords internal
mspms_t_tests <- function(processed_qf,
                          reference_variable = "time",
                          reference_value = "0") {
  if (!is.character(reference_value)) {
    reference_value <- as.character(reference_value)
  }
  # converting reference_variable to symbol
  sym <- dplyr::sym(reference_variable)
  # creating enquosure to determine what column to filter by
  filter_reference_by <- dplyr::enquo(sym)
  # Determining the remaining variables
  remaining_variables <- remaining_cd_names(processed_qf, reference_variable)
  remaining_variable_syms <- dplyr::sym(remaining_variables)
  group_by_cols <- dplyr::enquo(remaining_variable_syms)
  mspms_data <- mspms_tidy(processed_qf, "peptides_log_impute_norm")
  # Defining formula to use in t_test
  formula <- stats::as.formula(paste("peptides_log_impute_norm ~", reference_variable))
  # Doing T tests
  stat <- mspms_data %>%
    dplyr::group_by(
      .data$cleavage_seq,
      !!group_by_cols,
      .data$peptide,
      .data$cleavage_pos,
      .data$peptide_type
    ) %>%
    rstatix::t_test(
      formula = formula,
      ref.group = reference_value
    ) %>%
    dplyr::select(-"p.adj.signif") %>%
    rstatix::adjust_pvalue(method = "fdr") %>%
    rstatix::add_significance(p.col = "p.adj") %>%
    dplyr::mutate(
      comparison = paste0(
        !!remaining_variable_syms, ".", .data$group2, "/",
        !!remaining_variable_syms, ".", .data$group1
      )
    ) %>%
    tibble::as_tibble()
  return(stat)
}

#' add_peptide_data
#'
#' adds peptide information for every peptide in the data.
#'
#' @param tibble tibble you would like to add peptide info to. Must have column
#' named peptide
#' @param qf a QFeatures object with rowData for peptides. cleavage_seq,
#' cleavage_pos, and cleavage_type.
#' @return a tibble with column named peptide.
#' @keywords internal
add_peptide_data <- function(tibble, qf) {
  # extract peptide data
  pd <- SummarizedExperiment::rowData(qf[["peptides_log_impute_norm"]]) %>%
    tibble::as_tibble() %>%
    dplyr::select("peptide", "library_id", "peptide_type", "cleavage_seq", "cleavage_pos")
  # innerjoin
  out <- dplyr::inner_join(pd, tibble, by = "peptide")
  return(out)
}


#' calc_limma_design_matrix
#'
#' Calculates a limma compatible design matrix for mspms data.
#'
#' @param colData colData with condition and time variables as factors
#' @param norm_data normalized data from QFeatures object to use
#' @returns a model matrix
#' @keywords internal
calc_limma_design_matrix <- function(colData,
                                     norm_data) {
  # Create the design matrix with a valid naming format using periods
  if (length(unique(colData$condition)) == 1) {
    design <- stats::model.matrix(~ 0 + time, data = colData)
  } else {
    design <- stats::model.matrix(~ 0 + condition:time, data = colData)
  }
  colnames(design) <- apply(
    expand.grid(levels(colData$condition), levels(colData$time)), 1,
    function(x) paste0("condition.", x[1], ".time.", x[2])
  )
  rownames(design) <- colnames(norm_data) # Match sample names
  return(design)
}

#' calc_limma_contrasts
#'
#' Calculates limma contrasts given colData. The contrasts returned are pairwise
#' relative to T0 for each timepoint assayed.
#'
#' @param colData colData from mspms experiment
#' @param design_mat design_mat as returned by calc_limma_design_matrix
#' @returns a contrast matrix
#' @keywords internal
calc_limma_contrasts <- function(colData, design_mat) {
  contrast_list <- list()
  conditions <- levels(colData$condition)

  for (cond in conditions) {
    # Get all time points available for the condition
    valid_time_points <- unique(colData$time[colData$condition == cond])

    for (t in valid_time_points[-1]) { # Skip time 0 for each condition
      # Construct contrast names to match the standardized format with periods
      base_name <- paste0("condition.", cond, ".time.", t)
      ref_name <- paste0("condition.", cond, ".time.0")

      # Contrast name and formula
      contrast_name <- paste0(base_name, " - ", ref_name)
      contrast_formula <- paste0(base_name, " - ", ref_name)
      contrast_list[[contrast_name]] <- contrast_formula
    }
  }
  # Create contrast matrix
  contrast_matrix <- limma::makeContrasts(
    contrasts = unlist(contrast_list),
    levels = design_mat
  )
  return(contrast_matrix)
}

### remaining_cd_names() ###
test_that("remaining_cd_names() returns the expected missing name, when time is
provided as reference", {
  time <- mspms:::remaining_cd_names(mspms::processed_qf, "time")
  expect_equal(time, "condition")
})

test_that("remaining_cd_names() returns the expected missing name, when condition
is provided as reference", {
  condition <- mspms:::remaining_cd_names(mspms::processed_qf, "condition")
  expect_equal(condition, "time")
})

test_that("remaining_cd_names() throws error when column not in data is
          attempted to be passed", {
  expect_error(mspms:::remaining_cd_names(mspms::processed_qf, "not_here"))
})

### mspms_log2fc() ###
test_that("mspms_log2fc() returns does not error when data is as expected", {
  expect_no_error(mspms:::mspms_log2fc(
    mspms::processed_qf,
    "time",
    0
  ))
})

test_that("mspms_log2fc() returns does not error when time is supplied as a
          character", {
  expect_no_error(mspms:::mspms_log2fc(
    mspms::processed_qf,
    "time",
    "0"
  ))
})

test_that("mspms_log2fc() errors when a variable not in data is provided", {
  expect_error(mspms:::mspms_log2fc(
    mspms::processed_qf,
    "not_here",
    "0"
  ))
})

### mspms_t_tests() ###
test_that("mspms_t_tests() does not error when data is as expected", {
  expect_no_error(mspms:::mspms_t_tests(
    mspms::processed_qf,
    "time",
    "0"
  ))
})

# test_that("mspms_t_tests() does not error when numeric value of reference
#           variable is provided", {
#     expect_no_error(mspms:::mspms_t_tests(
#         mspms::processed_qf,
#         "time",
#         0
#     ))
# })
#
# test_that("mspms_t_tests() errors when nonexistant value is provided", {
#     expect_error(mspms:::mspms_t_tests(
#         mspms::processed_qf,
#         "not_here",
#         "not_here"
#     ))
# })

#' calc_AA_count_of_motif
#'
#' Calculate the counts of amino acids at each position of a motif for all the
#' sequences in a vector.
#'
#' @param cleavage_motif a vector of cleavage motifs
#' @return a matrix of counts
#' @keywords internal
calc_AA_count_of_motif <- function(cleavage_motif) {
  # calculating number of characters
  nchar <- nchar(cleavage_motif[1])
  # do this for the background first.
  sequences <- tibble::tibble(cleavage_motif = cleavage_motif)
  # separate the sequences into individual amino acids
  AAs <- tidyr::separate(
    sequences,
    col = 1,
    into = c("exclude", paste0("position", seq_len(nchar))),
    sep = "",
    remove = TRUE
  ) %>%
    dplyr::select(-"exclude")
  # Define the desired order.
  # This ensures that the amino acids will always be in the same order.
  desired_order <- c(
    "A", "D", "E", "F", "G", "H", "I", "K", "L", "n",
    "N", "P", "Q", "R", "S", "T", "V", "W", "X", "Y"
  )
  # Counting the number in each position
  count <- AAs %>%
    purrr::map_df(table)
  # Are any columns missing?
  `%!in%` <- Negate(`%in%`)
  missing_cols <- desired_order[desired_order %!in% names(count)]
  # building a df with missing columns
  missing_matrix <- matrix(nrow = nchar, ncol = length(missing_cols))
  colnames(missing_matrix) <- missing_cols
  missing_df <- tibble::as_tibble(missing_matrix)
  count_matrix <- dplyr::bind_cols(count, missing_df) %>%
    dplyr::relocate(dplyr::all_of(desired_order)) %>%
    t()
  # replacing NA with 0
  count_matrix[is.na(count_matrix)] <- 0
  colnames(count_matrix) <- paste0("P", c(
    seq(from = (nchar / 2), to = 1),
    paste0(seq_len(nchar / 2), "'")
  ))
  return(count_matrix)
}

#' calc_AA_prop_of_motif
#'
#' Calculate the proportion of amino acids at each position in a vector of
#' motifs.
#'
#' @param count_matrix this is a matrix of the counts of cleavage motifs
#'
#' @return a matrix with proportions of counts.
#' @keywords internal
calc_AA_prop_of_motif <- function(count_matrix) {
  prop <- count_matrix %>%
    as.data.frame() %>%
    tibble::rownames_to_column("AA") %>%
    dplyr::mutate(dplyr::across(dplyr::where(is.numeric), prop.table)) %>%
    tibble::column_to_rownames("AA") %>%
    as.matrix()
  return(prop)
}

#' calc_AA_motif_zscore
#'
#' Calculate the Z score for the amino acids at each position
#'
#' @param background_count_matrix the count matrix from the
#' background sequences
#' @param background_prop_matrix the proportion matrix from the
#' background sequences
#' @param experimental_count_matrix the count matrix from the
#' experimental sequences
#' @param experimental_prop_matrix the proportion matrix from the
#' experimental sequences
#'
#' @return a data frame of Zscores for each amino acid at each position.
#' @keywords internal

calc_AA_motif_zscore <- function(background_count_matrix,
                                 background_prop_matrix,
                                 experimental_count_matrix,
                                 experimental_prop_matrix) {
  ### calculating the SD ###
  # defining function per Icelogo manual
  standard_deviation <- function(proportion_matrix, count_matrix) {
    (proportion_matrix / colSums(count_matrix))^(1 / 2)
  }

  # calculating the standard deviation
  bg_sd <- standard_deviation(
    background_prop_matrix,
    experimental_count_matrix
  )

  ### Calculating Z score ###

  # Defining function per icelogo manual
  zscore <- function(experimental_prop_matrix,
                     background_prop_matrix,
                     bg_sd) {
    (experimental_prop_matrix - background_prop_matrix) / bg_sd
  }

  # applying to our data
  zscores <- zscore(
    experimental_prop_matrix,
    background_prop_matrix,
    bg_sd
  ) %>%
    as.data.frame()

  return(zscores)
}

#' calc_sig_zscores
#' Determine which Zscores are significant at the given alpha for a
#' matrix of scores
#' @param zscores = a data frame of zscores
#' @param pval = p value threshold for significance. Default is 0.05
#'
#' @return a tibble of significant zscores
#' @keywords internal

calc_sig_zscores <- function(zscores, pval = 0.05) {
  # no visible binding for global variable .
  . <- NULL
  # converting p value to zscore threshold. Divide by two since two tailed
  threshold <- stats::qnorm(p = pval / 2, lower.tail = FALSE)

  sig_zscores <- zscores %>%
    tibble::rownames_to_column("AA") %>%
    tidyr::pivot_longer(2:length(.),
      names_to = "position",
      values_to = "zscore"
    ) %>%
    dplyr::filter(abs(.data$zscore) > threshold) %>%
    dplyr::mutate(aa_position = paste0(.data$AA, ".", .data$position))

  return(sig_zscores)
}

#' calc_AA_percent_difference
#'
#' Calculate the percent difference between a matrix of background proportions
#' and a matrix of experimentally observed proportions.
#'
#' @param background_prop_matrix a proportion matrix of amino acids
#' per position from background cleavage sequences
#' @param experimental_prop_matrix a proportion matrix of amino acids per
#' position from experimental cleavage sequences
#'
#' @return a data frame of percent differences
#' @keywords internal
calc_AA_percent_difference <- function(background_prop_matrix,
                                       experimental_prop_matrix) {
  # Calculating percent difference
  pd <- (experimental_prop_matrix * 100) - (background_prop_matrix * 100) %>%
    as.data.frame()

  return(pd)
}

#' calc_AA_fc
#'
#' Calculate the fold change of each amino acid by position.
#'
#' @param experimental_prop_matrix a matrix of the experimental
#' proportions (from your vector of cleavage sequences) at each position.
#' @param background_prop_matrix a matrix of the background proportions
#'  of AAs at each position
#' @param sig_zscores a tibble of the significant zscores.
#' @return a matrix
#' @keywords internal
calc_AA_fc <- function(experimental_prop_matrix,
                       background_prop_matrix,
                       sig_zscores) {
  # calculating the fold change of each amino acid by position
  fold_change <- (experimental_prop_matrix * 100) /
    (background_prop_matrix * 100)
  # Filtering to only include significant z-scores
  prepared_fc <- prepare_fc(
    as.data.frame(fold_change),
    sig_zscores
  )
  converted_fc <- prepared_fc
  # Here we run into a problem with infinite values.
  # If a value is 0 in the count, but greater than that in the background
  # Icelogo shows infinite value as taking up the entire scale.
  max_sum <- max(
    purrr::map_df(as.data.frame(converted_fc),
      sum,
      na.rm = TRUE
    ),
    na.rm = TRUE
  )
  final_converted_fc <- data.frame(row.names = rownames(converted_fc))
  for (i in seq_len(ncol(converted_fc))) {
    if (0 %in% converted_fc[, i]) {
      num_zero <- sum(converted_fc[, i] == 0, na.rm = TRUE)
      col <- replace(
        converted_fc[, i],
        converted_fc[, i] == 0,
        (max_sum / num_zero * -1)
      )
      final_converted_fc <- cbind(final_converted_fc, col)
    } else {
      final_converted_fc <- cbind(final_converted_fc, converted_fc[, i])
    }
  }
  colnames(final_converted_fc) <- colnames(converted_fc)
  # now converting values less than 1 to converted fold change.
  final_converted_fc2 <- final_converted_fc %>%
    dplyr::mutate(
      dplyr::across(
        dplyr::all_of(names(final_converted_fc)),
        ~ case_when(.x < 1 & .x > 0 ~ (1 / .x) * -1,
          .default = .x
        )
      )
    )
  final_converted_fc2 <- as.matrix(final_converted_fc2)
  return(final_converted_fc2)
}
#' prepare_sig_p_dif
#'
#' Prepare significant percent difference data frame for iceLogo
#'
#' @param percent_difference  a data frame containing the percent differences
#' @param sig_zscores a matrix of significant amino acids at each position
#' based on z-scores
#'
#' @return a tibble
#' @keywords internal
prepare_sig_p_dif <- function(percent_difference, sig_zscores) {
  # No visible binding
  . <- NULL
  sig_final <- percent_difference %>%
    tibble::rownames_to_column("AA") %>%
    tidyr::pivot_longer(2:length(.),
      names_to = "position",
      values_to = "percent_difference"
    ) %>%
    dplyr::mutate(aa_position = paste0(.data$AA, ".", .data$position)) %>%
    dplyr::filter(.data$aa_position %in% sig_zscores$aa_position) %>%
    dplyr::select(-"aa_position") %>%
    tidyr::pivot_wider(
      names_from = "position",
      values_from = "percent_difference",
      names_sort = FALSE
    )
  # Dealing with the problem introduced by the pivot wider function
  missing_cols <- ncol(percent_difference) - (ncol(sig_final) - 1)
  missing_data <- as.data.frame(matrix(
    nrow = nrow(sig_final),
    ncol = missing_cols, NA
  ))
  `%!in%` <- Negate(`%in%`)
  missing_names <- names(percent_difference)[names(percent_difference) %!in%
    names(sig_final)]
  names(missing_data) <- missing_names
  final <- sig_final %>%
    dplyr::bind_cols(missing_data) %>%
    dplyr::relocate(paste0("P", c(
      (ncol(percent_difference) / 2):1,
      paste0(
        seq_len(ncol(percent_difference) / 2), "'"
      )
    ))) %>%
    tibble::column_to_rownames("AA") %>%
    as.matrix()
  return(final)
}

#' prepare_icelogo_data
#'
#' Prepare the final matrix containing iceLogo data for plotting.
#'
#' @param cleavage_seqs the cleavage sequences that are observed in the
#' experiment
#' @param background_universe a vector of the cleavage sequences to use as
#' the background.
#' @param pval the p-value threshold to consdier
#' @param type the type of iceLogo calculation to perform. Accepted values are
#' "percent_difference" or "fold_change".
#'
#' @return a matrix of enriched amino acids per position
#' @keywords internal
prepare_icelogo_data <- function(cleavage_seqs,
                                 background_universe =
                                   mspms::all_possible_8mers_from_228_library,
                                 pval = 0.05,
                                 type = "percent_difference") {
  # calculation proportions of background
  background_counts <- calc_AA_count_of_motif(background_universe)
  background_proportions <- calc_AA_prop_of_motif(background_counts)

  # calculate proportions of experimentally identified motifs
  experimental_counts <- calc_AA_count_of_motif(cleavage_seqs)
  experimental_proprotions <- calc_AA_prop_of_motif(experimental_counts)

  # calculate zscores
  zscores <- calc_AA_motif_zscore(
    background_count_matrix = background_counts,
    background_prop_matrix = background_proportions,
    experimental_count_matrix = experimental_counts,
    experimental_prop_matrix = experimental_proprotions
  )
  # calculate significant zscores
  sig_zscores <- calc_sig_zscores(zscores, pval)
  if (type == "percent_difference") {
    pd <- calc_AA_percent_difference(
      experimental_prop_matrix = experimental_proprotions,
      background_prop_matrix = background_proportions
    )
    final_pd <- prepare_sig_p_dif(pd, sig_zscores)
    return(final_pd)
  } else if (type == "fold_change") {
    fc <- calc_AA_fc(
      experimental_prop_matrix = experimental_proprotions,
      background_prop_matrix = background_proportions,
      sig_zscores = sig_zscores
    )
    return(fc)
  } else {
    stop("type must be either 'percent_difference' or 'fold_change'")
  }
}

#' prepare_fc
#'
#' Prepare fold changes of amino acids by position for Icelogo visualization.
#'
#' @param fold_change  a matrix of the fold changes of the AA by
#' position.
#' @param sig_zscores  a tibble of the significant zscores.
#'
#' @return a matrix of the fold changes of the significant AAs at each position.
#' @keywords internal

prepare_fc <- function(fold_change, sig_zscores) {
  # No visible binding for global variable .
  . <- NULL
  sig_final <- fold_change %>%
    tibble::rownames_to_column("AA") %>%
    tidyr::pivot_longer(2:length(.),
      names_to = "position",
      values_to = "fold_change"
    ) %>%
    dplyr::mutate(aa_position = paste0(.data$AA, ".", .data$position)) %>%
    dplyr::filter(.data$aa_position %in% sig_zscores$aa_position) %>%
    dplyr::select(-"aa_position") %>%
    tidyr::pivot_wider(
      names_from = "position",
      values_from = "fold_change",
      names_sort = FALSE
    )
  # Dealing with the problem introduced by the pivot wider function
  missing_cols <- ncol(fold_change) - (ncol(sig_final) - 1)
  missing_data <- as.data.frame(matrix(
    nrow = nrow(sig_final),
    ncol = missing_cols, NA
  ))
  `%!in%` <- Negate(`%in%`)
  missing_names <- names(fold_change)[names(fold_change) %!in%
    names(sig_final)]
  names(missing_data) <- missing_names
  final <- sig_final %>%
    dplyr::bind_cols(missing_data) %>%
    dplyr::relocate(paste0("P", c(
      (ncol(fold_change) / 2):1,
      paste0(
        seq_len(ncol(fold_change) / 2), "'"
      )
    ))) %>%
    tibble::column_to_rownames("AA") %>%
    as.matrix()
  return(final)
}

test_that("works with standard number of AAs)", {
  expect_no_error(mspms:::calc_AA_count_of_motif("XXXXXXXX"))
})


test_that("works with non standard number of AAs (so long as even number)", {
  expect_no_error(mspms:::calc_AA_count_of_motif("XXXXXXXXXX"))
})


test_that("does not work with odd number of AAs", {
  expect_error(mspms:::calc_AA_count_of_motif("XXX"))
})

#' plot_qc_check
#' plot the the percentage of the peptide library undetected in each sample per
#' each sample group.
#' @param processed_qf QFeatures object containing a SummarizedExperiment
#' named "peptides"
#' @param peptide_library a vector of all peptide library ids in the
#' experiment.
#' @param full_length_threshold percent to use as threshold visualized as a
#' vertical blue dashed line
#' @param cleavage_product_threshold percent to use as a threshold visualized as
#' a red dashed line
#' @param ncol n columns.
#' @return a ggplot2 object.
#' @export
#'
#' @examples
#' plot_qc_check(mspms::processed_qf)
plot_qc_check <- function(processed_qf,
                          peptide_library = mspms::peptide_library$library_id,
                          full_length_threshold = NULL,
                          cleavage_product_threshold = NULL,
                          ncol = 2) {
  if (!is.character(peptide_library)) {
    stop("peptide library must be a character vector")
  }
  qc_check_data <- prepare_qc_check_data(
    processed_qf,
    peptide_library
  )
  # Plotting per
  p1 <- qc_check_data %>%
    ggplot2::ggplot(ggplot2::aes(
      color = .data$peptide_type,
      fill = .data$peptide_type
    )) +
    ggplot2::geom_histogram(ggplot2::aes(.data$per_library_id_undetected),
      binwidth = 0.1,
      alpha = 0.5
    ) +
    ggplot2::geom_density(ggplot2::aes(.data$per_library_id_undetected),
      alpha = 0.5
    ) +
    ggplot2::geom_vline(
      xintercept = full_length_threshold, linetype = "dashed",
      color = "#00BFC4"
    ) +
    ggplot2::geom_vline(
      xintercept = cleavage_product_threshold, linetype = "dashed",
      color = "#F8766D"
    ) +
    ggplot2::facet_wrap(~ .data$group, scales = "free_y", ncol = ncol) +
    ggplot2::ggtitle("Percentage of Library ID Undetected In Each Sample") +
    ggplot2::ylab("count")
  return(p1)
}

---
title: "MSPMS Report"
date: "`r Sys.Date()`"
output:
  html_document:
        theme: cosmo
        toc: true
        toc_depth: 6
        toc_float:
            collapsed: true
            smooth_scroll: true
        code_folding: hide
        highlight: tango
        df_print: paged
params:
  prepared_data: NULL
  peptide_library: mspms::peptide_library
  n_residues: 4
---

```{r setup, include=FALSE}
library(dplyr)
ggplot2::theme_set(ggplot2::theme_bw())
knitr::opts_chunk$set(echo = TRUE,warning = FALSE, message = FALSE)
```

# Info

This report has been automatically generated by the mspms package. 
It contains standard results of the mspms analysis pipeline. 


R session info is as follows:  

```{r}
sessionInfo()
```

# Processed Data 

```{r}
# The standard mspms data processing pipeline is used here. 
processed_qf = mspms::process_qf(prepared_data)

mspms_data = mspms_tidy(processed_qf,"peptides_norm")

DT::datatable(mspms_data)

mspms_data %>%
  downloadthis::download_this(
    output_name = "mspms_data",
    output_extension = ".csv",
    button_label = "Download data",
    button_type = "warning",
    has_icon = TRUE,
    icon = "fa fa-save",
    csv2 = FALSE
  )
```

**Table 1.** Imputed and normalized mspms data. 

# QC Checks 


```{r}
mspms::plot_qc_check(processed_qf)

```

**Figure 1.** Here the results of the qc checks are displayed. 


```{r}
mspms::plot_nd_peptides(processed_qf)
```
  
**Figure 2.** Here the library peptides not detected in each samples are shown. 

# Overview 
```{r}
mspms_tidy_data <- mspms_tidy(processed_qf)
mspms::plot_pca(mspms_tidy_data)
```

**Figure 3.** Here a PCA of the experiment is displayed. The color represents
time, while shape and linetype of eclipse 
(if there are enough points to calculate) represents condition. 


```{r,fig.height = 8, fig.width = 10}
mspms::plot_heatmap(mspms_tidy_data)
```

**Figure 4.** Here an interactive heatmap of the experiment is displayed. 
Mouse over to see more information on each cell. Column side colors 
represent condition and time. 

# Statistics 

```{r}
t2 = mspms::log2fc_t_test(processed_qf) %>% 
  dplyr::arrange(p.adj)

DT::datatable(t2)

t2 %>%
  downloadthis::download_this(
    output_name = "mspms_t-tests",
    output_extension = ".csv",
    button_label = "Download ttests",
    button_type = "warning",
    has_icon = TRUE,
    icon = "fa fa-save",
    csv2 = FALSE
  )
```

**Table 4.** Here T-test results are displayed as compared to time 0 for each 
condition


```{r}
mspms::plot_volcano(t2)
```

**Figure 5.** Here the Log2fc and T tests are displayed as volcano plots 
relative to T0 for each condition. 

# Cleavage Motifs

```{r,fig.height = 14, fig.width = 4}
sig_cleavage_data <- t2 %>% 
  dplyr::filter(p.adj <= 0.05, log2fc >3)

tryCatch({
  print(mspms::plot_all_icelogos(sig_cleavage_data))
}, error = function(e) {
  print(e)
})
```
  
**Figure 6.** Here the cleavage motifs enriched in each condition are shown. 
Enriched cleavage motifs are defined as having a p.adj <= 0.05 and a log2fc >3
relative to time 0. 


# Position Specificity 

```{r}

d = mspms::plot_cleavages_per_pos(sig_cleavage_data)

tryCatch({
  print(d)
}, error = function(e) {
  print(e)
})
```

**Figure 7.** Here the count of significant cleavages at each position of the 
peptide library are shown for each condition (facet) per time point (color). 
Significant cleavages are defined as having a p.adj <= 0.05 and a log2fc > 3 
relative to time 0.  

---
title: "mspms_vignette"
output:
    BiocStyle::html_document:
    toc: true
    toc_depth: 2
vignette: >
  %\VignetteIndexEntry{mspms_vignette}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

ggplot2::theme_set(
  ggplot2::theme_minimal()
)

library(mspms)
library(dplyr)
```

# `r BiocStyle::Biocpkg("mspms")`


## Introduction

The goal of `r BiocStyle::Biocpkg("mspms")` is provide a R Package that can be used to easily and
reproducibly analyze data resulting from the [Multiplex Substrate Profiling by
Mass Spectrometry (MSP-MS) method](https://pubmed.ncbi.nlm.nih.gov/36948708/).

Additionally, we provide a [graphical user interface powered by shiny
apps](https://github.com/baynec2/mspms-shiny) that allows for a user to
utilize the method without requiring any R coding knowledge.

Multiplex Substrate Profiling by Mass Spectrometry
[(MSP-MS)](https://pubmed.ncbi.nlm.nih.gov/36948708/) is a powerful method used
to determine the substrate specificity of proteases. This method is of interest
for groups interested in the study of proteases and their role as regulators of
biological pathways, whether applied to the study of disease states, the
development of diagnostic and prognostic tests, generation of tool compounds, or
rational design of protease targeting therapeutics. Analysis of the MS based
data produced by MSP-MS is a multi-step process involving detection and
quantification of peptides, imputation, normalization, cleavage sequence
identification, statistics, and data visualizations. This process can be
challenging, especially for scientists with limited programming experience. To
overcome these issues, we developed the mspms R package to facilitate the
analysis of MSP-MS data utilizing good software/data analysis practices.

mspms differs from existing proteomics packages that are available in the
Bioconductor project in that it is specifically designed to analyze MSP-MS data.
This involves unique preprocessing steps and data visualizations tailored to
this specific assay.

In order to do so, mspms uses several excellent packages from the Bioconductor
project to provide a framework to easily and reproducibly analyze MSP-MS data.
These include:

-   `r BiocStyle::Biocpkg("QFeatures")`: management and processing of peptide 
quantitative features and sample metadata.
    
-   `r BiocStyle::Biocpkg("limma")`: Powerful linear models and empirical 
Bayesian methods for omics data.

-   `r BiocStyle::Biocpkg("MsCoreUtils")`: log2 transformation, 
imputation (QRILC), and normalization (center.median).

Some excellent non-Bioconductor packages are also utilized.

-   *ggplot2*: data visualizations

-   *heatmaply*: interactive heatmaps

-   *rstatix*: conduct statistics

-   *ggseqlogo*: iceLogo motif visualization.

-   *downloadthis*: gives users the ability to download data from standard .html
    report generated by mspms::generate_report().

Lastly, mspms takes advantage of iceLogos ([Colaert, N. et al. Nature Methods 6,
786-787 (2009)](http://www.ncbi.nlm.nih.gov/pubmed/19876014)) to viusalize
overrepresented amino acid motifs relative to a background set by implementing
components of the Java software in R.

## Quickstart

To generate a general report using your own data, run the following code. It
requires data that has been prepared for mspms data analysis by a converter
function, and colData (sample metadata). For more information see subsequent sections.

```{r,eval = FALSE}
mspms::generate_report(
  prepared_data = mspms::peaks_prepared_data,
  outdir = "../Desktop/mspms_report"
)
```

The above command will generate a .html file containing a generic mspms
analysis.

There is much more that can be done using the mspms package- see the following
sections for more information.

## Overview

Functions in this package are logically divided into 4 broad types of functions.

1.  Pre-processing data. These functions are focused on getting all of the data
    necessary for a mspms analysis together and in a consistent format.

2.  Data processing. These functions allow the user to process the proteomics data (imputation, normalization, etc).

3.  Statistics. These methods allow the user to perform basic statistics on the normalized/processed data.

4.  Data visualization. These functions allow the user to visualize the data.

**Note that only a subset of functions are exported to the user.** Helper functions can be found in the
[preprocessing_helper_functions.R](https://github.com/baynec2/mspms/blob/main/R/preprocessing_helper_functions.R),
[processing_helper_functions.R](https://github.com/baynec2/mspms/blob/main/R/processing_helper_functions.R),[icelogo_helper_functions.R](https://github.com/baynec2/mspms/blob/main/R/iceLogo_helper_fuctions.R), [statistics_helper_functions.R](https://github.com/baynec2/mspms/blob/main/R/statistics_helper_functions.R), and [iceLogo_helper_functions.R](https://github.com/baynec2/mspms/blob/main/R/iceLogo_helper_fuctions.R) files. 

These functions were not intended to be directly used by the user and are not exported in an effort to make the package API cleaner and more intuitive.

## Pre-processing data

Pre-processing data here refers to standardizing the data exported from
different software solutions for analyzing mass spectrometry-based proteomics
and adding useful information specific to the MSP-MS assay.

Specifically, the data from the file exported from the upstream software is
parsed to contain the **peptide** (detected peptide sequence, cleavages are
represented as "\_"), **library_id** (name of the peptide in the peptide library
each detected peptide maps to), and intensities for each sample.

Information about each peptide relative to the peptide it was derived from is
then added. This includes the **cleavage_seq** (the motif the peptide a user
specified n residues up and down from the cleavage event), **cleavage_pos**
(position of the peptide library the cleavage product was cleaved at ),
**peptide_type** (whether the detected peptide is a cleavage product of the
peptide library, or a full length member of the peptide library).

All of the information is then loaded as a QFeatures object along with colData
(metadata about each sample) where it is stored as a SummarizedExperiment object
named "peptides".

### A note on colData

As briefly described above, the colData contains metadata describing the samples
you are trying to analyze.

**It is very important that this contains at least the following columns: quantCols","group","condition",and "time".**

The quantCols field contains the name of each sample. These names must match
whatever the samples are named in the files exported from the upstream
proteomics software.

The group field contains text specifying what group each sample belongs to. All
replicate samples should have the same group name

The condition field contains the experimental conditions that vary in your
MSP-MS experiment (this depends on the experimental question, could be type of
protease, the type of inhibitor, etc)

The time field contains the duration of incubation of your protease of interest
with the peptide library for each sample.

An example of a valid colData file is shown below.

```{r}
colData <- readr::read_csv(system.file("extdata/colData.csv",
  package = "mspms"
))

head(colData)
```

### PEAKS

Analysis using a .csv exported from [PEAKS
software](https://www.bioinfor.com/peaks-studio/) is supported.

an exported .csv file can be generated from PEAKS as follows:

1.  Create a New Project in PEAKS.\
2.  Select data to add to PEAKS project.\
3.  Add data, rename samples, set correct parameters. • Highlight all the added
    data.\
    • Select Create new sample for each file.\
    • Select appropriate instrument and fragmentation method.\
    • Set Enzyme to “None”.\
    • Rename samples according to enzymes, time points, and replicates.\
    • Can also ensure appropriate data is selected for these.\
    • Select “Data Refinement” to continue.\
4.  Data Refinement.\
    • On the top right, select MSP-MS as the predefined parameters.\
    • Parameters shown are what should be used for MSP-MS data analysis.\
    • Select “Identification” to continue.\
5.  Peptide Identification.\
    • On the top right, select MSP-MS as the predefined parameters.\
    • Parameters shown are what should be used for MSP-MS data analysis.\
    • Identification -\> Select Database -\> TPD_237.\
    • Identification -\> no PTMs.\
    • Can remove the PTMs by highlighting them and selecting Remove\
6.  Label Free Quantification.\
    • Make sure Label Free is selected.\
    • Group samples -\> add quadruplicates of samples to new group.

```{r}
library(dplyr)
library(mspms)

# File path of peaks lfq file
lfq_filepath <- system.file("extdata/peaks_protein-peptides-lfq.csv",
  package = "mspms"
)

colData_filepath <- system.file("extdata/colData.csv", package = "mspms")

# Prepare the data
peaks_prepared_data <- mspms::prepare_peaks(lfq_filepath,
  colData_filepath,
  quality_threshold = 0.3,
  n_residues = 4
)

peaks_prepared_data
```


### Fragpipe

Data exported from [Fragpipe](https://github.com/Nesvilab/FragPipe) as a .tsv
file is supported.

To generate this file, run a [LFQ Fragpipe
workflow](https://fragpipe.nesvilab.org/docs/tutorial_lfq.html) using your
desired parameters (we recommend using match between runs).

You will find a file named "combined_peptide.tsv" in the output folder from
Fragpipe.

This can be loaded into mspms as follows:

```{r}
combined_peptide_filepath <- system.file("extdata/fragpipe_combined_peptide.tsv",
  package = "mspms"
)

colData_filepath <- system.file("extdata/colData.csv", package = "mspms")


fragpipe_prepared_data <- prepare_fragpipe(
  combined_peptide_filepath,
  colData_filepath
)

fragpipe_prepared_data
```
### Proteome Discoverer

Analysis of a PeptideGroups.txt file exported from [proteome
discoverer](https://www.thermofisher.com/us/en/home/industrial/mass-spectrometry/liquid-chromatography-mass-spectrometry-lc-ms/lc-ms-software/multi-omics-data-analysis/proteome-discoverer-software.html) 
is supported.

To generate this .txt file:
1. Ensure that non-normalized/ non-scaled abundances are included in your 
PeptideGroup table.   
2. File > export > To Text (tab delimited) > Items to be exported - check 
the Peptide Groups box > Export.   

Note that the fileIDs of each sample in proteome discoverer (By default 
F1 - Fn) must match the quantCols in colData.   

```{r}
peptide_groups_filepath <- system.file(
  "extdata/proteome_discoverer_PeptideGroups.txt",
  package = "mspms"
)

colData_filepath <- system.file("extdata/proteome_discover_colData.csv",
  package = "mspms"
)

prepared_pd_data <- prepare_pd(peptide_groups_filepath, colData_filepath)

prepared_pd_data
```
  
## Data Processing

Data processing includes imputation and normalization of the proteomics data.
This is all done in a QFeatures object using MSCoreUtils methods. Data from 
each step is stored as a SummarizedExperiment within the QFeatures object with
the indicated name. 

1. Data is first log2 transformed ("peptides_log").   
2. Data is normalized using the center.median method ("peptides_log_norm").  
3. Missing values are then imputed using the QRILC method 
("peptides_log_impute_norm"). 
4. Data is then reverse log2 transformed ("peptides_norm"). 

```{r}
set.seed(2)
processed_qf <- process_qf(peaks_prepared_data)
processed_qf
```

## Accessing data stored in QFeatures

Once your data has been processed, you might want to take a closer look at the 
peptide-level results. In MSP-MS, these are stored as SummarizedExperiment 
objects within your QFeatures. You can easily pull them out using the assay
name. For example:

```{r}
# Extracting the 'peptides_norm' SummarizedExperiment
pn <- processed_qf[["peptides_norm"]]

# View the main assay (e.g., intensity matrix)
head(SummarizedExperiment::assay(pn))
```

```{r}
# View metadata for rows (peptides)
head(SummarizedExperiment::rowData(pn))
```


## Statistics

MSP-MS analysis has traditionally used T-tests to what peptides are
significantly different relative to T0. The authors of the assay suggest using a
T-test derived FDR adjusted p value threshold \<= 0.05 and log2 fold change
threshold \>= 3. 

We recommend that the user now uses a Limma based approach that uses a linear 
modeling and empirical Bayesian approach. This is a approach well suited to 
proteomics data that is powerful, flexible, and fast.

This limma based approach (with stats calculated relative to time 0 for each 
condition) can be utilized as follows:

```{r}
limma_stats <- mspms::limma_stats(processed_qf = processed_qf)
```

Alternatively, we provide a user-friendly implementation of the traditional
t-test approach as follows:

```{r}
log2fc_t_test_data <- mspms::log2fc_t_test(processed_qf = processed_qf)
```

## Data Visualizations

We provide a number of data visualizations as part of the mspms package.

### QC Checks

A critical initial step in MSP-MS data analysis is a rigorous quality control
assessment. Given the reliance on a specific peptide library, calculating the
percentage of library peptides detected in each sample provides a
straightforward yet powerful indicator of data integrity. Anomalously low
detection rates signal potential instrument or experimental problems.

We can see the percentage of the peptide library that were undetected among each
group of replicates as follows (for full length peptides a threshold of \~\< 10
is considered good while for cleavage products a threshold \~\< 5 is good):

```{r}
plot_qc_check(processed_qf,
  full_length_threshold = 10,
  cleavage_product_threshold = 5
)
```

We can also see in what percentage of samples each peptide in the peptide
library were undetected in.

```{r}
plot_nd_peptides(processed_qf)
```

### Tidying our data

We can then convert our QFeatures object into a "long" tibble using the 
mspms_tidy function.

This makes the data easy to manipulate prior to ggplot2 or plotly based plotting functions. 

```{r}
mspms_tidy_data <- mspms_tidy(processed_qf)
```

### Heatmap

We can inspect our data using an interactive heatmap as follows:

```{r,eval = FALSE}
plot_heatmap(mspms_tidy_data)
```

note that the interactive plot is not returned in this vignette 
due to size constraints. 

### PCA

We can also inspect our data using a PCA as follows.

```{r}
plot_pca(mspms_tidy_data, value_colname = "peptides_norm")
```

### Volcano plots


We can generate volcano plots showing the significant peptides from each
condition as follows:

```{r}
plot_volcano(log2fc_t_test_data)
```

### Cleavage Position Plots

We can also create plots showing the number of times we observe a cleavage at
each position of the peptide_library among a set of peptides of interest.

We can do this as follows:

```{r}
sig_cleavage_data <- log2fc_t_test_data %>%
  dplyr::filter(p.adj <= 0.05, log2fc > 3)

p1 <- mspms::plot_cleavages_per_pos(sig_cleavage_data)

p1
```

### iceLogo

[Icelogos](https://www.nature.com/articles/nmeth1109-786) are a method for
visualizing conserved patterns in protein sequences through probability theory.

As part of the mspms R package, we have implemented the logic to generate
[iceLogos](https://genesis.ugent.be/uvpublicdata/icelogo/iceLogo.pdf) in R.

To use this, we first have to define a vector of cleavage sequences that we are
interested in. We will do this for the significant CatA cleavages below.

```{r}
catA_sig_cleavages <- log2fc_t_test_data %>%
  dplyr::filter(p.adj <= 0.05, log2fc > 3) %>%
  dplyr::filter(condition == "CatA") %>%
  dplyr::pull(cleavage_seq) %>%
  unique()
```

We also need to know all of the possible cleavages we could see among our
peptide library. We can generate that as below:

```{r}
all_possible_8mers_from_228_library <- calculate_all_cleavages(
  mspms::peptide_library$library_real_sequence,
  n_AA_after_cleavage = 4
)
```

We can then generate an iceLogo relative to the background of all possible
cleavages in our peptide library like so:

```{r}
plot_icelogo(catA_sig_cleavages,
  background_universe = all_possible_8mers_from_228_library
)
```

We also provide a function that conveniently plots all icelogos from all
conditions from the experiment all together.

```{r}
sig_cleavage_data <- log2fc_t_test_data %>%
  dplyr::filter(p.adj <= 0.05, log2fc > 3)

plot_all_icelogos(sig_cleavage_data)
```

### Plotting a Time Course

We can also plot the intensities of peptides of interest over time.

First we need to define which peptides we are interested in. Here we will use
the t-test results, and look at the peptide with the max log2fc.

```{r}
max_log2fc_pep <- log2fc_t_test_data %>%
  dplyr::filter(p.adj <= 0.05, log2fc > 3) %>%
  dplyr::filter(log2fc == max(log2fc)) %>%
  pull(peptide)
```

We can then filter our tidy mspms data to only include this peptide and plot

```{r}
p1 <- mspms_tidy_data %>%
  dplyr::filter(peptide == max_log2fc_pep) %>%
  plot_time_course()

p1
```


```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/iceLogo_helper_fuctions.R
\name{calc_AA_count_of_motif}
\alias{calc_AA_count_of_motif}
\title{calc_AA_count_of_motif}
\usage{
calc_AA_count_of_motif(cleavage_motif)
}
\arguments{
\item{cleavage_motif}{a vector of cleavage motifs}
}
\value{
a matrix of counts
}
\description{
Calculate the counts of amino acids at each position of a motif for all the
sequences in a vector.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/iceLogo_helper_fuctions.R
\name{calc_AA_fc}
\alias{calc_AA_fc}
\title{calc_AA_fc}
\usage{
calc_AA_fc(experimental_prop_matrix, background_prop_matrix, sig_zscores)
}
\arguments{
\item{experimental_prop_matrix}{a matrix of the experimental
proportions (from your vector of cleavage sequences) at each position.}

\item{background_prop_matrix}{a matrix of the background proportions
of AAs at each position}

\item{sig_zscores}{a tibble of the significant zscores.}
}
\value{
a matrix
}
\description{
Calculate the fold change of each amino acid by position.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/statistics_helper_functions.R
\name{mspms_t_tests}
\alias{mspms_t_tests}
\title{mspms_t_tests}
\usage{
mspms_t_tests(processed_qf, reference_variable = "time", reference_value = "0")
}
\arguments{
\item{processed_qf}{a QFeatures object with a SummarizedExperiment named
"peptides_norm".}

\item{reference_variable}{the variable to used as a reference.}

\item{reference_value}{the value of the reference variable to use as
the reference}
}
\value{
a tibble with the t test statistics for each peptide within each
group with the supplied value at the supplied variable as reference.
}
\description{
performs t-tests for each peptide within each group for the user specified.
FDR adjustment is performed.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generate_report.R
\name{generate_report}
\alias{generate_report}
\title{generate_report}
\usage{
generate_report(
  prepared_data,
  peptide_library = mspms::peptide_library,
  n_residues = 4,
  outdir = getwd(),
  output_file = paste0(Sys.Date(), "_mspms_report.html")
)
}
\arguments{
\item{prepared_data}{a QFeatures object containing a SummarizedExperiment
named "peptides".}

\item{peptide_library}{peptide library used with experiment. Contains
columns "library_id", "library_match_sequence", and "library_real_sequence".}

\item{n_residues}{the number of amino acid residues before and after the
cleavage site to generate a cleavage seq for.}

\item{outdir}{the output directory you would like to render the
report to.}

\item{output_file}{the file name to export.}
}
\value{
a knited .html report of the mspms analysis.
}
\description{
wrapper function to generate an automatic .html report of a basic mspms
analysis.
}
\examples{
\dontshow{if (isTRUE(FALSE)) withAutoprint(\{ # examplesIf}
generate_report(mspms::peaks_prepared_data)
\dontshow{\}) # examplesIf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing_helper_functions.R
\name{prepared_to_qf}
\alias{prepared_to_qf}
\title{convert prepared data to a QFeatures object}
\usage{
prepared_to_qf(
  prepared_data,
  colData,
  peptide_library = mspms::peptide_library,
  n_residues = 4
)
}
\arguments{
\item{prepared_data}{data prepared within one of the prepare functions}

\item{colData}{sample metadata}

\item{peptide_library}{the peptide library used.}

\item{n_residues}{the number of residues reported in the cleavage site}
}
\value{
a QFeatures object
}
\description{
convert prepared data to a QFeatures object
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/log2fc_t_test.R
\name{log2fc_t_test}
\alias{log2fc_t_test}
\title{log2fc_t_test}
\usage{
log2fc_t_test(processed_qf, reference_variable = "time", reference_value = 0)
}
\arguments{
\item{processed_qf}{mspms data in a QFeatures object.}

\item{reference_variable}{the colData variable to use as reference}

\item{reference_value}{the value of the colData variable to use as reference}
}
\value{
a tibble containing log2fc and t test statistics
}
\description{
Calculates the log2 fold change and t-test statistics given a user specified
reference variable and value.
}
\examples{
log2fc_and_t_test <- log2fc_t_test(mspms::processed_qf)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing_helper_functions.R
\name{check_file_is_valid}
\alias{check_file_is_valid}
\title{check_file_is_valid}
\usage{
check_file_is_valid(data, expected_names, tool_name)
}
\arguments{
\item{data}{A data frame read into R.}

\item{expected_names}{A character vector of expected column names.}

\item{tool_name}{A short string identifying the originating software
(e.g., "PEAKS", "PD",etc).}
}
\value{
Raises an error (`stop`) with an informative message if required
columns are missing; otherwise returns `invisible(NULL)`.
}
\description{
Validate that an input data frame contains all expected columns.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing_helper_functions.R
\name{cleavage}
\alias{cleavage}
\title{Generalized cleavage function with dynamic column names}
\usage{
cleavage(
  peptide_sequence,
  library_match_sequence,
  library_real_sequence,
  n_residues = 4,
  terminus = c("nterm", "cterm")
)
}
\arguments{
\item{peptide_sequence}{Peptide sequence, single-letter code. "_" denotes cleavage site.}

\item{library_match_sequence}{Sequence matched by proteomics software (may differ from real sequence).}

\item{library_real_sequence}{True peptide sequence.}

\item{n_residues}{Number of residues to include on each side of the cleavage site.}

\item{terminus}{"nterm" or "cterm", specifying which terminus to analyze.}
}
\value{
tibble with peptide, cleavage sequence, and cleavage position. Column names are
dynamically named based on the terminus.
}
\description{
Finds cleavage sequences for either N-terminal or C-terminal cleavages
relative to a peptide library sequence.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_time_course.R
\name{plot_time_course}
\alias{plot_time_course}
\title{plot_time_course}
\usage{
plot_time_course(
  mspms_tidy_data,
  value_colname = "peptides_norm",
  summarize_by_mean = FALSE
)
}
\arguments{
\item{mspms_tidy_data}{tidy mspms data (prepared from QFeatures object
by mspms_tidy())}

\item{value_colname}{the name of the column containing values.}

\item{summarize_by_mean}{whether to summarise by mean (TRUE- show error bars
+- 1 standard deviation) or not (FALSE)}
}
\value{
a ggplot2 object
}
\description{
Easily plot a time course of all peptides in a QFeatures object by
peptide.
}
\examples{
# Determining peptide of interest
max_log2fc_pep <- mspms::log2fc_t_test_data \%>\%
  dplyr::filter(p.adj <= 0.05, log2fc > 3) \%>\%
  dplyr::filter(log2fc == max(log2fc)) \%>\%
  dplyr::pull(peptide)

# Defining QFeatures filter
filtered <- mspms::mspms_tidy_data \%>\%
  dplyr::filter(peptide == max_log2fc_pep) \%>\%
  plot_time_course()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_all_icelogos.R
\name{plot_all_icelogos}
\alias{plot_all_icelogos}
\title{plot_all_icelogos}
\usage{
plot_all_icelogos(
  sig_cleavage_data,
  type = "percent_difference",
  pval = 0.05,
  background_universe = mspms::all_possible_8mers_from_228_library
)
}
\arguments{
\item{sig_cleavage_data}{a tibble of data of interest containing a column
labeled peptide, cleavage_seq, and condition}

\item{type}{this is the type of iceLogo you would like to generate,
can be either "percent_difference" or "fold_change".}

\item{pval}{this is the pvalue threshold (<=) to consider significant when
determining the significance of the sig_cleavages relative to the background
at each position of the iceLogo.}

\item{background_universe}{this is a list cleavages you would like to compare
to as background of the iceLogo}
}
\value{
a ggplot object that shows the motif of the cleavage sequences
}
\description{
Easily plot a iceLogo corresponding to peptides of interest across each
condition of an experiment.
}
\examples{
# Determining cleavages of interest
sig_cleavage_data <- mspms::log2fc_t_test_data \%>\%
  dplyr::filter(p.adj <= 0.05, log2fc > 3)
# Plotting a iceLogo for each condition.
plot_all_icelogos(sig_cleavage_data)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{all_possible_8mers_from_228_library}
\alias{all_possible_8mers_from_228_library}
\title{all_possible_8mers_from_228_library
All possible 8mers from the standard (as of 26April2024)
228 MSP-MS peptide library
(This is equivalent to the result of
mspms::calculate_all_cleavages(mspms::peptide_library$real_cleavage_seq,n=4))
vector of the 14 AA peptides used in the library.}
\format{
## `all_possible_8mers_from_228_library`
A vector with 2964 entries
}
\source{
<standard peptide library used with MSP-MS method
in the O’Donoghue lab as of 26April2024>
}
\usage{
all_possible_8mers_from_228_library
}
\description{
all_possible_8mers_from_228_library
All possible 8mers from the standard (as of 26April2024)
228 MSP-MS peptide library
(This is equivalent to the result of
mspms::calculate_all_cleavages(mspms::peptide_library$real_cleavage_seq,n=4))
vector of the 14 AA peptides used in the library.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/calculate_all_cleavages.R
\name{calculate_all_cleavages}
\alias{calculate_all_cleavages}
\title{calculate_all_cleavages
calculate all possible cleavages for a defined peptide library containing
peptides of the same length.}
\usage{
calculate_all_cleavages(peptide_library_seqs, n_AA_after_cleavage = 4)
}
\arguments{
\item{peptide_library_seqs}{The sequences of each peptide in the peptide
library. They should all be the same length.}

\item{n_AA_after_cleavage}{The number of AA after (and before) the cleavage
site to consider.}
}
\value{
a vector of all the possible cleavages for the peptide library
sequences
}
\description{
calculate_all_cleavages
calculate all possible cleavages for a defined peptide library containing
peptides of the same length.
}
\examples{
calculate_all_cleavages(mspms::peptide_library$library_real_sequence,
  n_AA_after_cleavage = 4
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{processed_qf}
\alias{processed_qf}
\title{processed_qf
A QFeatures object prepared from PEAKS data of Cathepsin data that has been
processed (imputation/normalization)}
\format{
## `peaks_prepared_data`
An instance of class QFeatures containing 5 assays:
[1] peptides: SummarizedExperiment with 2071 rows and 42 columns
[2] peptides_log: SummarizedExperiment with 2071 rows and 42 columns
[3] peptides_log_norm: SummarizedExperiment with 2071 rows and 42 columns
[4] peptides_log_impute_norm: SummarizedExperiment with 2071 rows and 42
columns
[5] peptides_norm: SummarizedExperiment with 2071 rows and 42 columns
\describe{
  \item{peptides}{Peptide Sequence Detected}
  ...
}
}
\source{
<mspms processed data originally from PEAKS files found in
 "tests/testdata/protein-peptides-id.csv" and
 "tests/testdata/protein-peptides-lfq.csv">
}
\usage{
processed_qf
}
\description{
processed_qf
A QFeatures object prepared from PEAKS data of Cathepsin data that has been
processed (imputation/normalization)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_pca.R
\name{plot_pca}
\alias{plot_pca}
\title{plot_pca}
\usage{
plot_pca(
  mspms_tidy_data,
  value_colname = "peptides_norm",
  color = "time",
  shape = "condition"
)
}
\arguments{
\item{mspms_tidy_data}{tidy mspms data (prepared from QFeatures object
by mspms_tidy)}

\item{value_colname}{the name of the column containing values.}

\item{color}{the name of the variable you would like to color by.}

\item{shape}{the name of the variable that you would like to determine
shape by.}
}
\value{
a ggplot2 object
}
\description{
Easily create a PCA plot from a QFeatures object containing mspms data.
Ellipses are drawn around the points at a 95% confidence interval.
Shape and colors are user specified.
}
\examples{
plot_pca(mspms::mspms_tidy_data)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/iceLogo_helper_fuctions.R
\name{calc_sig_zscores}
\alias{calc_sig_zscores}
\title{calc_sig_zscores
Determine which Zscores are significant at the given alpha for a
matrix of scores}
\usage{
calc_sig_zscores(zscores, pval = 0.05)
}
\arguments{
\item{zscores}{= a data frame of zscores}

\item{pval}{= p value threshold for significance. Default is 0.05}
}
\value{
a tibble of significant zscores
}
\description{
calc_sig_zscores
Determine which Zscores are significant at the given alpha for a
matrix of scores
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing_helper_functions.R
\name{add_cleavages}
\alias{add_cleavages}
\title{add_cleavages}
\usage{
add_cleavages(joined_with_library, n_residues = 4)
}
\arguments{
\item{joined_with_library}{a tibble containing columns named "peptide",
"library_match_sequence", and "library_real_sequence".}

\item{n_residues}{the number of residues to the left and right of the
cleavage site to include in the output.}
}
\value{
a tibble with cleavage information added.
}
\description{
Adds cleavage information to a tibble by wraping the n_term_cleavage
and c_term_cleavage functions into a consolidated function.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_cleavages_per_pos.R
\name{plot_cleavages_per_pos}
\alias{plot_cleavages_per_pos}
\title{plot_cleavages_per_pos}
\usage{
plot_cleavages_per_pos(sig_cleavage_data, ncol = NULL)
}
\arguments{
\item{sig_cleavage_data}{a tibble of data of interest containing a column
labeled peptide, cleavage_seq, condition, and cleavage_pos.}

\item{ncol}{the number of columns to plot.}
}
\value{
a ggplot2 object
}
\description{
plot the number of cleavages at each
}
\examples{
# Defining the significant peptides
sig_cleavage_data <- log2fc_t_test_data \%>\%
  dplyr::filter(p.adj <= 0.05, log2fc > 3)
# Plotting
p1 <- mspms::plot_cleavages_per_pos(sig_cleavage_data)
p1
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing_helper_functions.R
\name{check_peptide_library}
\alias{check_peptide_library}
\title{check_peptide_library}
\usage{
check_peptide_library(peptide_library)
}
\arguments{
\item{peptide_library}{}
}
\value{
an informative error if the column names of the peptide library are
unexpected. Otherwise nothing.
}
\description{
check_peptide_library
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/iceLogo_helper_fuctions.R
\name{calc_AA_percent_difference}
\alias{calc_AA_percent_difference}
\title{calc_AA_percent_difference}
\usage{
calc_AA_percent_difference(background_prop_matrix, experimental_prop_matrix)
}
\arguments{
\item{background_prop_matrix}{a proportion matrix of amino acids
per position from background cleavage sequences}

\item{experimental_prop_matrix}{a proportion matrix of amino acids per
position from experimental cleavage sequences}
}
\value{
a data frame of percent differences
}
\description{
Calculate the percent difference between a matrix of background proportions
and a matrix of experimentally observed proportions.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/iceLogo_helper_fuctions.R
\name{calc_AA_motif_zscore}
\alias{calc_AA_motif_zscore}
\title{calc_AA_motif_zscore}
\usage{
calc_AA_motif_zscore(
  background_count_matrix,
  background_prop_matrix,
  experimental_count_matrix,
  experimental_prop_matrix
)
}
\arguments{
\item{background_count_matrix}{the count matrix from the
background sequences}

\item{background_prop_matrix}{the proportion matrix from the
background sequences}

\item{experimental_count_matrix}{the count matrix from the
experimental sequences}

\item{experimental_prop_matrix}{the proportion matrix from the
experimental sequences}
}
\value{
a data frame of Zscores for each amino acid at each position.
}
\description{
Calculate the Z score for the amino acids at each position
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing_helper_functions.R
\name{transform_peaks}
\alias{transform_peaks}
\title{Transform PEAKS LFQ file into standard peptide format}
\usage{
transform_peaks(df, peptide_library, quality_threshold = 0.3)
}
\arguments{
\item{df}{PEAKS LFQ data read in with read_csv}

\item{peptide_library}{peptide library used in the experiment}

\item{quality_threshold}{minimum peptide quality to keep (default 0.3)}
}
\value{
a tibble with columns: peptide, library_id, sample intensities
}
\description{
Transform PEAKS LFQ file into standard peptide format
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/prepare_diann.R
\name{prepare_diann}
\alias{prepare_diann}
\title{prepare_diann}
\usage{
prepare_diann(
  precursor_filepath,
  colData_filepath,
  peptide_library = mspms::peptide_library,
  n_residues = 4
)
}
\arguments{
\item{precursor_filepath}{filepath to report.pr_matrix.tsv file exported
from DIA-NN.}

\item{colData_filepath}{file path to .csv file containing colData.
Must have columns named "quantCols","group","condition",and "time".}

\item{peptide_library}{peptide library used with experiment. Contains
columns "library_id", "library_match_sequence", and "library_real_sequence".}

\item{n_residues}{the number of amino acid residues before and after the
cleavage site to generate a cleavage seq for.}
}
\value{
a QFeatures object.
}
\description{
prepare data from the pr_matrix.tsv diann output. This can be either from
DIA-NN or from Fragpipe (as it uses DIA-NN for quantification internally for
MSFragger-DIA workflows)
}
\examples{
precursor_filepath <- system.file(
  "extdata/diann_report.pr_matrix.tsv",
  package = "mspms"
)
colData_filepath <- system.file("extdata/diann_colData.csv", package = "mspms")
prepare_diann(precursor_filepath, colData_filepath)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/prepare_peaks.R
\name{prepare_peaks}
\alias{prepare_peaks}
\title{Prepare PEAKS label-free quantification data for MSP-MS analysis}
\usage{
prepare_peaks(
  lfq_filepath,
  colData_filepath,
  quality_threshold = 0.3,
  peptide_library = mspms::peptide_library,
  n_residues = 4
)
}
\arguments{
\item{lfq_filepath}{Path to the PEAKS `.csv` file containing peptide-level LFQ data.}

\item{colData_filepath}{Path to a `.csv` file containing sample metadata (`colData`).
Must include the columns `"quantCols"`, `"group"`, `"condition"`, and `"time"`.}

\item{quality_threshold}{Minimum quality score required for a peptide to be retained.
Peptides below this threshold are filtered out (default `0.3`).}

\item{peptide_library}{A peptide library used in the experiment, typically
`mspms::peptide_library`. Must include `"library_id"`, `"library_match_sequence"`,
and `"library_real_sequence"`.}

\item{n_residues}{Number of amino acid residues to include on each side of the
cleavage site when generating cleavage sequences (default `4`).}
}
\value{
A `QFeatures` object containing a `SummarizedExperiment` named `"peptides"`.
}
\description{
This function reads, validates, transforms, and converts a PEAKS
LFQ file into a `QFeatures` object compatible with the `mspms` workflow.
}
\examples{
lfq_filepath <- system.file(
  "extdata/peaks_protein-peptides-lfq.csv",
  package = "mspms"
)
colData_filepath <- system.file(
  "extdata/colData.csv",
  package = "mspms"
)
peaks_qf <- mspms::prepare_peaks(lfq_filepath, colData_filepath)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing_helper_functions.R
\name{prepare_file}
\alias{prepare_file}
\title{Generic preparation function for MSP-MS input files}
\usage{
prepare_file(
  filepath,
  colData_filepath,
  peptide_library = mspms::peptide_library,
  n_residues = 4,
  read_fun,
  validate_fun,
  transform_fun
)
}
\arguments{
\item{filepath}{path to the input file}

\item{colData_filepath}{path to colData CSV}

\item{peptide_library}{peptide library used in experiment}

\item{n_residues}{number of residues to include around cleavage site}

\item{read_fun}{function to read the file (e.g., read_tsv, read_csv, read_delim)}

\item{validate_fun}{function to validate the file (check_file_is_valid_*)}

\item{transform_fun}{function to transform file into standard peptide format}
}
\value{
a QFeatures object
}
\description{
Generic preparation function for MSP-MS input files
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing_helper_functions.R
\name{transform_fragpipe}
\alias{transform_fragpipe}
\title{Transform FragPipe combined_peptide.tsv into standard peptide format}
\usage{
transform_fragpipe(df, peptide_library)
}
\arguments{
\item{df}{FragPipe combined_peptide.tsv read with read_tsv}

\item{peptide_library}{peptide library used in the experiment}
}
\value{
a tibble with columns: peptide, library_id, sample intensities
}
\description{
Transform FragPipe combined_peptide.tsv into standard peptide format
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/iceLogo_helper_fuctions.R
\name{prepare_fc}
\alias{prepare_fc}
\title{prepare_fc}
\usage{
prepare_fc(fold_change, sig_zscores)
}
\arguments{
\item{fold_change}{a matrix of the fold changes of the AA by
position.}

\item{sig_zscores}{a tibble of the significant zscores.}
}
\value{
a matrix of the fold changes of the significant AAs at each position.
}
\description{
Prepare fold changes of amino acids by position for Icelogo visualization.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing_helper_functions.R
\name{check_file_is_valid_pd}
\alias{check_file_is_valid_pd}
\title{check_file_is_valid_pd
Check to make sure the input data looks like the expected ProteomeDiscoverer
file.}
\usage{
check_file_is_valid_pd(pd_data)
}
\arguments{
\item{pd_data}{PeptideGroups.txt file generated by ProteomeDiscover and read
into R.}
}
\value{
a stop command with a informative message if file looks unexpected.
otherwise, nothing.
}
\description{
check_file_is_valid_pd
Check to make sure the input data looks like the expected ProteomeDiscoverer
file.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/statistics_helper_functions.R
\name{remaining_cd_names}
\alias{remaining_cd_names}
\title{remaining_cd_names}
\usage{
remaining_cd_names(processed_qf, reference_variable)
}
\arguments{
\item{processed_qf}{a QFeatures object}

\item{reference_variable}{name of reference variable}
}
\value{
a vector of the remaining names in the colData
}
\description{
determine what the remaining colData names are when removing the reference
variable.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotting_helper_functions.R
\name{count_cleavages_per_pos}
\alias{count_cleavages_per_pos}
\title{count_cleavages_per_pos}
\usage{
count_cleavages_per_pos(data, peptide_library = mspms::peptide_library)
}
\arguments{
\item{data}{a tibble containing columns named peptide, cleavage_pos, condition,
and time. Other column names can be included.}

\item{peptide_library}{a peptide library tibble.}
}
\value{
a tibble with all positions filled.
}
\description{
Count the number of cleavages per position
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_icelogo.R
\name{plot_icelogo}
\alias{plot_icelogo}
\title{plot_icelogo}
\usage{
plot_icelogo(
  cleavage_seqs,
  background_universe = mspms::all_possible_8mers_from_228_library,
  pval = 0.05,
  type = "percent_difference"
)
}
\arguments{
\item{cleavage_seqs}{these are the cleavage sequences of interest}

\item{background_universe}{this is a list of cleavage sequences
to use as the background in building the iceLogo.}

\item{pval}{this is the pvalue threshold (<=) to consider significant when
determining the significance of the sig_cleavages relative to the background
at each position of the iceLogo.}

\item{type}{this is the type of visualization you would like to perform,
accepted values are  either "percent_difference" or "fold_change".}
}
\value{
a ggplot2 object
}
\description{
This function plots the cleavage motifs that were enriched relative to
background as implemented in the iceLogo method.
https://iomics.ugent.be/icelogoserver/resources/manual.pdf
}
\examples{
# Determining significant cleavages for catA
catA_sig_cleavages <- mspms::log2fc_t_test_data \%>\%
  dplyr::filter(p.adj <= 0.05, log2fc > 3) \%>\%
  dplyr::filter(condition == "CatA") \%>\%
  dplyr::pull(cleavage_seq) \%>\%
  unique()

# Plotting icelogo
plot_icelogo(catA_sig_cleavages,
  background_universe = all_possible_8mers_from_228_library
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/statistics_helper_functions.R
\name{calc_limma_design_matrix}
\alias{calc_limma_design_matrix}
\title{calc_limma_design_matrix}
\usage{
calc_limma_design_matrix(colData, norm_data)
}
\arguments{
\item{colData}{colData with condition and time variables as factors}

\item{norm_data}{normalized data from QFeatures object to use}
}
\value{
a model matrix
}
\description{
Calculates a limma compatible design matrix for mspms data.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing_helper_functions.R
\name{consolidate_cleavages}
\alias{consolidate_cleavages}
\title{consolidate_cleavages}
\usage{
consolidate_cleavages(cleavage_added_data)
}
\arguments{
\item{cleavage_added_data}{a tibble where cleavage information has
been added by add_cleavages()}
}
\value{
a tibble with the cleavage information combined into a single column
 and rows with no cleavage information or double information removed.
}
\description{
Consolidate the n term and c term cleavage data. The nterm and cterm
cleavage information  are consolidated into a single column and rows
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotting_helper_functions.R
\name{prepare_qc_check_data}
\alias{prepare_qc_check_data}
\title{prepare_qc_check
Run simple quality control checks on the data. This checks to see how many
peptides belonging to the library were identified in the data in
each sample. Computes full length, and cleavage products independantly.}
\usage{
prepare_qc_check_data(
  processed_qf,
  peptide_library_ids = mspms::peptide_library$library_id
)
}
\arguments{
\item{processed_qf}{a QFeatures object with a SummarizedExperiment named
"peptides". Intended to be prepared by one of the pre-processing
prepare_x_data functions of the mspms R package.}

\item{peptide_library_ids}{a character vector containing the names of the
library_ids}
}
\value{
a tibble containing percentage of library_ids detected per sample,
both as full length, and as cleavage products.
}
\description{
prepare_qc_check
Run simple quality control checks on the data. This checks to see how many
peptides belonging to the library were identified in the data in
each sample. Computes full length, and cleavage products independantly.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/iceLogo_helper_fuctions.R
\name{calc_AA_prop_of_motif}
\alias{calc_AA_prop_of_motif}
\title{calc_AA_prop_of_motif}
\usage{
calc_AA_prop_of_motif(count_matrix)
}
\arguments{
\item{count_matrix}{this is a matrix of the counts of cleavage motifs}
}
\value{
a matrix with proportions of counts.
}
\description{
Calculate the proportion of amino acids at each position in a vector of
motifs.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/statistics_helper_functions.R
\name{calc_limma_contrasts}
\alias{calc_limma_contrasts}
\title{calc_limma_contrasts}
\usage{
calc_limma_contrasts(colData, design_mat)
}
\arguments{
\item{colData}{colData from mspms experiment}

\item{design_mat}{design_mat as returned by calc_limma_design_matrix}
}
\value{
a contrast matrix
}
\description{
Calculates limma contrasts given colData. The contrasts returned are pairwise
relative to T0 for each timepoint assayed.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotting_helper_functions.R
\name{prepare_for_PCA}
\alias{prepare_for_PCA}
\title{prepare_for_PCA()}
\usage{
prepare_for_PCA(mspms_tidy_data, value_colname = "peptides_norm")
}
\arguments{
\item{mspms_tidy_data}{tidy mspms data (prepared from QFeatures object
by mspms_tidy())}

\item{value_colname}{the name of the column containing values.}
}
\value{
a tibble
}
\description{
prepare QFeatures object for PCA analysis
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing_helper_functions.R
\name{check_file_is_valid_sage}
\alias{check_file_is_valid_sage}
\title{check_file_is_valid_sage
Check to make sure the input data looks like the expected PEAKS file.}
\usage{
check_file_is_valid_sage(sage_data)
}
\arguments{
\item{sage_data}{read in lfq.tsv file output prodcued by Sage
into R.}
}
\value{
a stop command with a informative message if file looks unexpected.
otherwise, nothing.
}
\description{
check_file_is_valid_sage
Check to make sure the input data looks like the expected PEAKS file.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing_helper_functions.R
\name{load_colData}
\alias{load_colData}
\title{load_colData}
\usage{
load_colData(colData_filepath)
}
\arguments{
\item{colData_filepath}{filepath to .csv file containing colData.}
}
\value{
a tibble
}
\description{
load a .csv file containing sample colData. Check for errors
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/iceLogo_helper_fuctions.R
\name{prepare_sig_p_dif}
\alias{prepare_sig_p_dif}
\title{prepare_sig_p_dif}
\usage{
prepare_sig_p_dif(percent_difference, sig_zscores)
}
\arguments{
\item{percent_difference}{a data frame containing the percent differences}

\item{sig_zscores}{a matrix of significant amino acids at each position
based on z-scores}
}
\value{
a tibble
}
\description{
Prepare significant percent difference data frame for iceLogo
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing_helper_functions.R
\name{transform_diann}
\alias{transform_diann}
\title{Transform DIA-NN report (pr_matrix.tsv) into standard peptide format}
\usage{
transform_diann(df, peptide_library)
}
\arguments{
\item{df}{DIA-NN pr_matrix.tsv read with read_tsv}

\item{peptide_library}{peptide library used in the experiment}
}
\value{
a tibble with columns: peptide, library_id, sample intensities
}
\description{
Transform DIA-NN report (pr_matrix.tsv) into standard peptide format
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotting_helper_functions.R
\name{calc_per_samples_library_nd}
\alias{calc_per_samples_library_nd}
\title{calc_per_samples_library_nd
Calculate the percentage of samples each library_id peptide was not detected
in.}
\usage{
calc_per_samples_library_nd(
  processed_qf,
  peptide_library_ids = mspms::peptide_library$library_id
)
}
\arguments{
\item{processed_qf}{a QFeatures object with a SummarizedExperiment named
"peptides". Intended to be prepared by one of the pre-processing
prepare_x_data functions of the mspms R package.}

\item{peptide_library_ids}{a character vector containing the names of the
library_ids}
}
\value{
a tibble containing percentage of samples each library id was
detected in,  both as full length, and as cleavage products.
}
\description{
calc_per_samples_library_nd
Calculate the percentage of samples each library_id peptide was not detected
in.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_qc_check.R
\name{plot_qc_check}
\alias{plot_qc_check}
\title{plot_qc_check
plot the the percentage of the peptide library undetected in each sample per
each sample group.}
\usage{
plot_qc_check(
  processed_qf,
  peptide_library = mspms::peptide_library$library_id,
  full_length_threshold = NULL,
  cleavage_product_threshold = NULL,
  ncol = 2
)
}
\arguments{
\item{processed_qf}{QFeatures object containing a SummarizedExperiment
named "peptides"}

\item{peptide_library}{a vector of all peptide library ids in the
experiment.}

\item{full_length_threshold}{percent to use as threshold visualized as a
vertical blue dashed line}

\item{cleavage_product_threshold}{percent to use as a threshold visualized as
a red dashed line}

\item{ncol}{n columns.}
}
\value{
a ggplot2 object.
}
\description{
plot_qc_check
plot the the percentage of the peptide library undetected in each sample per
each sample group.
}
\examples{
plot_qc_check(mspms::processed_qf)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{log2fc_t_test_data}
\alias{log2fc_t_test_data}
\title{log2fc_t_test_data
A tibble containing the results of t-tests and log2fc compared to time 0
14,497 × 19}
\format{
## `peaks_prepared_data`
A tibble: 14,497 × 19
}
\source{
<mspms processed data originally from PEAKS files found in
 "tests/testdata/protein-peptides-id.csv" and
 "tests/testdata/protein-peptides-lfq.csv">
}
\usage{
log2fc_t_test_data
}
\description{
log2fc_t_test_data
A tibble containing the results of t-tests and log2fc compared to time 0
14,497 × 19
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/iceLogo_helper_fuctions.R
\name{prepare_icelogo_data}
\alias{prepare_icelogo_data}
\title{prepare_icelogo_data}
\usage{
prepare_icelogo_data(
  cleavage_seqs,
  background_universe = mspms::all_possible_8mers_from_228_library,
  pval = 0.05,
  type = "percent_difference"
)
}
\arguments{
\item{cleavage_seqs}{the cleavage sequences that are observed in the
experiment}

\item{background_universe}{a vector of the cleavage sequences to use as
the background.}

\item{pval}{the p-value threshold to consdier}

\item{type}{the type of iceLogo calculation to perform. Accepted values are
"percent_difference" or "fold_change".}
}
\value{
a matrix of enriched amino acids per position
}
\description{
Prepare the final matrix containing iceLogo data for plotting.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_heatmap.R
\name{plot_heatmap}
\alias{plot_heatmap}
\title{plot_heatmap}
\usage{
plot_heatmap(
  mspms_tidy_data,
  value_colname = "peptides_norm",
  scale = "column",
  plot_method = "plotly",
  show_dendrogram = c(TRUE, TRUE)
)
}
\arguments{
\item{mspms_tidy_data}{tidy mspms data (prepared from QFeatures object
by mspms_tidy())}

\item{value_colname}{the name of the column containing values.}

\item{scale}{how would you like the data scaled? default is none,
but can also be "row", "column", or "none"}

\item{plot_method}{what plot method would you like to use, can use
plotly or ggplot2.}

\item{show_dendrogram}{Logical vector of length two, controlling whether
the row and/or column dendrograms are displayed. If a logical scalar is
provided, it is repeated to become a logical vector of length two.}
}
\value{
a heatmaply interactive heatmap
}
\description{
This produces a heatmaply interactive heatmap of the QFeatures object with
color bars representing the condition and time for each sample in each row.
}
\details{
Each column has a colored bar representing whether the peptide is a
cleavage product or a full length member of the peptide library.
}
\examples{
plot_heatmap(mspms::mspms_tidy_data)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{colData}
\alias{colData}
\title{colData
A tibble containing the colData associated with an experiment to proc}
\format{
## `colData`
A tibble: 42 × 4
}
\source{
colData corresponding to cathepsin A-D MSP-MS experiment
}
\usage{
colData
}
\description{
colData
A tibble containing the colData associated with an experiment to proc
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_volcano.R
\name{plot_volcano}
\alias{plot_volcano}
\title{plot_volcano}
\usage{
plot_volcano(
  log2fc_t_test_data,
  log2fc_threshold = 3,
  padj_threshold = 0.05,
  facets = "grid",
  ncol = 1
)
}
\arguments{
\item{log2fc_t_test_data}{a tibble containing the log2fc
and adjusted p values}

\item{log2fc_threshold}{the log2fc threshold that you want displayed on plot}

\item{padj_threshold}{the padj threshold that you want displayed on plot}

\item{facets}{how facets should be displayed. Accepted values are grid and
wrap}

\item{ncol}{ncol to include if facets = "wrap"}
}
\value{
a ggplot2 object
}
\description{
create a volcano plot to generate log2fc and adjusted p values for
experimental conditions
}
\examples{
p1 <- mspms::plot_volcano(mspms::log2fc_t_test_data, log2fc_threshold = 3)
p1
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing_helper_functions.R
\name{cterm_cleavage}
\alias{cterm_cleavage}
\title{C-terminal cleavage sequence extraction}
\usage{
cterm_cleavage(...)
}
\value{
A tibble with columns:
  - `peptide`: the input peptide sequence
  - `cterm`: the C-terminal cleavage sequence (n residues on each side)
  - `cterm_cleavage_pos`: the position of the C-terminal cleavage in the library sequence
}
\description{
Wrapper for `cleavage()` that extracts the C-terminal cleavage sequence
and cleavage position from a peptide relative to its library sequence.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{mspms_tidy_data}
\alias{mspms_tidy_data}
\title{mspms_tidy_data
A tibble containing tidy data derived from QFeatures object}
\format{
## `mspms_tidy_data`
A tibble:
}
\source{
processed_qf
}
\usage{
mspms_tidy_data
}
\description{
mspms_tidy_data
A tibble containing tidy data derived from QFeatures object
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mspms_tidy.R
\name{mspms_tidy}
\alias{mspms_tidy}
\title{mspms_tidy
Convert a SummarizedExperiment object within a QFeatures object
into a tidy tibble.}
\usage{
mspms_tidy(processed_qf, se_name = "peptides_norm")
}
\arguments{
\item{processed_qf}{a QFeature object containing rowData and colData.}

\item{se_name}{the name of the SummarizedExperiment you would like to
extract}
}
\value{
a tibble containing all the rowData, colData, and assay data for the
specified SummarizedExperiment.
}
\description{
mspms_tidy
Convert a SummarizedExperiment object within a QFeatures object
into a tidy tibble.
}
\examples{
mspms_data <- mspms_tidy(mspms::processed_qf)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/statistics_helper_functions.R
\name{mspms_log2fc}
\alias{mspms_log2fc}
\title{mspms_log2fc}
\usage{
mspms_log2fc(processed_qf, reference_variable = "time", reference_value = 0)
}
\arguments{
\item{processed_qf}{a QFeatures object with a SummarizedExperiment named
"peptides_norm".}

\item{reference_variable}{the variable to used as a reference (denominator
of log2 fold change).}

\item{reference_value}{the value of the reference variable to use as
the reference}
}
\value{
a tibble with the t test statistics for each peptide within each
group with the supplied value at the supplied variable as reference.
}
\description{
calculates the log2fc for each time point within each condition relative to
a specified value for a specified reference variable.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{peptide_library}
\alias{peptide_library}
\title{peptide_library}
\format{
## `peptide_library`
A  data frame with 228 rows and 3 columns:
\describe{
  \item{library_reference_id}{reference id of the detected peptide as
  put in upstream software}
  \item{library_match_sequence}{the sequence match to the peptide library,
   methionine is replaced with norleucine,which should function the same as
    methionine for proteases but has the same mass as L}
  \item{library_real_sequence}{Ls corresponding to norleucine are replaced
   back with n (for norleucine )}
  ...
}
}
\source{
<O’Donoghue lab as of 26April2024 >
}
\usage{
peptide_library
}
\description{
This is the 228 peptide library used by the O’Donoghue lab as of 26April2024.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/process_qf.R
\name{process_qf}
\alias{process_qf}
\title{process_qf}
\usage{
process_qf(prepared_qf)
}
\arguments{
\item{prepared_qf}{this is a QFeatures object containing a
SummarizedExperiment named "peptides"}
}
\value{
a QFeatures object containing a
SummarizedExperiments named "peptides","peptides_log","peptides_log_norm",
"peptides_log_impute_norm",and "peptides_norm"
}
\description{
process_qf
}
\examples{
processed_qf <- process_qf(mspms::peaks_prepared_data)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{peaks_prepared_data}
\alias{peaks_prepared_data}
\title{peaks_prepared_data
A QFeatures object prepared from PEAKS data of cathepsin data/.}
\format{
## `peaks_prepared_data`
An instance of class QFeatures containing 1 assays:
[1] peptides: SummarizedExperiment with 2071 rows and 42 columns
\describe{
  \item{peptides}{Peptide Sequence Detected}
  ...
}
}
\source{
<mspms processed data originally from PEAKS files found in
 "tests/testdata/protein-peptides-id.csv" and
 "tests/testdata/protein-peptides-lfq.csv">
}
\usage{
peaks_prepared_data
}
\description{
peaks_prepared_data
A QFeatures object prepared from PEAKS data of cathepsin data/.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/limma_stats.R
\name{limma_stats}
\alias{limma_stats}
\title{limma_stats}
\usage{
limma_stats(processed_qf)
}
\arguments{
\item{processed_qf}{mspms data in a QFeatures object.}
}
\value{
a tibble containing statistics
}
\description{
Calculates statistics for each condition relative to time 0 using limma for
differential analysis. Results are then formatted to be consistent with
results produced by other statistic approaches used in the mspms package
(log2fc_t_test).
}
\examples{
mspms_limma_results <- limma_stats(mspms::processed_qf)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/prepare_fragpipe.R
\name{prepare_fragpipe}
\alias{prepare_fragpipe}
\title{prepare_fragpipe}
\usage{
prepare_fragpipe(
  combined_peptide_filepath,
  colData_filepath,
  peptide_library = mspms::peptide_library,
  n_residues = 4
)
}
\arguments{
\item{combined_peptide_filepath}{file path the combined_peptide.tsv file
generated by FragPipe.}

\item{colData_filepath}{file path to .csv file containing colData.
Must have columns named "quantCols","group","condition",and "time".}

\item{peptide_library}{peptide library used with experiment. Contains
columns "library_id", "library_match_sequence", and "library_real_sequence".}

\item{n_residues}{the number of amino acid residues before and after the
cleavage site to generate a cleavage seq for.}
}
\value{
a QFeatures object containing a summarizedExperiment named "peptides"
}
\description{
Prepare a label free quantification file exported from Fragpipe
for subsequent mspms analysis.
}
\examples{
fragpipe_combined_peptide <- system.file("extdata/fragpipe_combined_peptide.tsv", package = "mspms")
colData_filepath <- system.file("extdata/colData.csv", package = "mspms")
# Prepare the data
fragpipe_prepared_data <- mspms::prepare_fragpipe(fragpipe_combined_peptide, colData_filepath)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/processing_helper_functions.R
\name{rlog2}
\alias{rlog2}
\title{rlog2
Reverse log2 transformation}
\usage{
rlog2(x)
}
\arguments{
\item{x}{a numeric value}
}
\value{
a reverse log2 transformed value
}
\description{
rlog2
Reverse log2 transformation
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_nd_peptides.R
\name{plot_nd_peptides}
\alias{plot_nd_peptides}
\title{plot_nd_peptides}
\usage{
plot_nd_peptides(
  processed_qf,
  peptide_library_ids = mspms::peptide_library$library_id
)
}
\arguments{
\item{processed_qf}{a QFeatures object containing a SummarizedExperiment
named "peptides"}

\item{peptide_library_ids}{a vector of all peptide library ids in the
experiment.}
}
\value{
a ggplot2 object
}
\description{
plot the percentage of samples each peptide from library was undetected in
(if the percentage is > 0).
}
\examples{
plot_nd_peptides(mspms::processed_qf)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotting_helper_functions.R
\name{icelogo_col_scheme}
\alias{icelogo_col_scheme}
\title{icelogo_col_scheme
Defining a color scheme for our iceLogos}
\usage{
icelogo_col_scheme()
}
\value{
a ggseqlogo color scheme function
}
\description{
icelogo_col_scheme
Defining a color scheme for our iceLogos
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/statistics_helper_functions.R
\name{add_peptide_data}
\alias{add_peptide_data}
\title{add_peptide_data}
\usage{
add_peptide_data(tibble, qf)
}
\arguments{
\item{tibble}{tibble you would like to add peptide info to. Must have column
named peptide}

\item{qf}{a QFeatures object with rowData for peptides. cleavage_seq,
cleavage_pos, and cleavage_type.}
}
\value{
a tibble with column named peptide.
}
\description{
adds peptide information for every peptide in the data.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mspms-package.R
\docType{package}
\name{mspms-package}
\alias{mspms}
\alias{mspms-package}
\title{mspms: Tools for the analysis of MSP-MS data}
\description{
\if{html}{\figure{logo.png}{options: style='float: right' alt='logo' width='120'}}

This package provides functions for the analysis of data generated by the multiplex substrate profiling by mass spectrometry for proteases (MSP-MS) method. Data exported from upstream proteomics software is accepted as input and subsequently processed for analysis. Tools for statistical analysis, visualization, and interpretation of the data are provided.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/baynec2/mspms}
  \item Report bugs at \url{https://github.com/baynec2/mspms/issues}
}

}
\author{
\strong{Maintainer}: Charlie Bayne \email{baynec2@gmail.com} (\href{https://orcid.org/0000-0003-1870-5298}{ORCID})

}
\keyword{internal}
